#if !defined(AFX_ANALYSEVIEW_H__300470D6_41AA_4459_AB81_143DC11A523F__INCLUDED_)
#define AFX_ANALYSEVIEW_H__300470D6_41AA_4459_AB81_143DC11A523F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// AnalyseView.h : Header-Datei
//

/////////////////////////////////////////////////////////////////////////////
// Ansicht CAnalyseView 

#define MAXNUMVERTICES 16384
#define MAXDIMENSION 20

class CAnalyseView : public CView
{
protected:
	CAnalyseView();           // Dynamische Erstellung verwendet geschtzten Konstruktor
	DECLARE_DYNCREATE(CAnalyseView)

// Attribute
protected:

	//Variablen fr Eingabedialog
	INT																		m_Tau;
	INT																		m_NumPoints;
	INT																		m_MaxDim;			/* Maximale embedding dimension     */
	INT																		m_Dim;				/* gewhlte embedding  dimension            */
	INT																		m_NumberOf;
	INT																		m_Iter;
	DOUBLE																m_RadiusMin;
	DOUBLE																m_RadiusMax;

	//Variablen fr Spektrum
	double**															m_LyaSpektrum;
	INT																		m_LyaSpektrumLaenge;
	INT																		m_DimLya;
	INT																		m_TauLya;
	INT																		m_NumberOfLya;
	INT																		m_IterLya;
	INT																		m_NumPointsLya;
	INT																		m_MaxDimLya;
	DOUBLE																m_RadiusMinLya;
	double																m_KaplanYorkeDimension;

	//Variablen fr Maximalen Exponenten
	double**															m_LyaMax;
	INT																		m_LyaMaxLaenge;
	INT																		m_NumPointsLyaMax;
	INT																		m_IterLyaMax;
	INT																		m_NumberOfLyaMax;
	INT																		m_TauLyaMax;
	DOUBLE																m_RadiusMinLyaMax;
	DOUBLE																m_RadiusMaxLyaMax;
	int																		m_IterationenDoneMaxLya;
	int																		m_EpsilonsDoneMaxLya;
	int																		m_MinDimDoneMaxLya;
	int																		m_MaxDimDoneMaxLya;
	CString																m_MaxLyapSteigung;
	double																m_FaktorXMaxLya;
	double																m_FaktorYMaxLya;
	INT																		m_ReferenzLyaMax;

	//Variablen fr Korrelationsdimension
	INT																		m_DimKorr;
	INT																		m_NumPointsKorr;
	INT																		m_NumberOfKorr;
	INT																		m_TauKorr;
	DOUBLE																m_RadiusMinKorr;
	DOUBLE																m_RadiusMaxKorr;
	INT																		m_MaxDimKorr;
	INT																		m_IterKorr;

	CAnalyseFrame*												m_pParentAnalyseFrame;
	INT																		m_WhatIs;

	double*																m_KorrDim;
	double***															m_KorrDimWerte;

	INT																		m_KorrDimLaengeI;
	INT																		m_KorrDimLaengeII;
	INT																		m_KorrDim_LastMaxDim;
	INT																		m_KorrDim_LastNumberOf;

	BOOL																	m_bIsMaxiLyaData;
	BOOL																	m_bIsSpektrumLyaData;
	BOOL																	m_bIsKorrData;

	
	double																m_XWert1;
	double																m_XWert2;
	double																m_YWert1;
	double																m_YWert2;
	double																m_TopYPlus;
	double																m_TopYMinus;
	POINT																	m_Marker1;
	POINT																	m_Marker2;
	POINT																	m_Nullpunkt;

	POINT																	m_DownMousePoint;
	POINT																	m_MoveMousePoint;
	POINT																	m_UpMousePoint;

	INT																		m_Choose;
	INT																		m_Choose2;

#ifdef _DEBUG
    CMemoryState oldMemState, newMemState, diffMemState;
#endif

// Operationen
public:
		void		IniFileWrite();
		void		IniFileRead();

// berschreibungen
	// Vom Klassen-Assistenten generierte virtuelle Funktionsberschreibungen
	//{{AFX_VIRTUAL(CAnalyseView)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void OnDraw(CDC* pDC);      // berschrieben zum Zeichnen dieser Ansicht
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementierung
protected:
	virtual ~CAnalyseView();
//	void GetNewPoints();
//	void BerechneKorrelationsintegral(INT Dimension);
//	void BerechneLyapunov(INT Dimension);
//	void DrawKorrelationsdimension(CDC* pDC);
// 	void DrawLyapunovExponent(CDC* pDC);
//	FLOAT Abstand(INT Vektor1Nr,INT Vektor2Nr, INT Dimension);
//	void readfile(char* filename,int window,int* num_of_points,int m,double* MAX_VAL,double** data_array,int skip);
	void ReadData(int* window,int* num_of_points,int* m,double* MAX_VAL,double** data_array,int skip);
	DOUBLE Abstand(double** DATA, INT Vektor1Nr, INT Vektor2Nr, INT Dimension);
	DOUBLE BerechnePunktweiseDimension(double** DATA, double* MAX_VAL, int GlobDim,int NumOfPoints,double Radius);
	void BerechneKorrelationsdimension(CDC* pDC);
	void BerechneLyapunovSpektrum(CDC* pDC);
	void BerechneLyapunovMax(CDC* pDC);
	void ZeichneLyapunovMax(CDC* pDC);
	void ZeichneLyapunovSpektrum(CDC* pDC);
	void ZeichneKorrelationsdimension(CDC* pDC);
//	void ZeichneKorrelationsdimension(CDC* pDC,int AktuelleDimension);
	int IsAtMarkerLine(POINT* ppoint);
	CString Double2String(DOUBLE dblWert);

  inline CSoundsDoc* GetDocument() { return (CSoundsDoc*)m_pDocument; }

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generierte Nachrichtenzuordnungsfunktionen
protected:
	//{{AFX_MSG(CAnalyseView)
	afx_msg void OnCheckKorr();
	afx_msg void OnCalculate();
	afx_msg void OnEditCopy();
	afx_msg void OnSave();
	afx_msg void OnCheckMaxlya();
	afx_msg void OnCheckSpeclya();
	afx_msg void OnChangeDimFeld();
	afx_msg void OnChangeDimMax();
	afx_msg void OnChangeIterFeld();
	afx_msg void OnChangeNumberofFeld();
	afx_msg void OnChangeRadiusMaxFeld();
	afx_msg void OnChangeRadiusMinFeld();
	afx_msg void OnChangeTauFeld();
	afx_msg void OnChangePunkteFeld();
	afx_msg void OnCls();
	afx_msg void OnReleasedcaptureDimSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnReleasedcaptureIterSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnReleasedcaptureNumberofSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnReleasedcapturePunkteSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnReleasedcaptureTauSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnReleasedcaptureReferenzSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnChangeReferenzFeld();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // AFX_ANALYSEVIEW_H__300470D6_41AA_4459_AB81_143DC11A523F__INCLUDED_
