//-----------------------------------------------------------------------------
// 
// Desc: Aufruf der FFT 
//       
//-----------------------------------------------------------------------------
#define MAX_NUM_KORRFUNCS 10

VOID CSoundsDoc::DoFFT(int FFTPoints)
{
	//Initialisierung der FFT Objekte
	FFTReal FFTObjekt(FFTPoints);
	DblFFTPts	* const Amplitude = new DblFFTPts [FFTPoints];
	DblFFTPts	* const	Frequenz = new DblFFTPts [FFTPoints];

	CArray<DOUBLE,DOUBLE> ZeitreiheGross;
	INT i=0;
	ZeitreiheGross.Copy(m_ZeitreiheArray);
	INT SizeArray=ZeitreiheGross.GetSize();
	if (SizeArray<FFTPoints) 
	{
		while (i<(FFTPoints-SizeArray))
		{
			ZeitreiheGross.Add(0);
			i++;
		}
	}

	// Filedaten schreiben
//	FILE *FileStream;
//	FileStream=fopen("C:\\Dumps\\FFT.txt","w");

	//Durchfhren der FFT
	FFTObjekt.do_fft(Frequenz,ZeitreiheGross.GetData());
	FFTObjekt.rescale(Frequenz);
	m_FrequenzenArray.RemoveAll();
	m_FrequenzenArray.SetSize(FFTPoints/2+1);
	for (i = 0; i <= FFTPoints/2; i ++)
	{
		double			img;
		const double	real = Frequenz [i];
		if (i > 0 && i < FFTPoints/2)
			img = Frequenz [i + FFTPoints/2];
		else
			img = 0;
		const double	f_abs = sqrt (real * real + img * img);
		m_FrequenzenArray[i]=f_abs;
//		fprintf (FileStream,"%5d %+12.6f %+12.6f %12.6f\n", i, real, img, f_abs);
	}

/*	if ((m_pViewZeitreihe!=NULL)&&(*theApp.GetIniZeitreiheWhatIs()==1)) 
	{
		CalcAllAutoKorrelationFunctions(FFTPoints,MAX_NUM_KORRFUNCS,&m_ZeitreiheArray)
	}
*/
	//	fclose(FileStream);
	delete [] Amplitude;
	delete [] Frequenz;
}

void CSoundsDoc::CalcAllAutoKorrelationFunctions(int NumOfFuncs)
{
	int FFTPoints=m_NumFFTPoints;
	//Initialisierung der FFT Objekte
	FFTReal FFTObjekt(FFTPoints);
	DblFFTPts	* const Amplitude = new DblFFTPts [FFTPoints];
	DblFFTPts	* const	Frequenz = new DblFFTPts [FFTPoints];

	//Zeitreihendaten notfalls auf FFTGre durch Nullen ergnzen
	CArray<DOUBLE,DOUBLE> ZeitreiheGross;
	INT i=0;
	ZeitreiheGross.Copy(m_ZeitreiheArray);
	INT SizeArray=ZeitreiheGross.GetSize();
	if (SizeArray<FFTPoints) 
	{
		while (i<(FFTPoints-SizeArray))
		{
			ZeitreiheGross.Add(0);
			i++;
		}
	}

	//Durchfhren der FFT
	FFTObjekt.do_fft(Frequenz,ZeitreiheGross.GetData());
	FFTObjekt.rescale(Frequenz);

	//Erste Autokorrelationsfunktion berechnen
	CalcAutoKorrelationFunction(FFTPoints,&FFTObjekt,Frequenz,Amplitude,m_AutoKorrArray.GetAt(0));
	i=0;

	//Nullstellen bzw. erstes Minimum ermitteln
	while (Amplitude[i]>0) 
	{
		if (Amplitude[i]<Amplitude[i+1])
		{
			m_FirstNullstelleAutokorr=i;
			break;
		}
		m_FirstNullstelleAutokorr=i;
		i++;
	}

	//weitere Autokorrelationskunktionen nach Anzahl berechnen
	if (NumOfFuncs>MAX_NUM_KORRFUNCS) NumOfFuncs=MAX_NUM_KORRFUNCS;
	for (i=0;i<NumOfFuncs;i++)
	{
		FFTObjekt.do_fft(Frequenz,m_AutoKorrArray.GetAt(i)->GetData());
		FFTObjekt.rescale(Frequenz);
		m_FrequenzenArray.RemoveAll();
		m_FrequenzenArray.SetSize(FFTPoints/2+1);
		for (int j = 0; j <= FFTPoints/2; j ++)
		{
			double			img;
			const double	real = Frequenz [j];
			if (j > 0 && j < FFTPoints/2)
				img = Frequenz [j + FFTPoints/2];
			else
				img = 0;
				const double	f_abs = sqrt (real * real + img * img);
			m_FrequenzenArray[j]=f_abs;
		}
		//Autokorrelationsfunktion berechnen
		CalcAutoKorrelationFunction(FFTPoints,&FFTObjekt,Frequenz,Amplitude,m_AutoKorrArray.GetAt(i+1));
	}
	delete [] Amplitude;
	delete [] Frequenz;
}

void CSoundsDoc::CalcAutoKorrelationFunction(int FFTPoints,FFTReal* FFTObjekt,
																						 DblFFTPts* const Frequenz,
																						 DblFFTPts* const Amplitude,
																						 CArray<DOUBLE,DOUBLE>* pArrayAutokorr)
{
	//Autokorrelationsfunktion berechnen
	//Real- und Imaginranteil der Frequenzen quadrieren
	for (INT i=0;i<FFTPoints; i++)
	{
		Frequenz[i]=pow(Frequenz[i],2);
	}
	
	//quadrierte Real- und Imaginrteile addieren und in Realteil schreiben, d.h. reelles Leistungsspektrum ermitteln
	for (i=0;i<FFTPoints/2; i++)
	{
		Frequenz[i]=Frequenz[i]+Frequenz[i+FFTPoints/2];
	}

	//Imaginrteil bei Leistungsspektrum ist Null
	for (i=FFTPoints/2;i<FFTPoints; i++)
	{
		Frequenz[i]=0;
	}

	//Inverse Fouriertransformation durchfhren 
	FFTObjekt->do_ifft(Frequenz,Amplitude);
	FFTObjekt->rescale(Amplitude);
	pArrayAutokorr->RemoveAll();
	pArrayAutokorr->SetSize(FFTPoints);
	for (i=0;i<FFTPoints; i++)
	{
		pArrayAutokorr->SetAt(i,Amplitude[i]);
	}
}

BOOL CSoundsDoc::DoFFTAtPoint(CArray<DOUBLE,DOUBLE>* pZeitreihe, int Start, int FFTPoints, CArray<DOUBLE,DOUBLE>* pFrequenzen)
{
	//Initialisierung der FFT Objekte
	FFTReal FFTObjekt(FFTPoints);
	DblFFTPts	* const	Amplitude = new DblFFTPts [FFTPoints];
	DblFFTPts	* const	Frequenz = new DblFFTPts [FFTPoints];

	INT i=0;
	INT SizeArray=pZeitreihe->GetSize();
	if (SizeArray<FFTPoints) 
	{
		return FALSE;
	}
	
	for( DWORD cT = 0; cT < (DWORD)FFTPoints; cT++ )
		Amplitude[cT] = pZeitreihe->GetAt(Start+cT);

	// Filedaten schreiben
//	FILE *FileStream;
//	FileStream=fopen("e:\\Studium\\Examen\\C++\\FFT.txt","w");

	//Durchfhren der FFT
	FFTObjekt.do_fft(Frequenz,Amplitude);
	FFTObjekt.rescale(Frequenz);
	pFrequenzen->RemoveAll();
	pFrequenzen->SetSize(FFTPoints/2+1);
	for (i = 0; i <= FFTPoints/2; i ++)
	{
		double			img;
		const double	real = Frequenz [i];
		if (i > 0 && i < FFTPoints/2)
			img = Frequenz [i + FFTPoints/2];
		else
			img = 0;
		const double	f_abs = sqrt (real * real + img * img);
		pFrequenzen->SetAt(i,f_abs);
//		pFrequenzen->Add(f_abs);
//		fprintf (FileStream,"%5d %+12.6f %+12.6f %12.6f\n", i, real, img, f_abs);
	}
//	fclose(FileStream);
	delete [] Amplitude;
	delete [] Frequenz;
	return TRUE;
}


