// FFT3DView.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Sounds.h"
#include "FFT3DView.h"
#include "GrafikDeviceDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define MAX(a,b)        ( (a) > (b) ? (a) : (b) )
#define MAX_NUM_VERTICES_MESH 40000

/////////////////////////////////////////////////////////////////////////////
// CFFT3DView

IMPLEMENT_DYNCREATE(CFFT3DView, CView)

CFFT3DView::CFFT3DView()
{
	m_pMesh1=NULL;
	m_pVerticesMeshKopie=NULL;
	INT Items=AfxGetMainWnd()->GetMenu()->GetMenuItemCount();
	AfxGetMainWnd()->GetMenu()->GetSubMenu(Items>5?5:3)->AppendMenu(MF_STRING|MF_ENABLED,ID_FENSTER_FFT3D,"3D-FFT");
	AfxGetMainWnd()->DrawMenuBar();
}

void CFFT3DView::IniFileWrite()
{
	//Inifile Werte schreiben
	*theApp.GetIni3DFFTSchrittweite()=m_Schrittweite;
	*theApp.GetIni3DFFTclrBackBuffer()=m_clrBackBuffer;
	*theApp.GetIni3DFFTBottomCutHz()=m_BottomCutHz;
	*theApp.GetIni3DFFTTopCutkHz()=m_TopCutkHz;
	*theApp.GetIni3DFFTSizePts()=m_SizePts;
	*theApp.GetIni3DFFTbIsWire()=m_bIsWire;
	*theApp.GetIni3DFFTBreite()=m_Breite;
	*theApp.GetIni3DFFTEpsilon()=m_Epsilon;
	*theApp.GetIni3DFFTTau()=m_Tau;
	*theApp.GetIni3DFFTbIsBunt()=m_bIsBunt;
	*theApp.GetIni3DFFTbIsAmpLinear()=m_bIsAmpLinear;
	*theApp.GetIni3DFFTbIsFreqLinear()=m_bIsFreqLinear;
}

void CFFT3DView::IniFileRead()
{
	//Inifile Werte einlesen
	m_Schrittweite	=	*theApp.GetIni3DFFTSchrittweite();
	m_clrBackBuffer	=	*theApp.GetIni3DFFTclrBackBuffer();
	m_BottomCutHz		=	*theApp.GetIni3DFFTBottomCutHz();
	m_TopCutkHz			= *theApp.GetIni3DFFTTopCutkHz();
	m_SizePts				= *theApp.GetIni3DFFTSizePts();
	m_bIsWire				= *theApp.GetIni3DFFTbIsWire();
	m_Breite				=	*theApp.GetIni3DFFTBreite();
	m_Epsilon				=	*theApp.GetIni3DFFTEpsilon();
	m_Tau						= *theApp.GetIni3DFFTTau();
	m_bIsBunt				= *theApp.GetIni3DFFTbIsBunt();
	m_bIsAmpLinear	= *theApp.GetIni3DFFTbIsAmpLinear();
	m_bIsFreqLinear	= *theApp.GetIni3DFFTbIsFreqLinear();
}

CFFT3DView::~CFFT3DView()
{
	IniFileWrite();
	Cleanup3DEnvironment();
	INT Items=AfxGetMainWnd()->GetMenu()->GetMenuItemCount();
	AfxGetMainWnd()->GetMenu()->GetSubMenu(Items>5?5:3)->RemoveMenu(ID_FENSTER_FFT3D,MF_BYCOMMAND);
	AfxGetMainWnd()->DrawMenuBar();
	CSoundsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->m_pViewFFT3D=NULL;
	if (m_pVerticesMeshKopie!=NULL) 
	{
		delete [] m_pVerticesMeshKopie;
	}
}


BEGIN_MESSAGE_MAP(CFFT3DView, CView)
	//{{AFX_MSG_MAP(CFFT3DView)
	ON_WM_SIZE()
	ON_WM_KEYDOWN()
	ON_WM_KEYUP()
	ON_COMMAND(IDM_TOGGLEHELP, OnTogglehelp)
	ON_COMMAND(IDM_TOGGLESTART, OnTogglestart)
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_COMMAND(IDM_SINGLESTEP, OnSinglestep)
	ON_COMMAND(IDM_CHANGEDEVICE, OnChangedevice)
	ON_WM_MOUSEWHEEL()
	ON_BN_CLICKED(IDC_FARBWAHL, OnFarbwahl)
	ON_BN_CLICKED(IDC_FESTEFARBE, OnFestefarbe)
	ON_BN_CLICKED(IDC_BUNT, OnBunt)
	ON_BN_CLICKED(IDC_BUTTON_DREHXL, OnButtonDrehxl)
	ON_BN_CLICKED(IDC_BUTTON_DREHXR, OnButtonDrehxr)
	ON_BN_CLICKED(IDC_BUTTON_DREHYL, OnButtonDrehyl)
	ON_BN_CLICKED(IDC_BUTTON_DREHYR, OnButtonDrehyr)
	ON_BN_CLICKED(IDC_BUTTON_DREHZL, OnButtonDrehzl)
	ON_BN_CLICKED(IDC_BUTTON_DREHZR, OnButtonDrehzr)
	ON_COMMAND(ID_SAVE, OnSave)
	ON_BN_CLICKED(IDC_FACES, OnFaces)
	ON_BN_CLICKED(IDC_WIRE, OnWire)
	ON_EN_CHANGE(IDC_EPSILON_FELD2, OnChangeEpsilonFeld)
	ON_BN_CLICKED(IDC_SCALE_AMP_LIN, OnScaleAmpLin)
	ON_BN_CLICKED(IDC_SCALE_AMP_LOG, OnScaleAmpLog)
	ON_BN_CLICKED(IDC_SCALE_FREQ_LIN, OnScaleFreqLin)
	ON_BN_CLICKED(IDC_SCALE_FREQ_LOG, OnScaleFreqLog)
	ON_COMMAND(ID_EDIT_CLEARALL, OnEditClearall)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_BN_CLICKED(IDC_BKGCLR, OnBkgclr)
	ON_BN_CLICKED(IDC_BUTTON_TRANSXL, OnButtonTransxl)
	ON_BN_CLICKED(IDC_BUTTON_TRANSXR, OnButtonTransxr)
	ON_BN_CLICKED(IDC_BUTTON_TRANSYL, OnButtonTransyl)
	ON_BN_CLICKED(IDC_BUTTON_TRANSYR, OnButtonTransyr)
	ON_BN_CLICKED(IDC_BUTTON_TRANSZL, OnButtonTranszl)
	ON_BN_CLICKED(IDC_BUTTON_TRANSZR, OnButtonTranszr)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_BREITE_SLIDER, OnReleasedcaptureBreiteSlider)
	ON_EN_CHANGE(IDC_BOTTOMCUT_FELD, OnChangeBottomcutFeld)
	ON_EN_CHANGE(IDC_TOPCUT_FELD, OnChangeTopcutFeld)
	ON_WM_RBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONUP()
	ON_WM_HELPINFO()
	ON_BN_CLICKED(IDC_RESETVIEW, OnResetview)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Zeichnung CFFT3DView 

void CFFT3DView::OnDraw(CDC* pDC)
{
  // Handle paint messages when the app is not ready
  if( m_pd3dDevice)// && !m_bReady )
    {
    if( m_bWindowed )
			{
				Render3DEnvironment();
      }
    }
}

/////////////////////////////////////////////////////////////////////////////
// Diagnose CFFT3DView

#ifdef _DEBUG
void CFFT3DView::AssertValid() const
{
	CView::AssertValid();
}

void CFFT3DView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CFFT3DView 

void CFFT3DView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();
	
	if (*theApp.GetIniAllgemeinGrundschulprofil())
	{
		CSoundsDoc* pDoc=GetDocument();
		*pDoc->GetFFTPoints()=8192;
		pDoc->UpdateStatusBar();
	}
	
		m_pParentFFTFrame=(CFFT3DFrame*)GetParentFrame();
    m_strWindowTitle    = _T("3D FFT");
		m_strHint						= _T("");
    m_bUseDepthBuffer   = TRUE;

    m_pFont            = new CD3DFont( _T("Century Gothic"), 12, 0 );
    m_pFontSmall       = new CD3DFont( _T("Century Gothic"),  9, 0);//D3DFONT_BOLD );
    m_pVB              = NULL;
		m_pVBKoord				 = NULL;
		m_pMesh1					 = NULL;
    m_dwNumVertices    = 0;

    ZeroMemory( m_bKey, sizeof(m_bKey) );
    m_fSpeed           = 5.0f;
    m_fAngularSpeed    = 1.0f;
    m_bShowHelp        = FALSE;

    m_vVelocity        = D3DXVECTOR3( 0.0f, 0.0f, 0.0f );
    m_vAngularVelocity = D3DXVECTOR3( 0.0f, 0.0f, 0.0f );

		x							=	0.0f;
		y							= 0.0f;
		z							=	0.0f;
		u							=	0.0f;
		v							= 0.0f;
		w							=	0.0f;

		D3DVECTOR Null;
		Null.x=0;
		Null.y=0;
		Null.z=0;
//		m_FFTPtArray.Add(Null);

		m_Recalc			=	FALSE;

		m_counter				=	0;

	IniFileRead();

	
	m_pRadioFesteFarbe=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_FESTEFARBE);
	m_pRadioBunt=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_BUNT);
	if (m_bIsBunt) 
	{
		m_pRadioFesteFarbe->SetCheck(0);
		m_pRadioBunt->SetCheck(1);
	}
	else
	{
		m_pRadioFesteFarbe->SetCheck(1);
		m_pRadioBunt->SetCheck(0);
	}
	
	m_pRadioFaces=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_FACES);
	m_pRadioLinien=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_WIRE);
	if (m_bIsWire) 
	{
		m_pRadioFaces->SetCheck(0);
		m_pRadioLinien->SetCheck(1);
	}
	else
	{
		m_pRadioFaces->SetCheck(1);
		m_pRadioLinien->SetCheck(0);
	}

	m_clrRekoREF=RGB(255,0,0);
	m_clrText=RGB(255,255,255);
	m_clrBkg=RGB(0,0,0);

	m_clrReko=D3DCOLOR_XRGB(GetRValue(m_clrRekoREF),\
													GetGValue(m_clrRekoREF),\
													GetBValue(m_clrRekoREF));

	m_FarbButton.SubclassDlgItem(IDC_FARBWAHL, &m_pParentFFTFrame->m_wndDlgBar);
	m_FarbButton.EnableWindow(TRUE);
	m_FarbButton.SetColour(m_clrText,m_clrRekoREF);

	m_FarbButtonBkg.SubclassDlgItem(IDC_BKGCLR, &m_pParentFFTFrame->m_wndDlgBar);
	m_FarbButtonBkg.EnableWindow(TRUE);
	m_FarbButtonBkg.SetColour(m_clrText,m_clrBkg);

	m_pEpsilonCtrl=(CSpinButtonCtrl*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_EPSILON_SPIN2);
 	m_pEpsilonCtrl->SetRange(1,20);
	m_pEpsilonCtrl->SetBuddy(m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_EPSILON_FELD2));
	m_pEpsilonCtrl->SetPos((INT)(m_Epsilon*100));

	CButton* m_pRadioAmpLinear=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_SCALE_AMP_LIN);
	CButton* m_pRadioAmpLog=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_SCALE_AMP_LOG);
	if (m_bIsAmpLinear) 
	{
		m_pRadioAmpLinear->SetCheck(1);
		m_pRadioAmpLog->SetCheck(0);
	}
	else
	{
		m_pRadioAmpLinear->SetCheck(0);
		m_pRadioAmpLog->SetCheck(1);
	}

	CButton* m_pRadioFreqLinear=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_SCALE_FREQ_LIN);
	CButton* m_pRadioFreqLog=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_SCALE_FREQ_LOG);
	if (m_bIsFreqLinear) 
	{
		m_pRadioFreqLog->SetCheck(0);
		m_pRadioFreqLinear->SetCheck(1);
	}
	else
	{
		m_pRadioFreqLog->SetCheck(1);
		m_pRadioFreqLinear->SetCheck(0);
	}

	CSliderCtrl* SliderCtrl=(CSliderCtrl*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_BREITE_SLIDER);
 	SliderCtrl->SetTicFreq( 1 );    // Send TBM_SETTICFREQ
	SliderCtrl->SetLineSize( 1 );       // Send TBM_SETLINESIZE
	SliderCtrl->SetPageSize( 1 );       // Send TBM_SETPAGESIZE
	SliderCtrl->SetRange( 1, 20, TRUE );
	SliderCtrl->SetPos(m_Breite);

	CSpinButtonCtrl* pBottumCutCtrl=(CSpinButtonCtrl*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_BOTTOMCUT_SPIN);
 	pBottumCutCtrl->SetRange(1,999);
	pBottumCutCtrl->SetBuddy(m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_BOTTOMCUT_FELD));
	pBottumCutCtrl->SetPos(m_BottomCutHz);

	CSpinButtonCtrl* pTopCutCtrl=(CSpinButtonCtrl*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_TOPCUT_SPIN);
	pTopCutCtrl->SetRange(1,100);
	pTopCutCtrl->SetBuddy(m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_TOPCUT_FELD));
	pTopCutCtrl->SetPos(m_TopCutkHz);



	m_bFinishMultiple=FALSE;
	m_bFailedMesh=FALSE;

	m_AnzahlFFTPts=0;

	m_bNetzNeu=FALSE;
	m_TatsaechlichAngezeigtFFTPunkte=0;

	//Direct3D Objekt erstellen
	m_hwndRenderWindow = GetSafeHwnd();
	CD3DApplication::m_hWnd = m_hwndRenderWindow;
  HRESULT hr=CD3DApplication::Create( AfxGetInstanceHandle() );
	if (hr==D3DAPPERR)	//Fehler bei der Erstellung des Direct3DApplicationObjekts
	{
		CSoundsDoc* pDoc=GetDocument();
		pDoc->m_pViewFFT3D=(CFFT3DFrame*)this->GetParentFrame();
		m_bReady=FALSE;
		pDoc->m_bIsNot3D=TRUE;
	}
	else
	{

	//Farbpalette erstellen
	CSoundsDoc* pDoc=GetDocument();
	CDC* pDC=GetDC();
	pDC->SelectPalette(pDoc->GetPalette(), FALSE);
	pDC->RealizePalette();
	}
}


//-----------------------------------------------------------------------------
// Name: OneTimeSceneInit()
// Desc: Called during initial app startup, this function performs all the
//       permanent initialization.
//-----------------------------------------------------------------------------
HRESULT CFFT3DView::OneTimeSceneInit()
{
		// Set up our view matrix. A view matrix can be defined given an eye point,
    // a point to lookat, and a direction for which way is up. Here we look at the
    // origin, and define "up" to be in the z-direction.
    D3DXVECTOR3 vEye = D3DXVECTOR3( -4.0f, +5.0f, 3.0f );
    D3DXVECTOR3 vAt  = D3DXVECTOR3( 0.0f, -5.0f, 0.0f );
    D3DXVECTOR3 vUp  = D3DXVECTOR3( 0.0f, 0.0f, 1.0f );
    D3DXMatrixLookAtRH( &m_matView, &vEye, &vAt, &vUp );

    // Set the position matrix
//    D3DXMatrixInverse( &m_matPosition, NULL, &m_matView );

		x							=	0.0f;
		y							= 0.0f;
		z							=	0.0f;
		u							=	0.0f;
		v							= 0.0f;
		w							=	0.0f;
		MoveStep			=	0.0f;
		m_bNetzNeu		=	TRUE;
		return S_OK;
}

//-----------------------------------------------------------------------------
// Name: FrameMove()
// Desc: Called once per frame, the call is the entry point for animating
//       the scene.
//-----------------------------------------------------------------------------
HRESULT CFFT3DView::FrameMove()
{
		x							=	0.0f;
		y							= 0.0f;
		z							=	0.0f;
		u							=	0.0f;
		v							= 0.0f;
		w							=	0.0f;
		FLOAT MoveStepView=0.0f;

    FLOAT fSecsPerFrame = 0.1f;//m_fElapsedTime;

    // Process keyboard input
    D3DXVECTOR3 vT( 0.0f, 0.0f, 0.0f );
    D3DXVECTOR3 vR( 0.0f, 0.0f, 0.0f );

    m_vVelocity        = D3DXVECTOR3( 0.0f, 0.0f, 0.0f );
    m_vAngularVelocity = D3DXVECTOR3( 0.0f, 0.0f, 0.0f );

    if( m_bKey[VK_LEFT] || m_bKey[VK_NUMPAD1] )                 vT.x -= 1.0f; // Slide Left
    if( m_bKey[VK_RIGHT] || m_bKey[VK_NUMPAD3] )                vT.x += 1.0f; // Slide Right
    if( m_bKey[VK_DOWN] )                                       vT.y -= 1.0f; // Slide Down
    if( m_bKey[VK_UP] )                                         vT.y += 1.0f; // Slide Up

    if( m_bKey[VK_ADD] || m_bKey[187] )                         vT.z -= 2.0f; // Move Forward
    if( m_bKey[VK_SUBTRACT] || m_bKey[189] )                    vT.z += 2.0f; // Move Backward

    if( m_bKey['A'] || m_bKey[VK_NUMPAD8] )                     vR.x -= 1.0f; // Pitch Down
    if( m_bKey['Z'] || m_bKey[VK_NUMPAD2] )                     vR.x += 1.0f; // Pitch Up
    if( m_bKey['E'] || m_bKey[VK_NUMPAD4] )                     vR.y -= 1.0f; // Turn Right
    if( m_bKey['Q'] || m_bKey[VK_NUMPAD6] )                     vR.y += 1.0f; // Turn Left
    if( m_bKey[VK_NUMPAD9] )                                    vR.z -= 2.0f; // Roll CW
    if( m_bKey[VK_NUMPAD7] )                                    vR.z += 2.0f; // Roll CCW
    if( m_bKey['O'] )                                           x -= 1.0f; // Dreh um X+
    if( m_bKey['P'] )                                           x += 1.0f; // Dreh um X-
    if( m_bKey['K'] )                                           y -= 1.0f; // Dreh um Y+
		if( m_bKey['L'] )                                           y += 1.0f; // Dreh um Y-
    if( m_bKey['N'] )                                           z -= 1.0f; // Dreh um Z+
    if( m_bKey['M'] )                                           z += 1.0f; // Dreh um Z-

    if( m_bKey['X'] )                                           u -= 0.1f; // Schub um X+
    if( m_bKey['C'] )                                           u += 0.1f; // Schub um X-
    if( m_bKey['V'] )                                           v -= 0.1f; // Schub um Y+
		if( m_bKey['B'] )																						v += 0.1f; // Schub um Y-
    if( m_bKey['G'] )                                           w -= 0.1f; // Schub um Z+
    if( m_bKey['H'] )                                           w += 0.1f; // Schub um Z-
		
//		for(int i=0; i<256; i++)
//		{
//			m_bKey[i]=0;
//		}

		m_vVelocity        = m_vVelocity * 0.9f + vT * 0.1f;
    m_vAngularVelocity = m_vAngularVelocity * 0.9f + vR * 0.1f;


    // Update position and view matricies
    D3DXMATRIXA16     matT, matR, matRotateX,matRotateY,matRotateZ,matTranslation;
    D3DXQUATERNION qR;

    vT = m_vVelocity * fSecsPerFrame * m_fSpeed;
    vR = m_vAngularVelocity * fSecsPerFrame * m_fAngularSpeed;


		D3DXMATRIX MatTemp;  // Temp matrix for rotations.
    D3DXMATRIX MatRot;   // Final rotation matrix, applied to 
                         // pMatWorld.
 
		//Verschiebung des Koordinatensystems in die Mitte des Netzes
    D3DXMATRIX matWorld,matViewTrans;
    D3DXMatrixTranslation(&matWorld, 0,MoveStep,0);

		//halbe Translation in y- Richtung, um die ganze Kurve zu sehen
    D3DXMatrixTranslation(&matViewTrans, 0,MoveStepView,0);
    D3DXMatrixMultiply(&m_matView, &matViewTrans, &m_matView);
		//Translationen in der ViewMatrix ausfhren
    D3DXMatrixTranslation(&matViewTrans, u,v,w);
    D3DXMatrixMultiply(&m_matView, &matViewTrans, &m_matView);
    D3DXMatrixTranslation(&matViewTrans, vT.x, vT.y, vT.z);
    D3DXMatrixInverse( &m_matPosition, NULL, &m_matView );
    D3DXMatrixMultiply(&m_matPosition, &matViewTrans, &m_matPosition);
    D3DXQuaternionRotationYawPitchRoll( &qR, vR.y, vR.x, vR.z );
    D3DXMatrixRotationQuaternion( &matR, &qR );
    D3DXMatrixMultiply( &m_matPosition, &matR, &m_matPosition );
    D3DXMatrixInverse( &m_matView, NULL, &m_matPosition );

    D3DXMatrixIdentity(&MatRot);

    // Now, apply the orientation variables to the world matrix
    // Produce and combine the rotation matrices.
    D3DXMatrixRotationX(&MatTemp, x*D3DX_PI/180);         // Pitch
    D3DXMatrixMultiply(&MatRot, &MatRot, &MatTemp);
    D3DXMatrixRotationY(&MatTemp, y*D3DX_PI/180);           // Yaw
    D3DXMatrixMultiply(&MatRot, &MatRot, &MatTemp);
    D3DXMatrixRotationZ(&MatTemp, z*D3DX_PI/180);          // Roll
    D3DXMatrixMultiply(&MatRot, &MatRot, &MatTemp);
 
		// Apply the rotation matrices to complete the world matrix.
    D3DXMatrixMultiply(&m_matView, &MatRot, &m_matView);

		if (m_bReady) 
		{
	    m_pd3dDevice->SetTransform( D3DTS_WORLD, &matWorld );
		  m_pd3dDevice->SetTransform( D3DTS_VIEW, &m_matView );
		}

    return S_OK;
}


//-----------------------------------------------------------------------------
// Name: SetupLights()
// Desc: Sets up the lights and materials for the scene.
//-----------------------------------------------------------------------------
VOID CFFT3DView::SetupLights()
{

D3DLIGHT8 d3dLight1, d3dLight2,d3dLight3;
HRESULT   hr;

// Initialize the structure.
ZeroMemory(&d3dLight1, sizeof(D3DLIGHT8));
ZeroMemory(&d3dLight2, sizeof(D3DLIGHT8));
ZeroMemory(&d3dLight3, sizeof(D3DLIGHT8));

// Set up a white directional light.
d3dLight1.Type = D3DLIGHT_DIRECTIONAL;
d3dLight1.Diffuse.r  = 0.8f;
d3dLight1.Diffuse.g  = 0.7f;
d3dLight1.Diffuse.b  = 0.9f;
d3dLight1.Ambient.r  = 1.0f;
d3dLight1.Ambient.g  = 1.0f;
d3dLight1.Ambient.b  = 1.0f;
d3dLight1.Specular.r = 1.0f;
d3dLight1.Specular.g = 1.0f;
d3dLight1.Specular.b = 1.0f;
d3dLight1.Direction.x = -1.0f;
d3dLight1.Direction.y = -1.0f;
d3dLight1.Direction.z = -2.0f;
// Set up a white directional light.
d3dLight3.Type = D3DLIGHT_DIRECTIONAL;
d3dLight3.Diffuse.r  = 0.3f;
d3dLight3.Diffuse.g  = 0.5f;
d3dLight3.Diffuse.b  = 0.1f;
d3dLight3.Ambient.r  = 1.0f;
d3dLight3.Ambient.g  = 1.0f;
d3dLight3.Ambient.b  = 1.0f;
d3dLight3.Specular.r = 1.0f;
d3dLight3.Specular.g = 1.0f;
d3dLight3.Specular.b = 1.0f;
d3dLight3.Direction.x = 1.0f;
d3dLight3.Direction.y = -1.0f;
d3dLight3.Direction.z = -2.0f;

// Set up a white point light.
d3dLight2.Type = D3DLIGHT_DIRECTIONAL;
d3dLight2.Diffuse.r  = 1.0f;
d3dLight2.Diffuse.g  = 1.0f;
d3dLight2.Diffuse.b  = 1.0f;
d3dLight2.Ambient.r  = 1.0f;
d3dLight2.Ambient.g  = 1.0f;
d3dLight2.Ambient.b  = 1.0f;
d3dLight2.Specular.r = 1.0f;
d3dLight2.Specular.g = 1.0f;
d3dLight2.Specular.b = 1.0f;
d3dLight2.Direction.x = 0.0f;
d3dLight2.Direction.y = 0.0f;
d3dLight2.Direction.z = 2.0f;

// Set the property information for the first light.
hr = m_pd3dDevice->SetLight(0, &d3dLight1);
hr = m_pd3dDevice->SetLight(1, &d3dLight2);
hr = m_pd3dDevice->SetLight(2, &d3dLight3);
m_pd3dDevice->LightEnable( 0, TRUE );
m_pd3dDevice->LightEnable( 1, TRUE );
m_pd3dDevice->LightEnable( 2, TRUE );

}

//-----------------------------------------------------------------------------
// Name: Render()
// Desc: Called once per frame, the call is the entry point for 3d
//       rendering. This function sets up render states, clears the
//       viewport, and renders the scene.
//-----------------------------------------------------------------------------
HRESULT CFFT3DView::Render()
{
	CSoundsDoc* pDoc=GetDocument();
  // Clear the backbuffer with a black background
  m_pd3dDevice->Clear( 0L, NULL, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER, m_clrBackBuffer, 1.0f, 0L );

  // Begin the scene
  if( SUCCEEDED( m_pd3dDevice->BeginScene() ) )
  {
	  // Draw the points in the vertex buffer. This is broken into a few
		// steps. We are passing the vertices down a "stream", so first we need
    // to specify the source of that stream, which is our vertex buffer. Then
    // we need to let D3D know what vertex shader to use. Full, custom vertex
    // shaders are an advanced topic, but in most cases the vertex shader is
    // just the FVF, so that D3D knows what type of vertices we are dealing
    // with. Finally, we call DrawPrimitive() which does the actual rendering
    // of our geometry.


		// Setup the lights and materials
		SetupLights();

/*		// Koordinatensystem ausgeben
		m_pd3dDevice->SetStreamSource( 0, m_pVBKoord, sizeof(FFT3DVERTEX) );
		m_pd3dDevice->SetVertexShader( D3DFVF_FFT3DVERTEX );
	  m_pd3dDevice->DrawPrimitive( D3DPT_LINELIST, 0, 1 );
*/
    // Output statistics
		DWORD Textfarbe=D3DCOLOR_XRGB(GetRValue(m_clrText),GetGValue(m_clrText),GetBValue(m_clrText));

		CString Text;
    if( m_bShowHelp )
    {
		  m_pFont->DrawText( 2,  0, Textfarbe, m_strFrameStats );//D3DCOLOR_ARGB(255,255,255,0)
		  m_pFont->DrawText( 2, 20, Textfarbe, m_strDeviceStats );
			Text.LoadString(IDS_3DHELP_SHORTCUTS);
      m_pFontSmall->DrawText(  2, 40, Textfarbe, Text.GetBuffer(Text.GetLength()));
     	
			Text.LoadString(IDS_3DHELP_SHORTCUTS1);
 			m_pFontSmall->DrawText( 20, 60, Textfarbe, Text.GetBuffer(Text.GetLength()));

			Text.LoadString(IDS_3DHELP_SHORTCUTS2);
			m_pFontSmall->DrawText( 210, 60, Textfarbe, Text.GetBuffer(Text.GetLength()));
    }
	  m_pFontSmall->DrawText( 2,  0, Textfarbe, m_strHint.GetBuffer(m_strHint.GetLength()) );//D3DCOLOR_ARGB(255,255,255,0)

		// Wenn Neues Datenarray vorhanden, dann Buffer erstellen
    if (m_Recalc)
			if (g_bIsPutPoints)
			{
				CArray<DOUBLE,DOUBLE> Dummyarray;
				for (int i=0; i<m_AnzahlFFTPts;i++)
					Dummyarray.Add(0);
				m_counter-=1;
//				NeueFFTPunkteMultiple(&Dummyarray);
			}
			else
			{
				CArray<DOUBLE,DOUBLE>* pFrequenzenArray=pDoc->GetFrequenzenArray();
				//altes FrequenzenArray vom vorhergehender PutPoints Analyse verwerfen
				if (*pDoc->GetFFTPoints()/2==pFrequenzenArray->GetSize()-1)
					NeueFFTPunkte(pFrequenzenArray);
			}

		// Wenn Zeitreihen oder Wavearray gefllt, dann ausgeben
		if (m_dwNumFaces>0)
		{
			DWORD State=0;
			if (m_bIsWire) 
				m_pd3dDevice->SetRenderState(D3DRS_FILLMODE, D3DFILL_WIREFRAME);
			else 
				m_pd3dDevice->SetRenderState(D3DRS_FILLMODE, D3DFILL_SOLID);
			
			m_pd3dDevice->SetRenderState(D3DRS_LIGHTING, TRUE); 
			m_pd3dDevice->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW); 
			if (m_counter>=1) 
			{
//				m_pd3dDevice->SetRenderState(D3DRS_DIFFUSEMATERIALSOURCE, D3DMCS_COLOR1);
 	      m_pMesh1->DrawSubset(0);
			}
		}

    // End the scene.
    m_pd3dDevice->EndScene();
  }
		
    return S_OK;
}

//-----------------------------------------------------------------------------
// Name: InitDeviceObjects()
// Desc: Initialize scene objects.
//-----------------------------------------------------------------------------
HRESULT CFFT3DView::InitDeviceObjects()
{
    m_pd3dDevice->SetTransform( D3DTS_VIEW, &m_matView );
		m_pd3dDevice->SetRenderState(D3DRS_LIGHTING, TRUE); 
		m_pd3dDevice->SetRenderState(D3DRS_FILLMODE, D3DFILL_SOLID);
		m_pd3dDevice->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);
		m_pd3dDevice->SetRenderState(D3DRS_DIFFUSEMATERIALSOURCE, D3DMCS_COLOR1);
    m_pFont->InitDeviceObjects( m_pd3dDevice );
    m_pFontSmall->InitDeviceObjects( m_pd3dDevice );
    return S_OK;
}


//-----------------------------------------------------------------------------
// Name: RestoreDeviceObjects()
// Desc: Initialize scene objects.
//-----------------------------------------------------------------------------
HRESULT CFFT3DView::RestoreDeviceObjects()
{
    m_pFont->RestoreDeviceObjects();
    m_pFontSmall->RestoreDeviceObjects();

	// Desc: Creates a vertex buffer and fills it with our vertices. The vertex
	//       buffer is basically just a chuck of memory that holds vertices. After
	//       creating it, we must Lock()/Unlock() it to fill it. For indices, D3D
	//       also uses index buffers. The special thing about vertex and index
	//       buffers is that they can be created in device memory, allowing some
	//       cards to process them in hardware, resulting in a dramatic
	//       performance gain.

/*

    // Koordinatensystem einlesen
		DWORD Textfarbe=D3DCOLOR_XRGB(GetRValue(m_clrText),GetGValue(m_clrText),GetBValue(m_clrText));
    FFT3DVERTEX m_Koordinatensystem[] =
    {
        { -2.0f,  0.0f, 0.0f,0,0,0,m_SizePts, Textfarbe, }, // x, y, z, color
        { +2.0f,  0.0f, 0.0f,0,0,0,m_SizePts, Textfarbe, },
        {  0.0f, +2.0f, 0.0f,0,0,0,m_SizePts, 0xffffff00,  },
        {  0.0f, -2.0f, 0.0f,0,0,0,m_SizePts, 0xffffff00,  }, 
        {  0.0f,  0.0f, +2.0f,0,0,0,m_SizePts, 0xffffff00, },
        {  0.0f,  0.0f, -2.0f,0,0,0,m_SizePts, 0xffffff00,  },//m_SizePts, 0xffffffff,
    };
		// Create the vertex buffer. Here we are allocating enough memory
    // (from the default pool) to hold all our 6 custom vertices. We also
    // specify the FVF, so the vertex buffer knows what data it contains.
		if( FAILED( m_pd3dDevice->CreateVertexBuffer( 6*sizeof(FFT3DVERTEX), D3DUSAGE_WRITEONLY, D3DFVF_FFT3DVERTEX,
                                                  D3DPOOL_DEFAULT, &m_pVBKoord ) ) )
        return E_FAIL;
    // Now we fill the vertex buffer. To do this, we need to Lock() the VB to
    // gain access to the vertices. This mechanism is required because vertex
    // buffers may be in device memory.
    VOID* pVerticesKoords;
    if( FAILED( m_pVBKoord->Lock( 0, sizeof(m_Koordinatensystem), (BYTE**)&pVerticesKoords, 0 ) ) )
        return E_FAIL;
    memcpy( pVerticesKoords, m_Koordinatensystem, sizeof(m_Koordinatensystem) );
    m_pVBKoord->Unlock();
*/
    // Set up the projection matrix
    FLOAT fAspectRatio = (FLOAT)(m_d3dsdBackBuffer.Width*1.2) / (FLOAT)(m_d3dsdBackBuffer.Height*1.2);
    D3DXMatrixPerspectiveFovRH( &m_matProj, D3DXToRadian(60.0f), fAspectRatio, 0.1f, 100.0f );
    m_pd3dDevice->SetTransform( D3DTS_PROJECTION, &m_matProj );

		
		if (m_dwNumVertices>0) 
		{
			HRESULT hr=D3DXCreateMeshFVF(m_dwNumFaces,m_dwNumVertices,D3DXMESH_32BIT|D3DPOOL_DEFAULT,D3DFVF_FFT3DVERTEX,m_pd3dDevice,&m_pMesh1);
			if (hr != D3D_OK)
			{
	      AfxMessageBox(E_FFT3DVIEW_RESTOREDEVICEOBJECTS_D3DXCREATEMESHFVF, MB_OK );
				m_bFailedMesh=TRUE;
			}
			else
			{
				//in m_pVerticesMesh gespeicherte Kopie wieder herstellen
					FFT3DVERTEX *pVerticesMesh;
					hr = m_pMesh1->LockVertexBuffer(0, (BYTE**) &pVerticesMesh);
					for (int w=0;w<m_dwNumVertices;w++) 
					{
						pVerticesMesh[w] = m_pVerticesMeshKopie[w];
					}
					m_pMesh1->UnlockVertexBuffer();

					//Lock and fill index buffer.
					DWORD *pwIndices; // Array of indices
					hr = m_pMesh1->LockIndexBuffer(0, (BYTE**) &pwIndices);
					if (hr != D3D_OK)
	          AfxMessageBox(E_FFT3DVIEW_RESTOREDEVICEOBJECTS_LOCKINDEXBUFFER, MB_OK );

					DWORD j=0;
					INT z=0;
					INT AnzahlFlaechenProBand=(m_TatsaechlichAngezeigtFFTPunkte-1)*2;
					INT AnzahlIndizesProBand=AnzahlFlaechenProBand*3; //weil Dreiecke :-)
					INT AnzahlFFTReihen=(INT)MAX_NUM_VERTICES_MESH/(FLOAT)m_TatsaechlichAngezeigtFFTPunkte;
					while (j<m_dwNumFaces*3) 
					{
						if ((j!=0)&&(j%AnzahlIndizesProBand==0)) 
							z+=1;
						pwIndices[j]		= j/6+z;
						pwIndices[j+1]	=	j/6+1+z;
						pwIndices[j+2]	=	(DWORD)(m_dwNumVertices/(AnzahlFFTReihen)+j/6+z);
						pwIndices[j+3]	= (DWORD)(m_dwNumVertices/(AnzahlFFTReihen)+j/6+z);
						pwIndices[j+4]	=	j/6+1+z;
						pwIndices[j+5]	=	(DWORD)(m_dwNumVertices/(AnzahlFFTReihen)+j/6+1+z);
						j+=6;
		     }
					hr = m_pMesh1->UnlockIndexBuffer();
					if(hr != D3D_OK)
	         AfxMessageBox(E_FFT3DVIEW_RESTOREDEVICEOBJECTS_UNLOCKINDEXBUFFER, MB_OK );

					hr = D3DXComputeNormals(m_pMesh1,NULL);
					if(hr != D3D_OK)
	          AfxMessageBox(E_FFT3DVIEW_RESTOREDEVICEOBJECTS_D3DXCOMPUTENORMALS, MB_OK );
				m_bNetzNeu=FALSE;
			}
			delete [] m_pVerticesMeshKopie;
		}
    return S_OK;
}

//-----------------------------------------------------------------------------
// Name: NeueFFTPunkte()
// Desc: Wenn die Arrays neu aufgefllt wurden, neue Punkte einlesen.
//-----------------------------------------------------------------------------
HRESULT CFFT3DView::NeueFFTPunkte(CArray<DOUBLE,DOUBLE>* pFrequenzenArray)
{
	m_strHint=_T("");
	m_bFinishMultiple=FALSE;
	HRESULT hr;
  // Zeitreihenarray als Punkte einlesen
	CSoundsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	INT* pBitRate=pDoc->GetBitRate();
	BOOL* pSigned=pDoc->GetSigned();
	INT MaxFrequenzen=pFrequenzenArray->GetSize()-1;
	DOUBLE MaxAmplitude=ldexp(1,*pDoc->GetBitRate());
	if (MaxFrequenzen>2) // Wenn Array berhaupt belegt.
	{
		//Rescale Frequenz Array auf x: -m_Breite bis +m_Breite und Hhe z: 0 bis 4, sowie y: Schrittweite mal AnzahlReihen
		DOUBLE FaktorX;
		DOUBLE FaktorZ;
		FaktorX=2/(DOUBLE)MaxFrequenzen;
	  FaktorZ=4;//MaxAmplitude;

		//NeueFFTReihe ist Array fr die einzelne FFTReihe
		CArray<D3DVECTOR,D3DVECTOR> NeueFFTReihe;
		NeueFFTReihe.RemoveAll();
		D3DVECTOR Anfang;
		Anfang.x=(FLOAT)(-m_Breite);
		Anfang.y=m_counter*m_Schrittweite;
		Anfang.z=0;
		NeueFFTReihe.Add(Anfang);

		D3DVECTOR Messpunkt;
		INT* pSampleRate=pDoc->GetSampleRate();
		INT FrequenzbreiteFFTAnsicht=m_TopCutkHz*1000;
		FLOAT LastX=(FLOAT)(-m_Breite);
		DOUBLE BildProzentVonBottomCutHz = m_bIsFreqLinear?\
																				 m_BottomCutHz/(DOUBLE)FrequenzbreiteFFTAnsicht:\
																				 log(m_BottomCutHz)/log(FrequenzbreiteFFTAnsicht);
		int i=0;
		while (i<MaxFrequenzen)
	  {
			INT FrequenzLinear=(INT)(i*(*pSampleRate/2/(FLOAT)MaxFrequenzen));
			//Frequenzen unter m_BottomCutHz ausschneiden wegen Darstellungsverlust
			//die ersten 10 Hz entsprechen ca. 1/5 des Bildraums in der Oktavdarstellung
			if (FrequenzLinear>m_BottomCutHz) 
			{
				//Frequenzen von m_BottomCutHz bis Frequenzbreite (22khz, 44kHz usw) auf ClientRect skalieren
				DOUBLE ProzentwertKlein=m_bIsFreqLinear?\
																FrequenzLinear/(DOUBLE)FrequenzbreiteFFTAnsicht-BildProzentVonBottomCutHz:\
																log(FrequenzLinear)/log(FrequenzbreiteFFTAnsicht)-BildProzentVonBottomCutHz;
				DOUBLE ProzentwertSkaliertAuf100=ProzentwertKlein/(1-BildProzentVonBottomCutHz);
				Messpunkt.x=(FLOAT)((ProzentwertSkaliertAuf100)*2*m_Breite-m_Breite);
				if (Messpunkt.x-LastX>=m_Epsilon&&ProzentwertSkaliertAuf100<=1)
				{
					DOUBLE Wert;
					INT Intensitaet=(INT)(pFrequenzenArray->GetAt(i));
					if (m_bIsAmpLinear)
						Wert=Intensitaet/MaxAmplitude*15;
					else
						Wert=log(Intensitaet+1)/log(MaxAmplitude);
				  Messpunkt.z=(FLOAT)(Wert*FaktorZ);
					Messpunkt.y=(FLOAT)(m_counter*m_Schrittweite);
					//Punkteanzahl auf SIchtbarkeitsma reduzieren
					NeueFFTReihe.Add(Messpunkt);
					LastX=Messpunkt.x;
				}
			}
		  i+=1;
	  }
		//GesamtFFT, auch bei greren Frequenzbereichen als die FFT angibt, zeichnen
		Messpunkt.x=(FLOAT)m_Breite;
		Messpunkt.y=(FLOAT)(m_counter*m_Schrittweite);
		Messpunkt.z=0;
//		NeueFFTReihe.Add(Messpunkt);

		//Netzparameter ermitteln
		m_TatsaechlichAngezeigtFFTPunkte=NeueFFTReihe.GetSize();
		INT AnzahlFFTReihen=(INT)MAX_NUM_VERTICES_MESH/(FLOAT)m_TatsaechlichAngezeigtFFTPunkte;
		m_dwNumVertices=(DWORD)(AnzahlFFTReihen*m_TatsaechlichAngezeigtFFTPunkte);	
		m_dwNumFaces=(m_TatsaechlichAngezeigtFFTPunkte-1)*2*(AnzahlFFTReihen-1);

		if (m_bNetzNeu) 
		{
			NeuesNetz(m_dwNumFaces,m_dwNumVertices,m_pMesh1,m_TatsaechlichAngezeigtFFTPunkte,AnzahlFFTReihen,&NeueFFTReihe);
			m_bNetzNeu=FALSE;
		}

		if (m_counter>0) 
		{
			if (m_dwNumFaces>0) 
			{
				CArray<FFT3DVERTEX,FFT3DVERTEX> m_VerticesFFT;
				FFT3DVERTEX Puffer;

				// Punkte in Puffer einlesen
				FFT3DVERTEX *pVerticesMesh;
				//Lock and fill vertex buffer.
				hr = m_pMesh1->LockVertexBuffer(0, (BYTE**) &pVerticesMesh);
				if(hr != D3D_OK)
          AfxMessageBox(E_FFT3DVIEW_NEUEFFTPUNKTE_LOCKVERTEXBUFFER, MB_OK );
				
				//Netzkoordinaten um eine Reihe nach hinten shiften
				for (int u=m_dwNumVertices-m_TatsaechlichAngezeigtFFTPunkte;u>m_TatsaechlichAngezeigtFFTPunkte;u--) 
				{
					pVerticesMesh[u] = pVerticesMesh[u-m_TatsaechlichAngezeigtFFTPunkte];
					pVerticesMesh[u].y+=m_Schrittweite;
				}
				//Neue FFTReihe aus Array hinten anfgen
				for (int w=0;w<m_TatsaechlichAngezeigtFFTPunkte;w++) 
				{
					FLOAT Prozent=w/(FLOAT)(m_TatsaechlichAngezeigtFFTPunkte);
					Puffer.x=-NeueFFTReihe.GetAt(w).x;
					Puffer.y=-AnzahlFFTReihen*m_Schrittweite/2;													//in erster Reihe anfgen;
//					Puffer.y=m_Schrittweite*(AnzahlFFTReihen-2);
					Puffer.z=NeueFFTReihe.GetAt(w).z;
	 				Puffer.ptsize=0.5f;//m_SizePts;
					if (m_bIsBunt)
						Puffer.color=Farbwahl((INT)(Prozent*1663));
					else
						Puffer.color=m_clrReko;
					pVerticesMesh[w] = Puffer;
				}
				m_pMesh1->UnlockVertexBuffer();

				//Indexbuffer hat sich nicht verndert also auch nicht neu setzen

				//Beleuchtung berechnen
				hr = D3DXComputeNormals(m_pMesh1,NULL);
				if(hr != D3D_OK)
          AfxMessageBox(E_FFT3DVIEW_NEUEFFTPUNKTE_COMPUTENORMALS, MB_OK );

				m_counter++;
				if (m_counter>=AnzahlFFTReihen) m_counter=0;
			}
		}
		if (m_counter==0) 
			m_counter++;

	}// wenn berhaupt belegt
	else
	{
		m_dwNumVertices=0;
		m_dwNumFaces=0;
		m_counter=0;
		m_bNetzNeu=TRUE;
	}
	m_Recalc=FALSE;
	return S_OK;
}

void CFFT3DView::NeuesNetz(DWORD dwNumFaces, DWORD dwNumVertices, ID3DXMesh* pMesh,
													INT PtsPerRow,INT Rows,	CArray<D3DVECTOR,D3DVECTOR>* pNeueFFTReihe)
{
	HRESULT hr;
	if( m_pMesh1 != NULL ) 
	{
		m_pMesh1->Release();
		m_pMesh1=NULL;
	}
	hr=D3DXCreateMeshFVF(dwNumFaces,dwNumVertices,D3DXMESH_32BIT|D3DPOOL_DEFAULT,D3DFVF_FFT3DVERTEX,m_pd3dDevice,&m_pMesh1);
  if (hr != D3D_OK)
	{
    AfxMessageBox(E_FFT3DVIEW_NEUESNETZ_D3DXCREATEMESHFVF, MB_OK );
		m_bFailedMesh=TRUE;
	}
	else
	{
		FFT3DVERTEX *pVerticesMesh;
		FFT3DVERTEX Puffer;
		hr = m_pMesh1->LockVertexBuffer(0, (BYTE**) &pVerticesMesh);
		for (int w=0;w<dwNumVertices;w++) 
		{
			FLOAT Prozent=(w%PtsPerRow)/(FLOAT)(PtsPerRow);
			Puffer.x=-pNeueFFTReihe->GetAt(w%PtsPerRow).x;//(Prozent*2*m_Breite-m_Breite);
			Puffer.y=(FLOAT)(floor(w/(float)PtsPerRow)*m_Schrittweite-Rows*m_Schrittweite/2);
			Puffer.z=0;
			Puffer.ptsize=0.5f;
			if (m_bIsBunt)
				Puffer.color=Farbwahl((INT)(Prozent*1663));
			else
				Puffer.color=m_clrReko;
			pVerticesMesh[w] = Puffer;
		}
		m_pMesh1->UnlockVertexBuffer();
		//Lock and fill index buffer.
		DWORD *pwIndices; // Array of indices
		hr = m_pMesh1->LockIndexBuffer(0, (BYTE**) &pwIndices);
		if (hr != D3D_OK) AfxMessageBox(E_FFT3DVIEW_NEUESNETZ_LOCKINDEXBUFFER, MB_OK );
		DWORD j=0;
		INT z=0;
		INT AnzahlFlaechenProBand=(PtsPerRow-1)*2;
		INT AnzahlIndizesProBand=AnzahlFlaechenProBand*3; //weil Dreiecke :-)
		while (j<dwNumFaces*3) 
		{
			if ((j!=0)&&(j%AnzahlIndizesProBand==0)) 
				z+=1;
			pwIndices[j]		= j/6+z;
			pwIndices[j+1]	=	j/6+1+z;
			pwIndices[j+2]	=	(DWORD)(dwNumVertices/Rows+j/6+z);
			pwIndices[j+3]	= (DWORD)(dwNumVertices/Rows+j/6+z);
			pwIndices[j+4]	=	j/6+1+z;
			pwIndices[j+5]	=	(DWORD)(dwNumVertices/Rows+j/6+1+z);
			j+=6;
    }
		hr = m_pMesh1->UnlockIndexBuffer();
		if(hr != D3D_OK) AfxMessageBox(E_FFT3DVIEW_NEUESNETZ_UNLOCKINDEXBUFFER, MB_OK );
		hr = D3DXComputeNormals(m_pMesh1,NULL);
		if(hr != D3D_OK) AfxMessageBox(E_FFT3DVIEW_NEUESNETZ_COMPUTENORMALS, MB_OK );
	}
}

//-----------------------------------------------------------------------------
// Name: DrawMultiple3DFFTs ()
// Desc: Nach g_bIsPutPoints 3D Netz ausfllen
//-----------------------------------------------------------------------------

void CFFT3DView::DrawMultiple3DFFTs() 
{
	BeginWaitCursor();
	g_bIsBusy=TRUE;

	//Netzwerte zurcksetzen
	m_bFinishMultiple=FALSE;
	m_bNetzNeu=TRUE;
	m_dwNumVertices=0;
	m_dwNumFaces=0;
	m_counter=0;

	CSoundsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CArray<DOUBLE,DOUBLE>* pZeitreiheArray=pDoc->GetZeitreiheArray();
	DOUBLE MaxZeitZeitreihe=pZeitreiheArray->GetSize();
	INT FFTPoints=*pDoc->GetFFTPoints();
	if (MaxZeitZeitreihe>FFTPoints) 
	{
		m_strHint=_T("");
		CArray<DOUBLE,DOUBLE> FrequenzenArrayFirst;
		pDoc->DoFFTAtPoint(pZeitreiheArray,0,FFTPoints,&FrequenzenArrayFirst);
		NeueFFTPunkte(&FrequenzenArrayFirst);

		INT AnzahlKnoten=m_dwNumVertices;
		INT AnzahlKnotenProFFT=m_TatsaechlichAngezeigtFFTPunkte;
		INT AnzahlFFTReihen=(INT)MAX_NUM_VERTICES_MESH/(FLOAT)m_TatsaechlichAngezeigtFFTPunkte;

		INT Sprung=(INT)(MaxZeitZeitreihe/AnzahlFFTReihen);
		for (INT j=0;j<(INT)(MaxZeitZeitreihe-FFTPoints); j+=Sprung)
		{
			CArray<DOUBLE,DOUBLE> FrequenzenArray;
			pDoc->DoFFTAtPoint(pZeitreiheArray,j,FFTPoints,&FrequenzenArray);
			NeueFFTPunkte(&FrequenzenArray);
			Render3DEnvironment();
			if (m_bFailedMesh) break;

			//Abbruch mit ESC abfangen wenn nicht im Capturemodus
			if (!g_bIsCapturing) 
			{
				MSG msg;
				PeekMessage( &msg, NULL, 0, 0, PM_REMOVE );
		    if (msg.message == WM_KEYDOWN && msg.wParam == VK_ESCAPE) 
				{
					g_bIsBreak=TRUE;
				  TranslateMessage(&msg); 
			    DispatchMessage(&msg); 
				}
				if (g_bIsBreak) break;
			}
		}
		m_bFailedMesh=FALSE;
		m_bFinishMultiple=TRUE;
	}
	else
	{
		if (*theApp.GetIniAllgemeinGrundschulprofil()) 
			m_strHint.LoadString(IDS_NEEDMOREPOINTS_SIMPLE);
		else
			m_strHint.LoadString(IDS_NEEDMOREPOINTS);
		Render3DEnvironment();
	}
	g_bIsBreak=FALSE;
	g_bIsBusy=FALSE;
	EndWaitCursor();
}

//-----------------------------------------------------------------------------
// Name: Farbwahl ()
// Desc: Farbspiel einbauen.
//-----------------------------------------------------------------------------
DWORD CFFT3DView::Farbwahl(INT counter)
{
	INT r=0,g=0,b=0;
	if (counter<128) {
		r=128+counter;
		g=0;
		b=0;
	} else if ((counter>=128)&&(counter<384)) {
		r=255;
		g=counter-128;
		b=0;
	} else if ((counter>=384)&&(counter<640)) {
		r=639-counter;
		g=255;
		b=0;
	} else if ((counter>=640)&&(counter<896)) {
		r=0;
		g=255;
		b=counter-640;
	} else if ((counter>=896)&&(counter<1152)) {
		r=0;
		g=1151-counter;
		b=255;
	} else if ((counter>=1152)&&(counter<1408)) {
		r=counter-1152;
		g=0;
		b=255;
	} else if ((counter>=1408)&&(counter<1664)) {
		r=255;
		g=counter-1408;
		b=255;
	}
	return D3DCOLOR_XRGB(r,g,b);  // hier evtl. Farbspiel einbauen

}


//-----------------------------------------------------------------------------
// Name: InvalidateDeviceObjects()
// Desc: Called when the device-dependent objects are about to be lost.
//-----------------------------------------------------------------------------
HRESULT CFFT3DView::InvalidateDeviceObjects()
{
    m_pFont->InvalidateDeviceObjects();
    m_pFontSmall->InvalidateDeviceObjects();
    SAFE_RELEASE( m_pVB );
    SAFE_RELEASE( m_pVBKoord );
//    SAFE_RELEASE( m_pVBFFT3D);

		if (m_pMesh1!=NULL) 
		{
				FFT3DVERTEX *pVerticesMesh;
				m_pVerticesMeshKopie = new FFT3DVERTEX [m_dwNumVertices];
				HRESULT hr = m_pMesh1->LockVertexBuffer(0, (BYTE**) &pVerticesMesh);
				if(hr != D3D_OK)
          AfxMessageBox(E_FFT3DVIEW_INVALIDATEDEVICEOBJECTS_LOCKVERTEXBUFFER, MB_OK );
				
				for (int u=0;u<m_dwNumVertices;u++) 
				{
					m_pVerticesMeshKopie[u] = pVerticesMesh[u];
				}
				m_pMesh1->UnlockVertexBuffer();
		}
		
    SAFE_RELEASE( m_pMesh1 );

    return S_OK;
}




//-----------------------------------------------------------------------------
// Name: DeleteDeviceObjects()
// Desc: Called when the app is exiting, or the device is being changed,
//       this function deletes any device dependent objects.
//-----------------------------------------------------------------------------
HRESULT CFFT3DView::DeleteDeviceObjects()
{
    m_pFont->DeleteDeviceObjects();
    m_pFontSmall->DeleteDeviceObjects();
    return S_OK;
}




//-----------------------------------------------------------------------------
// Name: FinalCleanup()
// Desc: Called before the app exits, this function gives the app the chance
//       to cleanup after itself.
//-----------------------------------------------------------------------------
HRESULT CFFT3DView::FinalCleanup()
{
		m_FFTPtArray.RemoveAll();
    SAFE_DELETE( m_pFont );
    SAFE_DELETE( m_pFontSmall );
    return S_OK;
}




//-----------------------------------------------------------------------------
// Name: ConfirmDevice()
// Desc: Called during device intialization, this code checks the device
//       for some minimum set of capabilities
//-----------------------------------------------------------------------------
HRESULT CFFT3DView::ConfirmDevice( D3DCAPS8* pCaps, DWORD dwBehavior, 
                                 D3DFORMAT Format )
{
    if( (dwBehavior & D3DCREATE_HARDWARE_VERTEXPROCESSING ) ||
        (dwBehavior & D3DCREATE_MIXED_VERTEXPROCESSING ) )
    {
        if( pCaps->VertexShaderVersion < D3DVS_VERSION(1,0) )
            return E_FAIL;
    }

    return S_OK;
}



void CFFT3DView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	if (g_bIsCapturing||g_bIsPlayingWave) 
				{
					m_Recalc=TRUE;
					Render3DEnvironment();	
				}
				else if (g_bIsPutPoints&&lHint!=2) 
							{
							
								m_Recalc=TRUE;
								OnResetview();
								if (m_bReady&&!g_bIsBreak) DrawMultiple3DFFTs();	
							}
	if (lHint==11) 
	{
		m_Recalc=TRUE;
		OnResetview();
	}
}

void CFFT3DView::OnSize(UINT nType, int cx, int cy) 
{
	if (m_bReady==1) 
	{
//		m_bNetzNeu=TRUE;
		// Halt frame movement while the app is sizing or moving
		Pause( TRUE );

		// Check to see if we are losing our window...
		if( SIZE_MAXHIDE==nType || SIZE_MINIMIZED==nType )
	  {	
		  if( m_bClipCursorWhenFullscreen && !m_bWindowed )
			   ClipCursor( NULL );
	    m_bActive = FALSE;
		}
	  else
		  m_bActive = TRUE;

	  Pause( FALSE );

		if( m_bActive && m_bWindowed )
	  {
		  RECT rcClientOld;
			rcClientOld = m_rcWindowClient;

			// Update window properties
		  GetWindowRect( &m_rcWindowBounds );
	    GetClientRect( &m_rcWindowClient );

	    if( rcClientOld.right - rcClientOld.left != m_rcWindowClient.right - m_rcWindowClient.left ||
			    rcClientOld.bottom - rcClientOld.top != m_rcWindowClient.bottom - m_rcWindowClient.top)
		  {
				// A new window size will require a new backbuffer
				// size, so the 3D structures must be changed accordingly.
			  m_bReady = FALSE;

		    m_d3dpp.BackBufferWidth  = m_rcWindowClient.right - m_rcWindowClient.left;
	      m_d3dpp.BackBufferHeight = m_rcWindowClient.bottom - m_rcWindowClient.top;

		    // Resize the 3D environment
				if( FAILED( Resize3DEnvironment() ) )
					DisplayErrorMsg( D3DAPPERR_RESIZEFAILED, MSGERR_APPMUSTEXIT );

				m_bReady = TRUE;
			}
		}
	}
}

void CFFT3DView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	m_bKey[nChar]=1;
	Render3DEnvironment();

	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CFFT3DView::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	m_bKey[nChar]=0;

	CView::OnKeyUp(nChar, nRepCnt, nFlags);
}

void CFFT3DView::OnTogglehelp() 
{
  m_bShowHelp = !m_bShowHelp;
	Render3DEnvironment();
}

void CFFT3DView::OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView) 
{
  m_bHasFocus = bActivate;
	
	CView::OnActivateView(bActivate, pActivateView, pDeactiveView);
}

void CFFT3DView::OnTogglestart() 
{
  // Toggle frame movement
  m_bFrameMoving = !m_bFrameMoving;
  DXUtil_Timer( m_bFrameMoving ? TIMER_START : TIMER_STOP );
}

void CFFT3DView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	m_ptPrev = point;
	CView::OnLButtonDown(nFlags, point);
}

void CFFT3DView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	m_ptPrev = point;
	CView::OnRButtonDown(nFlags, point);
}

void CFFT3DView::OnLButtonUp(UINT nFlags, CPoint point) 
{
/*	for(int i=0; i<256; i++)
	{
		m_bKey[i]=0;
	}
*/	
	CView::OnLButtonUp(nFlags, point);
}

void CFFT3DView::OnRButtonUp(UINT nFlags, CPoint point) 
{
/*	for(int i=0; i<256; i++)
	{
		m_bKey[i]=0;
	}
*/	
	CView::OnRButtonUp(nFlags, point);
}

void CFFT3DView::OnMouseMove(UINT nFlags, CPoint point) 
{
	m_Recalc=FALSE;
	// Wird aufgerufen, wenn die Maus bewegt wird.
  if (nFlags==MK_RBUTTON)
  {
	  if ((m_ptPrev.x-point.x)<0) DoFrameMove(VK_NUMPAD6);//m_bKey[VK_NUMPAD6]=1; //Maus nach links
		if ((m_ptPrev.x-point.x)>0) DoFrameMove(VK_NUMPAD4);//m_bKey[VK_NUMPAD4]=1; //Maus nach rechts
	  if ((m_ptPrev.y-point.y)<0) DoFrameMove(VK_NUMPAD2);//m_bKey[VK_NUMPAD2]=1; //Maus nach unten
		if ((m_ptPrev.y-point.y)>0) DoFrameMove(VK_NUMPAD8);//m_bKey[VK_NUMPAD8]=1; //Maus nach oben
//   if (!g_bIsPlayingWave&&!g_bIsCapturing&&!g_bIsPutPoints)
//			FrameMove();
//		Render3DEnvironment();
	}

  if (nFlags==MK_LBUTTON)
  {
	  if ((m_ptPrev.x-point.x)<0) DoFrameMove('C');//m_bKey['C']=1;//Maus nach links
	  if ((m_ptPrev.x-point.x)>0) DoFrameMove('X');//m_bKey['X']=1;//Maus nach rechts
	  if ((m_ptPrev.y-point.y)<0) DoFrameMove('V');//m_bKey['V']=1; //Maus nach unten
	  if ((m_ptPrev.y-point.y)>0) DoFrameMove('B');//m_bKey['B']=1;//Maus nach oben
//    if (!g_bIsPlayingWave&&!g_bIsCapturing&&!g_bIsPutPoints)
//			FrameMove();
//		Render3DEnvironment();
  }

//	for(int i=0; i<256; i++)
//	{
//		m_bKey[i]=0;
//	}

	m_ptPrev = point;
	CView::OnMouseMove(nFlags, point);
}

void CFFT3DView::OnSinglestep() 
{
  // Single-step frame movement
  if( FALSE == m_bFrameMoving )
    DXUtil_Timer( TIMER_ADVANCE );
  else
    DXUtil_Timer( TIMER_STOP );
  m_bFrameMoving = FALSE;
  m_bSingleStep  = TRUE;
}

void CFFT3DView::OnChangedevice() 
{
  HRESULT hr;
  // Prompt the user to select a new device or mode
  if( m_bActive && m_bReady )
  {
		m_bReady=FALSE;
		//    Pause(TRUE);

    // Can't display dialogs in fullscreen mode
    if( m_bWindowed == FALSE )
    {
        if( FAILED( ToggleFullscreen() ) )
        {
            DisplayErrorMsg( D3DAPPERR_RESIZEFAILED, MSGERR_APPMUSTEXIT );
        }
    }

		CGrafikDeviceDlg Dlg;
		Dlg.m_FFTView=this;
		Dlg.m_bReko=FALSE;
		if (Dlg.DoModal()==IDOK) 
		{

	    // Get access to the newly selected adapter, device, and mode
			DWORD dwDevice;
		  dwDevice  = m_Adapters[m_dwAdapter].dwCurrentDevice;
	    m_bWindowed = m_Adapters[m_dwAdapter].devices[dwDevice].bWindowed;

			// Release all scene objects that will be re-created for the new device
		  InvalidateDeviceObjects();
	    DeleteDeviceObjects();

		  // Release display objects, so a new device can be created
	    if( m_pd3dDevice->Release() > 0L )
        DisplayErrorMsg( D3DAPPERR_NONZEROREFCOUNT, MSGERR_APPMUSTEXIT );

		  // Inform the display class of the change. It will internally
	    // re-create valid surfaces, a d3ddevice, etc.
			CSoundsDoc* pDoc=GetDocument();
	    if( FAILED( hr = Initialize3DEnvironment() ) )
			{
        DisplayErrorMsg( hr, MSGERR_APPMUSTEXIT );
				m_bReady=FALSE;
				pDoc->m_bIsNot3D=TRUE;
				goto Stop;
			}

			// If the app is paused, trigger the rendering of the current frame
		  if( FALSE == m_bFrameMoving )
			{
        m_bSingleStep = TRUE;
        DXUtil_Timer( TIMER_START );
        DXUtil_Timer( TIMER_STOP );
	    }
    }
		m_bReady=TRUE;
		Render3DEnvironment();
  }
Stop:
	;
}

BOOL CFFT3DView::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
	if (nFlags==MK_CONTROL) 
	{
		if (zDelta>0) 
		  DoFrameMove('K');//m_bKey['K']=1;
		else
		  DoFrameMove('L');//m_bKey['L']=1;
	}
	if (nFlags==MK_SHIFT) 
	{
		if (zDelta>0) 
		  DoFrameMove('O');//m_bKey['O']=1;
		else
		  DoFrameMove('P');//m_bKey['P']=1;
	}
	if (nFlags==0) 
	{
		if (zDelta>0) 
		  DoFrameMove('N');//m_bKey['N']=1;
		else
		  DoFrameMove('M');//m_bKey['M']=1;
	}
	return CView::OnMouseWheel(nFlags, zDelta, pt);
}


void CFFT3DView::DoFrameMove(char Buchstabe) 
{
	m_bKey[Buchstabe]=1;	
	if (m_bReady) 
	{
		FrameMove();
		Render3DEnvironment();
	}
	m_bKey[Buchstabe]=0;	
}

void CFFT3DView::OnButtonDrehxl() 
{
	DoFrameMove('O');
}

void CFFT3DView::OnButtonDrehxr() 
{
	DoFrameMove('P');
}

void CFFT3DView::OnButtonDrehyl() 
{
	DoFrameMove('K');
}

void CFFT3DView::OnButtonDrehyr() 
{
	DoFrameMove('L');
}

void CFFT3DView::OnButtonDrehzl() 
{
	DoFrameMove('M');
}

void CFFT3DView::OnButtonDrehzr() 
{
	DoFrameMove('N');
}

void CFFT3DView::OnButtonTransxl() 
{
	DoFrameMove('X');
}

void CFFT3DView::OnButtonTransxr() 
{
	DoFrameMove('C');
}

void CFFT3DView::OnButtonTransyl() 
{
	DoFrameMove('V');
}

void CFFT3DView::OnButtonTransyr() 
{
	DoFrameMove('B');
}

void CFFT3DView::OnButtonTranszl() 
{
	DoFrameMove('G');
}

void CFFT3DView::OnButtonTranszr() 
{
	DoFrameMove('H');
}

void CFFT3DView::OnResetview() 
{
	if (m_bReady) 
	{
		m_counter=0;
		OneTimeSceneInit();

    m_pd3dDevice->SetTransform( D3DTS_VIEW, &m_matView );
		m_pd3dDevice->SetRenderState(D3DRS_LIGHTING, TRUE); 
		m_pd3dDevice->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW); 
		m_pd3dDevice->SetRenderState(D3DRS_DIFFUSEMATERIALSOURCE, D3DMCS_COLOR1);
		Render3DEnvironment();
	}
}

void CFFT3DView::OnBkgclr() 
{
	CColorDialog dlgColor(m_clrBkg);
	if (dlgColor.DoModal() == IDOK)
	{
		m_clrBkg = dlgColor.GetColor();
		m_clrBackBuffer=D3DCOLOR_XRGB(GetRValue(m_clrBkg),GetGValue(m_clrBkg),GetBValue(m_clrBkg));
		m_clrText=TRGB(GetRValue(m_clrBkg),GetGValue(m_clrBkg),GetBValue(m_clrBkg));
		m_FarbButtonBkg.SetColour(m_clrText,m_clrBkg);
		m_Recalc=TRUE;
		if (m_bReady) 
		 	Render3DEnvironment();
	}
}

void CFFT3DView::OnFarbwahl() 
{
	CColorDialog dlgColor(m_clrReko);
	if (dlgColor.DoModal() == IDOK)
	{
		m_clrRekoREF = dlgColor.GetColor();
		m_pRadioFesteFarbe=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_FESTEFARBE);
		m_pRadioFesteFarbe->SetCheck(1);
		m_pRadioBunt=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_BUNT);
		m_pRadioBunt->SetCheck(0);
		m_clrReko=D3DCOLOR_XRGB(GetRValue(m_clrRekoREF),GetGValue(m_clrRekoREF),GetBValue(m_clrRekoREF));
		m_FarbButton.SetColour(m_clrText,m_clrRekoREF);
		m_bIsBunt=FALSE;
		RedrawMesh();
	}
}

void CFFT3DView::OnFestefarbe() 
{
	m_FarbButton.SetColour(m_clrText,m_clrRekoREF);
	m_clrReko=D3DCOLOR_XRGB(GetRValue(m_clrRekoREF),GetGValue(m_clrRekoREF),GetBValue(m_clrRekoREF));
	m_bIsBunt=FALSE;
	RedrawMesh();
}

void CFFT3DView::OnBunt() 
{
	m_FarbButton.SetColour(GetSysColor(COLOR_INACTIVECAPTION),GetSysColor(COLOR_MENU));
	m_bIsBunt=TRUE;
	RedrawMesh();
}

void CFFT3DView::OnFaces() 
{
	m_pRadioLinien=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_WIRE);
	m_pRadioLinien->SetCheck(0);
	m_pRadioFaces=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_FACES);
	m_pRadioFaces->SetCheck(1);
	m_bIsWire=FALSE;
	m_Recalc=TRUE;
	if (m_bReady) 
 		Render3DEnvironment();
}

void CFFT3DView::OnWire() 
{
	m_pRadioLinien=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_WIRE);
	m_pRadioLinien->SetCheck(1);
	m_pRadioFaces=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_FACES);
	m_pRadioFaces->SetCheck(0);
	m_bIsWire=TRUE;
	m_Recalc=TRUE;
	if (m_bReady) 
 		Render3DEnvironment();
}

void CFFT3DView::OnChangeEpsilonFeld() 
{
	INT Wert=m_pParentFFTFrame->m_wndDlgBar.GetDlgItemInt(IDC_EPSILON_FELD2);
	m_Epsilon=(FLOAT)((FLOAT)Wert/100);
	RedrawMesh();
}

void CFFT3DView::OnScaleAmpLin() 
{
	m_bIsAmpLinear=TRUE;
	RedrawMesh();
}

void CFFT3DView::OnScaleAmpLog() 
{
	m_bIsAmpLinear=FALSE;
	RedrawMesh();
}

void CFFT3DView::OnScaleFreqLin() 
{
	m_bIsFreqLinear=TRUE;
	RedrawMesh();
}

void CFFT3DView::OnScaleFreqLog() 
{
	m_bIsFreqLinear=FALSE;
	RedrawMesh();
}

void CFFT3DView::OnReleasedcaptureBreiteSlider(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CSliderCtrl* SliderCtrl=(CSliderCtrl*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_BREITE_SLIDER);
	m_Breite=SliderCtrl->GetPos();
	RedrawMesh();
	*pResult = 0;
}

void CFFT3DView::OnChangeBottomcutFeld() 
{
	m_BottomCutHz=m_pParentFFTFrame->m_wndDlgBar.GetDlgItemInt(IDC_BOTTOMCUT_FELD);
	RedrawMesh();
}

void CFFT3DView::RedrawMesh() 
{
	m_Recalc=TRUE;
	m_bNetzNeu=TRUE;
	if (m_bReady) 
	{
		m_counter=0;
		DrawMultiple3DFFTs();
 		Render3DEnvironment();
	}
}

void CFFT3DView::OnChangeTopcutFeld() 
{
	m_TopCutkHz=m_pParentFFTFrame->m_wndDlgBar.GetDlgItemInt(IDC_TOPCUT_FELD);
	RedrawMesh();
}

void CFFT3DView::OnEditClearall() 
{
	CSoundsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->DeleteContents();
	m_counter=0;
 	Render3DEnvironment();
	pDoc->UpdateAllViews(NULL,50);
}

void CFFT3DView::OnEditCopy() 
{
	CDC* pDC=GetDC();
	CMetaFileDC * pMetaDC = new CMetaFileDC();
	pMetaDC->CreateEnhanced(GetDC(),NULL,NULL,"SOUNDS Soundanalyse\03D FFT Abbild\0\0");
	//draw meta file
	CRect rect;
	GetClientRect(rect);

	pMetaDC->BitBlt(0,0,rect.right,rect.bottom,pDC,0,0,SRCCOPY);
	//close meta file dc and prepare for clipboard;
	HENHMETAFILE hMF = pMetaDC->CloseEnhanced();

	//copy to clipboard
	// Open the clipboard...
	if(!OpenClipboard()) 
	{
    AfxMessageBox(IDS_OPEN_CLIPBOARD_FAIL);
    return;
	}
	EmptyClipboard();
	::SetClipboardData(CF_ENHMETAFILE,hMF);
	CloseClipboard();
	//DeleteMetaFile(hMF);
	delete pMetaDC;
}

void CFFT3DView::OnSave() 
{
	HRESULT hr;
	CFileDialog FotoFileDlg(FALSE,NULL,NULL,OFN_OVERWRITEPROMPT|OFN_NOREADONLYRETURN|OFN_ENABLESIZING,\
              "BMP - Bitmap File|*.bmp|DDS - DirectDraw Surface File|*.dds|");
  FotoFileDlg.m_ofn.nFilterIndex=1;
	FotoFileDlg.m_ofn.lpstrDefExt=".bmp";
	CString Text;
	Text.LoadString(IDS_SAVE_FFT3D);
	FotoFileDlg.m_ofn.lpstrTitle=Text.GetBuffer(Text.GetLength());
  if (FotoFileDlg.DoModal()==IDOK) 
	{
		CString Pfad=FotoFileDlg.GetPathName();
		LPTSTR strFileName=Pfad.GetBuffer(MAX_PATH);
		// get the backbuffer description
	  LPDIRECT3DSURFACE8 backbuf;
		if(FAILED(hr=m_pd3dDevice->GetBackBuffer(0,D3DBACKBUFFER_TYPE_MONO,&backbuf))) 
       goto Ende;

	  D3DSURFACE_DESC desc;
		hr=backbuf->GetDesc(&desc);
		if(FAILED(hr))
       goto Ende;

	  // create the image buffer
		LPDIRECT3DSURFACE8 surf;
	  if (FAILED(hr=m_pd3dDevice->CreateImageSurface(desc.Width,desc.Height,desc.Format,&surf))) 
       goto Ende;

		// copy the image buffer and release the back buffer
	  hr=D3DXLoadSurfaceFromSurface(surf,NULL,NULL,backbuf,NULL,NULL,D3DX_FILTER_NONE,0);
		backbuf->Release();
	  if (FAILED(hr)) 
			surf->Release();
		else
		{
			D3DXIMAGE_FILEFORMAT FileFormat;
			if (FotoFileDlg.m_ofn.nFilterIndex==1) 
				FileFormat=D3DXIFF_BMP;
			else
				FileFormat=D3DXIFF_DDS;
			
			//Finally, we call D3DXSaveSurfaceToFile() to create the file, 
			//and release the temporary image surface:
			hr=D3DXSaveSurfaceToFile(strFileName,FileFormat,surf,NULL,NULL);

			// release the image surface
			surf->Release();
		}
	}
Ende:
	;
}


BOOL CFFT3DView::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	CSoundsDoc* pDoc=GetDocument();
	pDoc->m_help.SetHelpFile(pDoc->m_strHelpFile);
	pDoc->m_help.DisplayTopic("html/DreidimensionaleFouriertransformationsdarstellung.html");
	
	
	return CView::OnHelpInfo(pHelpInfo);
}


void CFFT3DView::CalcWindowRect(LPRECT lpClientRect, UINT nAdjustType) 
{

	if (lpClientRect->left==lpClientRect->right) 
	{
		lpClientRect->right+=1;
	}
	if (lpClientRect->top==lpClientRect->bottom) 
	{
		lpClientRect->bottom+=1;
	}
	CView::CalcWindowRect(lpClientRect, nAdjustType);
}
