// why are min(), max(), fmax() etc. not available in standard libraries?
//    oh, at least fmax() is available, but from g++-3.1 on
/*inline long min(long x, long y) {
	if (x<y) {
		return x;
	} else {
		return y;
	}
}

inline long max(long x, long y) {
	if (x>y) {
		return x;
	} else {
		return y;
	}
}
*/

/*// unfortunately strtol() declares the 'end' pointer not as const
// thus we have to omit, too
bool wavargtol(const_string str, const_string &end, long &l) {
	if (*str != ',') { return false; }
	l = strtol(str+1, &(char *)end, 10);  // strtol will really not change the contents of the string, but strtol has not declared that
	while (isspace(*end)) {end++;}
	return *end == 0 || *end == ',' ;
}
*/
bool wavargtof(const_string str, char* &end, float &f) {
	if (*str != ',') { return false; }
	f = strtod(str+1, &end);
	while (isspace(*end)) 
	{
		end++;
	}
	return *end == 0 || *end == ',' ;
}


void get_valuepair(char key, const char *arg, float &vmin, float &vmax) {
	if (sscanf(arg, "%g,%g", &vmin, &vmax)!=2) {
		printf("You specified '%s' but for the '-%c' option we need two comma separated numbers.\ne.g. -%c 1,10\n",
			       arg, key, key);
		exit(1);
	//} else if (vmin > vmax) {
	//	printf("Minimum must be smaller than maximum. %s is invalid.\n", arg);
	//	exit(1);
	}
}

void check_scalerange (char key, const char *arg, float &amin, float &amax) {
	if (sgn(amin) != sgn(amax)) {
		printf("Scales must always have the same sign, %s have not. (Option -%c)\n", arg, key);
		exit(1);
	} else if (amin == 0) {
		printf("Scales must not be zero.\n");
		exit(1);
	};
}


/* based on example 3 of argp at http://www.gnu.org/manual/glibc-2.2.3/html_node/libc_536.html */
const char *argp_program_version = "CWT";
const char *argp_program_bug_address = "nobody";

/* Program documentation. */
static char doc[] =	"CWT -- compute the continuous wavelet transform of given signals and wavelets";

/* A description of the arguments we accept. */
static char args_doc[] = "";





// I don't know, what it means, if it ever worked, if it still work, how it can be simplified with standard functions
complex<float> cauchy(float x, complex<float> l, float m1, float m2)
{
	complex<float> alpha=complex<float>(0,m1)-(complex<float>(0,m2)*l-complex<float>(0.5,0));
	complex<float> z=complex<float>(x,0)-l;
	x=abs(z);
	float phi=-arg(z);
	complex<float> p=complex<float>(0,phi)*alpha;
	float alpha1=alpha.real(),
			alpha2=alpha.imag();

	float beta = alpha2*log(x)*p.real();
	z=complex<float>(cos(beta),sin(beta));
	x=pow(x,alpha1)*exp(p.real());

	return -x*z;
}

void get_signalsupp(const arguments &arguments, const wavelet_fkt *wf, long &totalbegin, long &totalend) {
	long sparebegin, spareend;
	wf->get_max_supp (arguments, sparebegin, spareend);
	totalbegin = min(arguments.bminint,arguments.bmaxint) + sparebegin;
	totalend   = max(arguments.bminint,arguments.bmaxint) + spareend;
	printf("bmin %ld, bmax %ld, sparebegin %ld, spareend %ld\n", arguments.bminint, arguments.bmaxint, sparebegin, spareend);
}

inline float doubchar2float (signed char hi, unsigned char lo) {
	//("hi %d, lo %d, hi<<8 + lo %d\n", hi<<8, lo,(hi<<8) + lo);
	// although '<<' is a multiplication operation, it has lower precedence than '+' ... C sucks ...
	return float((int(hi)<<8) + int(lo)) / 0x8000;
};



// element wise add or sub files containing real data sets
// you must preserve, that the files have the same length
// the ".dat" extension must be left out
void superimpose_dat (const_string outfilename, const_string inafilename, const_string inbfilename, superimpose_modes mode) {
/*	safe_file inafile(wfopen (inafilename, ".dat", "r"));
	safe_file inbfile(wfopen (inbfilename, ".dat", "r"));
	safe_file outfile(wfopen (outfilename, ".dat", "w"));
	float xa, xb;
	if (mode==sub) {
		while (fscanf(inafile.cfile(), "%g", &xa)==1 && fscanf(inbfile.cfile(), "%g", &xb)==1) {
			fprintf(outfile.cfile(), "%g\n", xa-xb);
		};
	} else {
		while (fscanf(inafile.cfile(), "%g", &xa)==1 && fscanf(inbfile.cfile(), "%g", &xb)==1) {
			fprintf(outfile.cfile(), "%g\n", xa+xb);
		};
	}
	*/
};

void delete_dat (const_string filename) {
	safe_string fullname (strlen(filename)+4);
	fullname.append (filename);
	fullname.append (".dat");
	//printf("remove %s\n", fullname.cstr());
	remove(fullname.cstr());
};


// output in z; y must be a buffer of length zlen+wlen-1
void convolute_sampleddata(float *z, long zlen, const float *y, const float *w, long wlen) {
	for (;zlen>0;(zlen--,z++,y++)) {
		float zacc = 0;
		const float *yc = y;
		const float *wc = w;
		long wl;
		for (wl = wlen; wl>0; wl--) {
			zacc += *yc * *wc;
			yc++;
			wc++;
		}
		*z = zacc;
	}
}

float dotproduct(const float *x, const float *y, long len) {
	float acc = 0;
	for (;len>0;(len--,x++,y++)) {
		acc += *x * *y;
	}
	return acc;
}




inline complex<float> expi (float angle) {
#ifdef HAVE_SINCOS
	double cosx, sinx;
	sincos (angle, &sinx, &cosx);
	return complex<float>(cosx,sinx);
#else
	return complex<float>(cos(angle),sin(angle));
#endif
}


// modulate the complex signal in yr,yi with a complex screw with frequency 'angle' starting at phase 'phase'
// output in zr,zi
// very slow
void modulate(float *zr, float *zi, const float *yr, const float *yi, long len, float phase, float angle) {
	for (;len-->0;(zr++,zi++,yr++,yi++,phase+=angle)) {
		complex<float> dz = expi(phase);
		*zr = *yr * dz.real() - *yi * dz.imag();
		*zi = *yr * dz.imag() + *yi * dz.real();
	}
}


// same function as 'modulate' but with only log(len) calls to the expensive cos() and sin() routines
void fast_modulate(float *zr, float *zi, const float *yr, const float *yi, long len, float phase, float angle) {
	int loglen = 1;
	long tmplen = len;
	while(tmplen>0) {
		loglen++;
		tmplen/=2;
	};

	// following invariant is always kept up to date:
	//   the angle represented in cb[k].backup is the highest multiple of 'angle*2^k' which is less or equal to the currently required angle
	struct complexbit {
		complex<float> backup, incr;
	};
	complexbit *cb = new complexbit[loglen];
	{
		int k;
		complex<float> startc = expi(phase);
		long twopow=1;
		for (k=0; k<loglen; k++) {
			cb[k].incr   = expi(angle*twopow);
			cb[k].backup = startc;
			twopow <<= 1;
		}
	}

	long n;
	for (n=0;n<len;(zr++,zi++,yr++,yi++)) {
		float cosp = cb[0].backup.real();
		float sinp = cb[0].backup.imag();
		*zr = *yr * cosp - *yi * sinp;
		*zi = *yr * sinp + *yi * cosp;
		n++;
		long tmpn = n;
		complexbit *curcb;
		// ooops '&' seems to have lower precedence than '=='
		for (curcb=cb; (tmpn&1) == 0; curcb++) {
			tmpn >>= 1;
		}
		//printf("n %ld, k %d, tmpn %ld\n", n, k, tmpn);
		complex<float> newc = curcb[1].backup * curcb[0].incr;
		for (; curcb>=cb; curcb--) {
			curcb->backup = newc;
		}
	}
	delete[] cb;
}

// smooth with a characteristic function of [0,n)
// the input buffer 'y' must have 'n' words more than 'z'
void smooth(float *z, const float *y, long len, long n) {
	float acc=0;
	const float *yo = y;
	long i;
	for (i=n;i-->0;y++) {
		acc += *y;
	}
	float nf = 1.0/float(n);
	for (;len-->0;(z++,yo++,y++)) {
		*z = acc*nf;
		acc -= *yo;
		acc += *y;
	}
}

// smooth with a characteristic function of [0,t) where t might be a fractional number
// the fractional behaviour is achieved by linear interpolation
// the input buffer 'y' must have 'ceil(t)' words more than 'z'
void fract_smooth(float *z, const float *y, long len, float t) {
	float acc=0;
	const float *yo = y;
	double floort;
	float frac;
	frac = modf(t,&floort);
	//printf("fract_smooth t %g, floor %g, frac %g\n", t, floort, frac);
	long n=long(floort);
	long i;
	for (i=n;i-->0;y++) {
		acc += *y;
	}
	float nf = 1.0/t;
	for (;len-->0;(z++,yo++,y++)) {
		*z = (acc+*y*frac)*nf;
		acc -= *yo;
		acc += *y;
	}
}

// smooth with a characteristic function of [-t,t] where t might be a fractional number
// the fractional behaviour is achieved by linear interpolation
// the input buffer 'y' must have 'ceil(t)' words more than 'z'
void fract_sym_smooth(float *z, const float *y, long len, float t) {
	double floort;
	float frac = modf(t,&floort);
	//printf("fract_smooth t %g, floor %g, frac %g\n", t, floort, frac);
	long n=long(floort);
	y-=n;
	const float *yo = y-1;

	float acc=0;
	long i;
	for (i=2*n;i-->0;y++) {
		acc += *y;
	}
	float nf = 0.5/t;
	for (;len-->0;(z++,y++)) {
		*z = (acc+(*y+*yo)*frac)*nf;
		yo++;
		acc -= *yo;
		acc += *y;
	}
}


float mintegral(const signal_fkt *sf, complex_component scc, const float *w, long n, const wavelet_fkt *wf, float a, float b)     //Mittelpunktsregel
{
	float h=(wf->rsupp-wf->lsupp)/float(n);
	//M+=(*w)*sf->evaluate_imag(b+(wf->lsupp+float(k)*h)*a);
	float ha = h*a;
	float bla = b+wf->lsupp*a;
	float M=0;
	long k;
	if (scc == cc_imag) {
		for(k=0; k<n; (k++,w++)) {
			M+=(*w)*sf->evaluate_imag(bla+float(k)*ha);
		}
	} else {
		for(k=0; k<n; (k++,w++)) {
			M+=(*w)*sf->evaluate_real(bla+float(k)*ha);
		}
	}

//printf("M=%g\n", M);
	return M;
}; // end mintegral

void store_inf (const char *outputbasename, const char *ext, const wavelet_fkt *wf, const arguments& arguments) {
/*	safe_file file(wfopen(outputbasename,ext,"w"));
	fprintf(file.cfile(),"%g\n%g\n",wf->rsupp-wf->lsupp,arguments.samplerate);
	arguments.a.write(file.cfile()); fprintf(file.cfile(),"%d\n",arguments.adiv);
	arguments.b.write(file.cfile());
	*/
};

// convert the wavelet coefficients to a pgm file and display them if requested
// could also be used for the output of the data sets 'phase', 'absolute'
// but they are implemented more efficiently. Another problem are that 'min' and 'max'
// are fix for the phase image
void convert_dat2pgm(const char *outputbasename, const wavelet_fkt *wf, const arguments &arguments,
										 CArray<FLOAT,FLOAT>* pWaveletCoeffizients) 
{
//	store_inf (outputbasename, ".inf", wf, arguments);

	float max=0,min=0;
	long nab = arguments.a.n*arguments.b.n;
	{
		float F;
		F=pWaveletCoeffizients->GetAt(0);
		min=F;	// this allows to obtain the real min, even if it is above 0
		max=F;
		long i;
		for(i=1; i<nab; i++) {
			F=pWaveletCoeffizients->GetAt(i);
			refresh_bounds (F, min, max);
		}
//			char debug_name[100];
//			sprintf(debug_name,"c://Dumps//debug_coeffizientsbeforScaling.txt");
//			write_signal(debug_name,pWaveletCoeffizients->GetData(),nab);
	}
/*
//	float max=0,min=0;
//	long nab = arguments.a.n*arguments.b.n;
	{
		safe_file file(wfopen(outputbasename,".dat","r"));
		float F;
		fscanf(file.cfile(),"%g\n",&F);
		min=F;	// this allows to obtain the real min, even if it is above 0
		max=F;
		long i;
		for(i=1; i<nab; i++) {
			fscanf(file.cfile(),"%g\n",&F);
			refresh_bounds (F, min, max);
		}
	}
*/	if (min==max) {
		/* will only occur if the wavelet or the signal is constant, but possible different from zero
		    - in this case, any maximum value but zero is ok */
		min -= 0.01f;
		max += 0.01f;
	};

	// Skalierung auf 0-255 fuer xv-Format + Ausgabe in wt.pgm
	// natuerliche skalierung
	{
		float F;
		long N,i;
		for(i=0; i<nab; i++) 
		{
			F=pWaveletCoeffizients->GetAt(i);
	 		N=(long)(255/(max-min)*(F-min));  // fuer xv-view
			pWaveletCoeffizients->SetAt(i,N);

		}//for
//			char debug_name[100];
//			sprintf(debug_name,"c://Dumps//debug_coeffizients.txt");
//			write_signal(debug_name,pWaveletCoeffizients->GetData(),nab);
	}
//	view_result(outputbasename,".pgm",arguments.graphic,arguments.imgviewer);

/*	
	// Skalierung auf 0-255 fuer xv-Format + Ausgabe in wt.pgm
	// natuerliche skalierung
	{
		safe_file afile(wfopen(outputbasename,".dat","r"));
		safe_file bfile(wfopen(outputbasename,".pgm","w"));
		printhbar();
		printf("   scaling the wavelet transform for output ...\n");
		fprintf(bfile.cfile(),"P2\n%ld  %ld\n255\n",arguments.b.n,arguments.a.n);
		float F;
		long N,i;
		for(i=0; i<nab; i++) {
			fscanf(afile.cfile(),"%g\n",&F);
	 		N=(long)(255/(max-min)*(F-min));  // fuer xv-view
	 		fprintf(bfile.cfile(),"%ld\n",N);
		}//for
	}
//	view_result(outputbasename,".pgm",arguments.graphic,arguments.imgviewer);

	// Skalierung auf 0-255 fuer xv-Format + Ausgabe in wt.pgm
	// der Absolutwerte der wt
	{
		safe_file afile(wfopen(outputbasename,".dat","r"));
		safe_file bfile(wfopen(outputbasename,".abs.pgm","w"));
		printhbar();
		printf("   scaling the wavelet transform (absolut value) for output ...\n");
		if(fabs(min)>max) {
			max=fabs(min);
		}
		fprintf(bfile.cfile(),"P2\n%ld  %ld\n255\n",arguments.b.n,arguments.a.n);
		float F;
		long N,i;
		for(i=0; i<nab; i++) {
			fscanf(afile.cfile(),"%g\n",&F);
	 		N=(long)(255/max*fabs(F));  // fuer xv-view
	 		fprintf(bfile.cfile(),"%ld\n",N);
		}//for
	}
*/	// removed for more clearance
	// view_result(outputbasename,".abs.pgm",arguments.graphic,arguments.imgviewer);
}

void wavelettransform(const signal_fkt *sf, complex_component scc, const wavelet_fkt *wf, division_range *adiv, const char *outputbasename, 
											const arguments &arguments,CArray<FLOAT,FLOAT>* pWaveletCoeffizients) //Proz. zur Berechnung der WT
{
	//Berechnung der Wavelettransformation + Ausgabe in wt.dat

//	safe_file file(wfopen(outputbasename,".dat","w"));
//	printhbar();
//	printf("   compute the wavelet transform with:   %s ...\n ", wf->namewave);
//	arguments.print_wtinfo();


	float bstep = (arguments.b.max-arguments.b.min)*arguments.samplerate/arguments.b.n;
	pWaveletCoeffizients->RemoveAll();
	pWaveletCoeffizients->SetSize(arguments.a.n*arguments.b.n);

	time_t cta = time(NULL);
	if (arguments.usesignalrate) {
		long lmaxpos, rmaxpos;
		wf->get_max_supp (arguments, lmaxpos, rmaxpos);
// a somewhat inefficient implementation
#ifdef MachineTooFast
		long size = arguments.bmaxint - arguments.bminint;
		safe_signal ws(size);  // seems to be a name already existing in 'istream'
#endif
		safe_signal w(rmaxpos-lmaxpos);
		// ***************** dangerous --- deallocation might be skipped by an exception
		const float *s  = sf->discretize(arguments,wf,scc);

		long hna;
		for(hna = arguments.a.n; hna>0; hna--) {
			float a = adiv->get_nth(hna);
			float as = a*arguments.samplerate;
			long lpos, rpos;
			wf->get_supp (as, lpos, rpos);
			wf->discretize (w.cptr()-lpos, lpos, rpos, 1.0/as, 1.0/sqrt(fabs(a)*wf->cpsi));
#ifdef MachineTooFast
			convolute_sampleddata (ws.cptr(), size, s-lmaxpos+lpos, w.cptr(), rpos-lpos);
			long hnb;
			float b;
			for((hnb = arguments.b.n, b = 0); hnb>0; (hnb--, b+=bstep)) {
//				fprintf(file.cfile(),"%g \n",ws.cptr()[(long)b]);
				pWaveletCoeffizients->SetAt((arguments.a.n-hna)*arguments.b.n+(arguments.b.n-hnb),ws.cptr()[(long)b]);
//				pWaveletCoeffizients->Add(ws.cptr()[(long)b]);
   		}
#else
			long hnb;
			float b;
			const float *wl = s-lmaxpos+lpos;
			for((hnb = arguments.b.n, b = 0); hnb>0; (hnb--, b+=bstep)) {
//				fprintf(file.cfile(),"%g \n",dotproduct(wl+(long)b, w.cptr(), rpos-lpos));
 				pWaveletCoeffizients->SetAt((arguments.a.n-hna)*arguments.b.n+(arguments.b.n-hnb),dotproduct(wl+(long)b, w.cptr(), rpos-lpos));
// 				pWaveletCoeffizients->Add(dotproduct(wl+(long)b, w.cptr(), rpos-lpos));
  		}
#endif
		}
		sf->free_discretized(s);

	} else {
//printf("wf->rsupp %g, wf->lsupp %g\n", wf->rsupp, wf->lsupp);
		float h = float(arguments.mi)/(wf->rsupp-wf->lsupp);
		long lpos = long(wf->lsupp*h);
		long rpos = lpos+arguments.mi;
		safe_signal w(arguments.mi);
		wf->discretize (w.cptr()-lpos, lpos, rpos, 1.0/h, 1.0/sqrt(wf->cpsi));

//printf("arguments.mi %ld\n", arguments.mi);
		long hna;
		for(hna = arguments.a.n; hna>0; hna--) {
			float a = adiv->get_nth(hna);
			float as = a * arguments.samplerate;
			float yc = sqrt(h*fabs(a));
			long hnb;
			float b;
			for((hnb = arguments.b.n, b = arguments.b.min*arguments.samplerate); hnb>0; (hnb--, b+=bstep)) {
				//printf("hnb %ld\n", hnb);
//				fprintf(file.cfile(),"%g \n",yc*mintegral(sf,scc,w.cptr(),arguments.mi,wf,as,b));
				pWaveletCoeffizients->SetAt((arguments.a.n-hna)*arguments.b.n+(arguments.b.n-hnb),
																	yc*mintegral(sf,scc,w.cptr(),arguments.mi,wf,as,b));
//				pWaveletCoeffizients->Add(yc*mintegral(sf,scc,w.cptr(),arguments.mi,wf,as,b));
   		}
   		//printf("     \033[A %d percent\n", (long)(100*l/(arguments.a.n*arguments.b.n)));
		}
	}
	time_t ctb = time(NULL);
	CString Zeit;
	sprintf(Zeit.GetBuffer(100),"   needed %.2f seconds\n", difftime(ctb, cta));
//	AfxMessageBox(Zeit);
//	printf("   ... ready!\n");

}// end wavelettransform




// translated hat curve for easy access to color components in a color circle
float hat(float phase) {
	double dummy;
	phase=modf(phase,&dummy);
	if(phase<0) {phase+=1.;}  // modf makes the same ugly thing as % - it returns a negative number, if the argument was negative
#ifdef ColorTriangle
	if(phase<1./3) { // ascending part
	 return phase*3;
	} else if (phase<2./3) { // descending part
	 return 2.-phase*3;
	} else { // the rest
	 return 0;
	};
#else
	if(phase<1./6) { // ascending part
	 return phase*6;
	} else if (phase<=1./2) { // constant part
	 return 1;
	} else if (phase<2./3) { // descending part
	 return 4.-phase*6;
	} else { // the rest
	 return 0;
	};
#endif
};

float *alloc_wtspace(long x, long y) {
	//printf("Allocating space for %ld x %ld wavelet coefficients.\n", x, y);
	float *f = new float[x*y];
	if (f==NULL) {
		printf("Could not allocate space for %ld x %ld wavelet coefficients.\n", x, y);
		exit(1);
	}
	return f;
}

void complex_wt(const char *outputbasename, const wavelet_fkt *wf, const arguments &arguments,
								CArray<FLOAT,FLOAT>* pWaveletCoeffizientsReal,CArray<FLOAT,FLOAT>* pWaveletCoeffizientsImg,
								CArray<FLOAT,FLOAT>* pWaveletCoeffizients)
{
	const static float pmin=0,pmax=2*M_PI;
	const int rng = 255;
	float max=0;
	long x = arguments.b.n,
	     y = arguments.a.n;

	// input:  wt.re.dat, wt.im.dat
	// output: wt.phase.pgm, wt.phase.dat, wt.mod.pgm, wt.mod.dat
	//printf("\n");
	//printf("   analyzing the real- and imaginary part for\n");
	//printf("   phase and modulus representation\n");
	/*  the image size is read from arguments record
	    reading it from the information file might be useful if this routine is moved to a separate program
		safe_file file(wfopen(outputbasename,".inf","r"));
		float dummy;
		fscanf(file.cfile(),"%g\n",&dummy);
		fscanf(file.cfile(),"%g\n",&dummy);
		fscanf(file.cfile(),"%g  %g  %ld\n",&dummy,&dummy,&x);
		fscanf(file.cfile(),"%g  %g  %ld\n",&dummy,&dummy,&y);
	*/

	safe_signal REwt    (alloc_wtspace(x,y));
	safe_signal IMwt    (alloc_wtspace(x,y));
	safe_signal phase   (alloc_wtspace(x,y));
	safe_signal modulus (alloc_wtspace(x,y));

	{
//		safe_file afile(wfopen(outputbasename,".re.dat","r"));
//		safe_file bfile(wfopen(outputbasename,".im.dat","r"));
		long i,j;
//		printf("\n\nok1\n\n");

//		printf("ok2 \n\n");
		for(j=y; (j--)>0;) {
			for(i=0; i<x; i++) {
				float &re = REwt   .cptr()[i+j*x];
				float &im = IMwt   .cptr()[i+j*x];
				float &ph = phase  .cptr()[i+j*x];
				float &md = modulus.cptr()[i+j*x];

				re=pWaveletCoeffizientsReal->GetAt(i+j*x);
				im=pWaveletCoeffizientsImg->GetAt(i+j*x);
//				fscanf(afile.cfile(),"%g",&re);
//				fscanf(bfile.cfile(),"%g",&im);

				md=sqrt(im*im+re*re);
				if(md>max) {max=md;}

				if (md!=0) {
					ph = atan2(re,im);
					if(ph<0) {
						ph += 2*M_PI;
					}
				} else {
					ph=0;
				};

			} //for i
		} //for j
	}
//	printf("pmin %g, pmax %g\n", pmin, pmax);

	if (max==0) {
		/* will only occur if the wavelet or the signal is constant zero
		    - in this case, any maximum value but zero is ok */
		max = 1;
	};

/*	// PHASE:
	{
		store_inf (outputbasename, ".phase.inf", wf, arguments);
		safe_file cfile(wfopen(outputbasename,".phase.pgm","w"));
		safe_file dfile(wfopen(outputbasename,".phase.dat","w"));
		long i,j;
		fprintf(cfile.cfile(),"P2\n%ld  %ld\n%d\n",x,y,rng);
		for(j=y; (j--)>0;) {
			fprintf(cfile.cfile(),"\n");
			for(i=0; i<x; i++) {
				pWaveletCoeffizientsReal->SetAt(i+j*x,(rng/(pmax-pmin)*(phase.cptr()[i+j*x]-pmin)));
				fprintf(cfile.cfile(),"%d ",(int)(rng/(pmax-pmin)*(phase.cptr()[i+j*x]-pmin)));
				fprintf(dfile.cfile(),"%g\n",phase.cptr()[i+j*x]);
			}//i
		}//j
	}
//	view_result(outputbasename,".phase.pgm",arguments.graphic,arguments.imgviewer);
*/
	// MODULUS:
	{
//		store_inf (outputbasename, ".mod.inf", wf, arguments);
//		safe_file cfile(wfopen(outputbasename,".mod.pgm","w"));
//		safe_file dfile(wfopen(outputbasename,".mod.dat","w"));
		long i,j;
//		fprintf(cfile.cfile(),"P2\n%ld  %ld\n%d\n",x,y,rng);

		pWaveletCoeffizients->RemoveAll();
		pWaveletCoeffizients->SetSize(arguments.a.n*arguments.b.n);

		for(j=y; (j--)>0;) {
//			fprintf(cfile.cfile(),"\n");
			for(i=0; i<x; i++) {
				pWaveletCoeffizients->SetAt((y-j-1)*x+i,(rng*modulus.cptr()[i+j*x]/max));
//				pWaveletCoeffizients->Add((rng*modulus.cptr()[i+j*x]/max));
//				fprintf(cfile.cfile(),"%d ",(int)(rng*modulus.cptr()[i+j*x]/max));
//				fprintf(dfile.cfile(),"%g\n",modulus.cptr()[i+j*x]);
			}//i
		}//j
	}
//	view_result(outputbasename,".mod.pgm",arguments.graphic,arguments.imgviewer);

/*	// MODULUS + PHASE colored:
	printf("   save the phase and modulus file...\n");
	{
		safe_file file(wfopen(outputbasename,".color.ppm","w"));
		long i,j;
		fprintf(file.cfile(),"P3\n#%s.color.ppm\n%ld  %ld\n%d",outputbasename,x,y,rng);
		for(j=y; (j--)>0;) {
			fprintf(file.cfile(),"\n");
			for(i=0; i<x; i++) {
				int color[3];
				float cphase   = phase  .cptr()[i+j*x];
				float cmodulus = modulus.cptr()[i+j*x]/max*rng;
				color[0]=int(cmodulus*hat(cphase/(2*M_PI))  	);
				color[1]=int(cmodulus*hat(cphase/(2*M_PI)-1./3));
				color[2]=int(cmodulus*hat(cphase/(2*M_PI)-2./3));
				//fprintf(file.cfile(),"%d %d %d   ",red,green,blue);
				fprintf(file.cfile(),"%d %d %d   ",color[0],color[1],color[2]);
			}// i
		}// j
	}
//	view_result(outputbasename,".color.ppm",arguments.graphic,arguments.imgviewer);
*/
}// end void complex_wt



void print_list_of_wavelets () {
	int i;
	for (i=0; wavelet_desc_arr[i].id!=NULL; i++) {
		printf("  %-15s  %s\n", wavelet_desc_arr[i].id, wavelet_desc_arr[i].help);
	};
}

void print_list_of_signals () {
	int i;
	for (i=0; signal_desc_arr[i].id!=NULL; i++) {
		printf("  %-15s  %s\n", signal_desc_arr[i].id, signal_desc_arr[i].help);
	};
}


