// InfoView.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Sounds.h"
#include "InfoView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CInfoView

IMPLEMENT_DYNCREATE(CInfoView, CFormView)

CInfoView::CInfoView()
	: CFormView(CInfoView::IDD)
{
	//{{AFX_DATA_INIT(CInfoView)
	m_intBits = 0;
	m_strChannels = _T("");
	m_strFormat = _T("");
	m_intSamples = 0;
	m_strSoundAusgang = _T("Primrer Soundtreiber");
	m_strSoundEingang = _T("Primrer Soundaufnahmetreiber");
	m_strPlayFile = _T("");
	m_strRecordFile = _T("");
	m_longFFTPoints = 0;
	//}}AFX_DATA_INIT
}

CInfoView::~CInfoView()
{
	CSoundsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->m_pViewInfo=NULL;
}

void CInfoView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CInfoView)
	DDX_Text(pDX, IDC_BITS, m_intBits);
	DDX_Text(pDX, IDC_CHANNELS, m_strChannels);
	DDX_Text(pDX, IDC_FORMAT, m_strFormat);
	DDX_Text(pDX, IDC_SAMPLES, m_intSamples);
	DDX_Text(pDX, IDC_SOUNDAUSGANG, m_strSoundAusgang);
	DDX_Text(pDX, IDC_SOUNDEINGANG, m_strSoundEingang);
	DDX_Text(pDX, IDC_WAVEFILEPLAY, m_strPlayFile);
	DDX_Text(pDX, IDC_WAVEFILERECORD, m_strRecordFile);
	DDX_Text(pDX, IDC_FFTPOINTS, m_longFFTPoints);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CInfoView, CFormView)
	//{{AFX_MSG_MAP(CInfoView)
		// HINWEIS - Der Klassen-Assistent fgt hier Zuordnungsmakros ein und entfernt diese.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Diagnose CInfoView

#ifdef _DEBUG
void CInfoView::AssertValid() const
{
	CFormView::AssertValid();
}

void CInfoView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CInfoView 

void CInfoView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	m_bkgclr=GetSysColor(COLOR_MENU); 
	m_txtclr=GetSysColor(COLOR_MENUTEXT); 
	m_redclr=RGB(255,0,0); 

	m_CaptureButton.SubclassDlgItem(IDC_ISCAPTURE, this);
	m_CaptureButton.EnableWindow(TRUE);
	m_CaptureButton.SetColour(m_bkgclr,m_bkgclr);

	m_RecordButton.SubclassDlgItem(IDC_ISRECORD, this);
	m_RecordButton.EnableWindow(TRUE);
	m_RecordButton.SetColour(m_bkgclr,m_bkgclr);
	
}

void CInfoView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
 if ((lHint==18)||(lHint==50)) 
 {
	CSoundsDoc* pDoc=GetDocument();
	m_strSoundEingang=theApp.m_strSoundEingang;
	m_strSoundAusgang=theApp.m_strSoundAusgang;
	m_intBits = pDoc->m_intBits;
	m_strChannels = pDoc->m_strChannels;
	m_strFormat = pDoc->m_strFormat;
	m_intSamples = pDoc->m_intSamples;
	m_strPlayFile = pDoc->m_strPlayFile;
	m_strRecordFile = pDoc->m_strRecordFile;
	m_longFFTPoints = pDoc->m_NumFFTPoints;

	if (g_bIsRecording) 
		m_RecordButton.SetColour(m_txtclr,m_redclr);
	else
		m_RecordButton.SetColour(m_bkgclr,m_bkgclr);
	if (g_bIsCapturing) 
		m_CaptureButton.SetColour(m_txtclr,m_redclr);
	else
		m_CaptureButton.SetColour(m_bkgclr,m_bkgclr);
	UpdateData(FALSE);
 }
}


