#if !defined(AFX_LYAPUNOVKANTZ_H__F0310F93_CE2B_440A_9830_098B836C3E77__INCLUDED_)
#define AFX_LYAPUNOVKANTZ_H__F0310F93_CE2B_440A_9830_098B836C3E77__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// LyapunovKantz.h : Header-Datei
//

#define BOX 128
#define NMAX 256

/////////////////////////////////////////////////////////////////////////////
// Fenster CLyapunovKantz 

class CLyapunovKantz
{
// Konstruktion
public:
	CLyapunovKantz();

// Attribute
protected:
	//Korrelationsdimensionsberechnung
	unsigned int			m_Korr_EMBED;
	unsigned int			m_Korr_HOWOFTEN;
	unsigned int			m_Korr_DELAY;
	double						m_Korr_EPSMAX;
	double						m_Korr_EPSMIN;
	unsigned long			m_Korr_MAXFOUND;
	unsigned long			m_Korr_length;

	long* 						m_Korr_scr;
	int					 			m_Korr_imax;
	double 						m_Korr_epsinv;
	int					 			m_Korr_howoften1;
	unsigned int			m_Korr_DIM;	
	unsigned long			m_Korr_MINDIST;
	int								m_Korr_imin;
	double						m_Korr_lneps;
	double						m_Korr_lnfac;
	long							m_Korr_boxc1[NMAX];
	long*							m_Korr_listc1;
	long							m_Korr_box[NMAX][NMAX];
	double**					m_Korr_found;
	long*							m_Korr_list;		
	double**					m_Korr_Series;




	//Fr Maximalen Lyapunovexponenten
	unsigned int				m_intIBox;
	unsigned long				m_lLength;
	unsigned long				m_lExclude;
	unsigned long				m_lReference;
	unsigned int				m_intMaxdim;
	unsigned int				m_intMindim;
	unsigned int				m_intDelay;
	unsigned int				m_intColumn;
	unsigned int				m_intEpscount;
	unsigned int				m_intMaxiter;
	unsigned int				m_intWindow;
	unsigned int				m_intVerbosity;
	double							m_dEpsmin;
	double							m_dEpsmax;
	char								m_cEps0set;
	char								m_cEps1set;
	char*								m_pOutfile;
	char*								m_pInfile;

	double*							m_pdSeries;
	double**						m_ppdLyap;
	long								m_lBox[BOX][BOX];
	long*								m_plListe;
	long**							m_pplLFound;
	long*								m_plFound;
	long**							m_pplCount;
	double							m_dMax;
	double							m_dMin;

	//Fr Lyapunovspektrum
	char								m_LSpec_epsset;
	char								m_LSpec_INVERSE;
	char								m_LSpec_dimset;
	char*								m_LSpec_COLUMNS;
	unsigned long				m_LSpec_LENGTH;
	unsigned long				m_LSpec_ITERATIONS;
	unsigned long				m_LSpec_exclude;
	unsigned int				m_LSpec_EMBED;
	unsigned int				m_LSpec_DIMENSION;
	unsigned int				m_LSpec_DELAY;
	unsigned int				m_LSpec_MINNEIGHBORS;
	unsigned int				m_LSpec_verbosity;
	double							m_LSpec_EPSSTEP;

	double**						m_LSpec_Series;
	
	double*							m_LSpec_averr;
	double							m_LSpec_avneig;
	double							m_LSpec_aveps;
	double							m_LSpec_epsmin;
	long								m_LSpec_imax;
	long								m_LSpec_count;
	long**							m_LSpec_box;
	long*								m_LSpec_list;
	unsigned long*			m_LSpec_found;
	unsigned int				m_LSpec_alldim;
	unsigned int**			m_LSpec_indexes;

	unsigned long*	rnd_array;
	unsigned long		rnd69;
	unsigned long*	rnd1279;
	unsigned long		factor;
	unsigned long*	nexti;
	unsigned long		rndtime;
	unsigned long		rndtime1;
	unsigned long		rndtime2;
	unsigned long		rndtime3;
	unsigned long*	next1279;
	unsigned long		t1279;
	unsigned long		t1279_1;
	unsigned long		t1279_2;
	unsigned long		t1279_3;
	double					lo_limit;

	double				m_oldFaktorY;
	double				m_oldFaktorYKorr;
	double				m_KaplanYorkeDimension;

public:
	virtual ~CLyapunovKantz();
	double** Calc_Max_Lyap_Exponent(CDC* pDC, HWND hwnd, double* series,unsigned long length,int* pIterationen,int* Epsilons);
	double** Calc_Lyap_Spektrum(CDC* pDC, HWND hwnd, double** Series, int iters, int Laenge);
	double*** Calc_Korr_Dim(CDC* pDC, HWND hwnd, double** Series, int Laenge);

	void DrawExponents(CDC* pDC,HWND hwnd, double** LYAEXP, int count,int start, int dim, int tau);
	void DrawLyapunovMax(CDC* pDC,HWND hwnd, double** DATA,int Iterationen,int Epsilons,int MinDim,int MaxDim);
	void DrawKorrDim(CDC* pDC,HWND hwnd, double*** KorrDimWerte,int AnzahlDimensionen,int AnzahlRadien,LONG PosMarker1,LONG PosMarker2);
	void SetParameters(LONG Iter,int MaxDim,int MinDim,int Tau,int NumberOf,double RadiusMin,
																	 double RadiusMax,INT Which, INT Referenz);
	void rescale_data(double *x,unsigned long l,double *min,double *interval);
	void check_alloc(void *pnt);

/*
	double **get_multi_series(char *name,unsigned long *l,unsigned long ex,
			  unsigned int *col,char *which,char colfix,
			  unsigned int verbosity);
*/

protected:
	void put_in_boxes(double eps);
	void lfind_neighbors(long act,double eps);
	void iterate_points(long act);

	double sort(long act,unsigned long nfound);
	void make_multi_box(double **ser,long **box,long *list,unsigned long l,
										unsigned int bs,unsigned int dim,unsigned int emb,
										unsigned int del,double eps);
	unsigned long find_multi_neighbors(double **s,long **box,long *list,double **x,
																		unsigned long l,unsigned int bs,unsigned int dim,
																		unsigned int emb,unsigned int del,double eps,
																		unsigned long *flist);
	void solvele(double **mat,double *vec,unsigned int n);
	double** invert_matrix(double **mat,unsigned int size);
	void make_dynamics(double **dynamics,long act);
	void gram_schmidt(double **delta,double *stretch);
	void make_iteration(double **dynamics,double **delta);
	void variance(double *s,unsigned long l,double *av,double *var);
	void rnd_init(unsigned long iseed);
	unsigned long rnd_long(void);

	void scramble();
	void make_c2_dim(int n);
	void make_c2_1(int n);


};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // AFX_LYAPUNOVKANTZ_H__F0310F93_CE2B_440A_9830_098B836C3E77__INCLUDED_
