// MainFrm.cpp : Implementierung der Klasse CMainFrame
//

#include "stdafx.h"
#include "Sounds.h"
#include "MainFrm.h"
#include "FFTFrame.h"
#include "ChildFrm.h"
#include "SoundsView.h"
#include "FFTView.h"
#include "SonoView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	ON_MESSAGE(WM_USER_PLAY_NOTIFY_DONE, OnPlayNotifyDone)
	ON_MESSAGE(WM_USER_CAPTURE_DONE, OnCaptureDone)
	ON_MESSAGE(WM_USER_SETFFTBAR, OnUpdateFFTBar)
	ON_MESSAGE(WM_USER_SETWAVEFILEBAR, OnUpdateWaveFileBar)
	ON_MESSAGE(WM_USER_SETWAVEBITBAR, OnUpdateWaveBitBar)
	ON_MESSAGE(WM_USER_SETWAVEKHZBAR, OnUpdateWaveKhzBar)
	ON_MESSAGE(WM_USER_SETCAPTUREBAR, OnUpdateCaptureBar)
	ON_MESSAGE(WM_USER_SETRECORDBAR, OnUpdateRecordBar)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_CLOSE()
	ON_COMMAND(ID_VIEW_STATUS_BAR, OnViewStatusBar)
	ON_COMMAND(ID_VIEW_TOOLBARNORMAL, OnViewToolbarnormal)
	ON_COMMAND(ID_VIEW_TOOLBARSCHULE, OnViewToolbarschule)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // Statusleistenanzeige
	ID_INDICATOR_WAVEFILE,
	ID_INDICATOR_WAVEBIT,
	ID_INDICATOR_WAVEKHZ,
	ID_SEPARATOR_HIGH,
	ID_INDICATOR_FFTPTS,
	ID_SEPARATOR_HIGH,
	ID_INDICATOR_CAPTURE,
	ID_INDICATOR_RECORD,
	ID_SEPARATOR_HIGH,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame Konstruktion/Zerstrung

CMainFrame::CMainFrame()
{
	// ZU ERLEDIGEN: Hier Code zur Member-Initialisierung einfgen
	
}

CMainFrame::~CMainFrame()
{
	m_bmToolbarSchuleHi.DeleteObject();
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	CSize SizeStatus,SizeTool;
	m_HoeheStatusbar=0;
	m_HoeheToolbarSchule=0; 
	m_HoeheToolbarNormal=0;

	//Symbolleisten erstellen aber noch nicht anzeigen
	//Grundschulsymbolleiste nicht andockbar und nicht verschiebbar
	if (!m_wndToolBarSchule.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | CBRS_TOP
			| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
			!m_wndToolBarSchule.LoadToolBar(IDR_TOOLSCHULE))
	{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1;      // Fehler bei Erstellung
	}

  //StandardToolbarSize W:16 H:16 SchoolToolbarSize W:32, H:32
	AttachToolbarImages(IDB_HICOLOR_TOOLBARSCHULE, 
											IDB_HICOLOR_TOOLBARSCHULE_DISABLED, 
											IDB_HICOLOR_TOOLBARSCHULE_HOT,
											&m_wndToolBarSchule,
											&m_ImageListSchule,&m_ImageListSchuleDisabled,&m_ImageListSchuleHot,
											32,32,10);

	
/*	m_pImageListSchule=new CImageList;
	m_pImageListSchule->Create(IDB_TOOLBARSCHULEDISABLED,32,1,0);
	CToolBarCtrl& ToolbarSchuleCtrl=m_wndToolBarSchule.GetToolBarCtrl();
	ToolbarSchuleCtrl.SetDisabledImageList(m_pImageListSchule);
  m_bmToolbarSchuleHi.LoadBitmap( IDB_TOOLBARSCHULE );
  m_wndToolBarSchule.SetBitmap( (HBITMAP)m_bmToolbarSchuleHi );
*/	
	//Normale Symbolleiste ist andockbar
	if (!m_wndToolBarNormal.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | CBRS_TOP
			| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
			!m_wndToolBarNormal.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1;      // Fehler bei Erstellung
	}
	
	AttachToolbarImages(IDB_HICOLOR_TOOLBARNORMAL, 
											IDB_HICOLOR_TOOLBARNORMAL_DISABLED, 
											IDB_HICOLOR_TOOLBARNORMAL_HOT,
											&m_wndToolBarNormal,
											&m_ImageListNormal,&m_ImageListNormalDisabled,&m_ImageListNormalHot,
											16,16,24);
/*	m_pImageListNormal=new CImageList;
	m_pImageListNormal->Create(IDB_TOOLBARDISABLED,16,1,0);
	CToolBarCtrl& ToolbarNormalCtrl=m_wndToolBarNormal.GetToolBarCtrl();
//	ToolbarNormalCtrl.SetDisabledImageList(m_pImageListNormal);
  m_bmToolbarNormalHi.LoadBitmap( IDB_TOOLBAR );
  m_wndToolBarNormal.SetBitmap( (HBITMAP)m_bmToolbarNormalHi );
*/
	
	m_wndToolBarNormal.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBarNormal);

	//IniFile auslesen und entsprechende Symbolleisten einblenden
	if (*theApp.GetIniAllgemeinToolbarNormal()) 
	{
		SizeTool=m_wndToolBarNormal.CalcFixedLayout(FALSE,TRUE);
		m_HoeheToolbarNormal=SizeTool.cy; 
		m_wndToolBarNormal.ShowWindow(SW_SHOW);
	}

	if (*theApp.GetIniAllgemeinToolbarSchule()) 
	{
		SizeTool=m_wndToolBarSchule.CalcFixedLayout(FALSE,TRUE);
		m_HoeheToolbarSchule=SizeTool.cy; 
		m_wndToolBarSchule.ShowWindow(SW_SHOW);
	}

	//Statusbar erstellen
	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Statusleiste konnte nicht erstellt werden\n");
		return -1;      // Fehler bei Erstellung
	}
	m_wndStatusBar.SetPaneInfo( 1, ID_INDICATOR_WAVEFILE, SBPS_NORMAL, 200);
	m_wndStatusBar.SetPaneInfo( 2, ID_INDICATOR_WAVEBIT, SBPS_NORMAL, 60);
	m_wndStatusBar.SetPaneInfo( 3, ID_INDICATOR_WAVEKHZ, SBPS_NORMAL, 50);
	m_wndStatusBar.SetPaneInfo( 4, ID_SEPARATOR_HIGH, SBPS_NOBORDERS, 10);
	m_wndStatusBar.SetPaneInfo( 5, ID_INDICATOR_FFTPTS, SBPS_NORMAL, 100);
	m_wndStatusBar.SetPaneInfo( 6, ID_SEPARATOR_HIGH, SBPS_NOBORDERS, 10);
	m_wndStatusBar.SetPaneInfo( 7, ID_INDICATOR_CAPTURE, SBPS_NORMAL, 80);
	m_wndStatusBar.SetPaneInfo( 8, ID_INDICATOR_RECORD, SBPS_NORMAL, 85);
	m_wndStatusBar.SetPaneInfo( 9, ID_SEPARATOR_HIGH, SBPS_NOBORDERS, 10);

	//Inifile auslesen und Statusbar entsprechend ein- oder ausblenden
	if (*theApp.GetIniAllgemeinStatusbar()) 
	{
		SizeStatus=m_wndStatusBar.CalcFixedLayout(FALSE,TRUE);
		m_HoeheStatusbar=SizeStatus.cy;
	}
	else
	{
		m_wndStatusBar.ShowWindow(FALSE);
	}

//	this->SetMenu(NULL);
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CMDIFrameWnd::PreCreateWindow(cs) )
		return FALSE;
    cs.style &= ~FWS_ADDTOTITLE;

	return TRUE;
}
void CMainFrame::OnViewStatusBar() 
{
	if( m_wndStatusBar.IsWindowVisible() )
	{
		m_wndStatusBar.ShowWindow(SW_HIDE);
		m_HoeheStatusbar=0;
		*theApp.GetIniAllgemeinStatusbar()=0;
	}
	else
	{
		CSize SizeStatus;
		m_wndStatusBar.ShowWindow(SW_SHOW);
		*theApp.GetIniAllgemeinStatusbar()=1;
		SizeStatus=m_wndStatusBar.CalcFixedLayout(FALSE,TRUE);
		m_HoeheStatusbar=SizeStatus.cy;
	}	
	RecalcLayout();
	RecalcViews();
}

void CMainFrame::OnViewToolbarnormal() 
{
	if(m_wndToolBarNormal.IsWindowVisible() )
	{
		m_wndToolBarNormal.ShowWindow(SW_HIDE);
		*theApp.GetIniAllgemeinToolbarNormal()=0;
		m_HoeheToolbarNormal=0;
	}
	else
	{
		CSize SizeTool;
		m_wndToolBarNormal.ShowWindow(SW_SHOW);
		*theApp.GetIniAllgemeinToolbarNormal()=1;
		SizeTool=m_wndToolBarNormal.CalcFixedLayout(FALSE,TRUE);
		m_HoeheToolbarNormal=SizeTool.cy; 
	}
	RecalcLayout();
	RecalcViews();
}

void CMainFrame::OnViewToolbarschule() 
{
	if(m_wndToolBarSchule.IsWindowVisible() )
	{
		m_wndToolBarSchule.ShowWindow(SW_HIDE);
		*theApp.GetIniAllgemeinToolbarSchule()=0;
		m_HoeheToolbarSchule=0;
	}
	else
	{
		CSize SizeTool;
		m_wndToolBarSchule.ShowWindow(SW_SHOW);
		*theApp.GetIniAllgemeinToolbarSchule()=1;
		SizeTool=m_wndToolBarSchule.CalcFixedLayout(FALSE,TRUE);
		m_HoeheToolbarSchule=SizeTool.cy; 
	}
	RecalcLayout();
	RecalcViews();
}

void CMainFrame::RecalcViews() 
{
	//Redraw Window Sizes from IniFile with new Dimension because of Updated Status or Toolbars
	theApp.SwitchWindowDlgBars(TRUE,TRUE);
}

void CMainFrame::OnClose() 
{
	CSoundsApp *app=(CSoundsApp *)AfxGetApp();
	WINDOWPLACEMENT wp;
	
	this->GetWindowPlacement(&wp);
	if (this->IsZoomed()) wp.showCmd=SW_SHOWMAXIMIZED;
	if (this->IsIconic()) wp.showCmd=SW_SHOWMINIMIZED;
	app->PutWP(wp,MAIN);

	
	CMDIFrameWnd::OnClose();
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame Diagnose

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame Nachrichten-Handler

LRESULT CMainFrame::OnCaptureDone(WPARAM, LPARAM)
{
	theApp.mp_doc->OnCaptureDone();
	return 0;
}


LRESULT CMainFrame::OnPlayNotifyDone(WPARAM, LPARAM)
{
	theApp.mp_doc->OnPlayNotifyDone(0);
	return 0;
}

LRESULT CMainFrame::OnUpdateWaveFileBar(WPARAM wparam, LPARAM)
{
	CString WaveFile=*theApp.mp_doc->GetWaveFilename();
	CString AddOn="File: ";
	while (WaveFile.Find("\\",0)!=-1) 
	{
		INT i=WaveFile.Find("\\",0);
		WaveFile.Delete(0,i+1);	
	}
	m_wndStatusBar.SetPaneText(1,AddOn+WaveFile,TRUE);
	return 0;
}

LRESULT CMainFrame::OnUpdateWaveBitBar(WPARAM wparam, LPARAM)
{
	char buffer[20];
	CString AddOn1="Mono: ";
	CString AddOn2="-Bit";
	CString Bits=itoa( wparam, buffer, 10 );
	CString Text;
	if (wparam!=0) 
		Text=AddOn1+Bits+AddOn2;
	else
		Text="";
	m_wndStatusBar.SetPaneText(2,Text,TRUE);
	return 0;
}

LRESULT CMainFrame::OnUpdateWaveKhzBar(WPARAM wparam, LPARAM)
{
	char buffer[20];
	CString AddOn=" kHz";
	CString Samples=itoa( wparam/1000, buffer, 10 );
	CString Text;
	if (wparam!=0) 
		Text=Samples+AddOn;
	else
		Text="";
	m_wndStatusBar.SetPaneText(3,Text,TRUE);
	return 0;
}

LRESULT CMainFrame::OnUpdateFFTBar(WPARAM wparam, LPARAM)
{
	char buffer[20];
	CString AddOn;
	AddOn.LoadString(IDS_FFTPOINTS);
	CString Punkte=itoa( wparam, buffer, 10 );
	CString Text;
	if (wparam!=0) 
		Text=AddOn+Punkte;
	else
		Text="";
	m_wndStatusBar.SetPaneText(5,Text,FALSE);
	return 0;
}

LRESULT CMainFrame::OnUpdateCaptureBar(WPARAM wparam, LPARAM)
{
	CString Text;
	if (g_bIsCapturing) 
		Text.LoadString(IDS_CAPTURING);
	else
		Text="";
	m_wndStatusBar.SetPaneText(7,Text,TRUE);
	return 0;
}

LRESULT CMainFrame::OnUpdateRecordBar(WPARAM wparam, LPARAM)
{
	CString Text;
	if (g_bIsRecording) 
		Text.LoadString(IDS_RECORDING);
	else
		Text="";
	m_wndStatusBar.SetPaneText(8,Text,TRUE);
	return 0;
}

//Helper for 24-Bit Toolbars

void	CMainFrame::ReplaceBackgroundColor (CBitmap& ioBM)
{
 // figure out how many pixels there are in the bitmap
 BITMAP		bmInfo;

 VERIFY (ioBM.GetBitmap (&bmInfo));

 // add support for additional bit depths if you choose
 VERIFY (bmInfo.bmBitsPixel == 24);
 VERIFY (bmInfo.bmWidthBytes == (bmInfo.bmWidth * 3));

 const UINT		numPixels (bmInfo.bmHeight * bmInfo.bmWidth);

 // get a pointer to the pixels
 DIBSECTION  ds;

 VERIFY (ioBM.GetObject (sizeof (DIBSECTION), &ds) == sizeof (DIBSECTION));

 RGBTRIPLE*		pixels = reinterpret_cast<RGBTRIPLE*>(ds.dsBm.bmBits);
 VERIFY (pixels != NULL);

 // get the user's preferred button color from the system
 const COLORREF		buttonColor (::GetSysColor (COLOR_BTNFACE));
 const RGBTRIPLE		userBackgroundColor = {
 GetBValue (buttonColor), GetGValue (buttonColor), GetRValue (buttonColor)};

 // search through the pixels, substituting the user's button
 // color for any pixel that has the magic background color
 for (UINT i = 0; i < numPixels; ++i)
 {
  if (pixels [i].rgbtBlue == kBackgroundColor.rgbtBlue
  && pixels [i].rgbtGreen == kBackgroundColor.rgbtGreen
  && pixels [i].rgbtRed == kBackgroundColor.rgbtRed)
  {
   pixels [i] = userBackgroundColor;
  }
 }
}


// create an image list for the specified BMP resource
void	CMainFrame::MakeToolbarImageList (UINT inBitmapID, CImageList&	outImageList,
																							INT ImageWidth, INT ImageHeight, INT NumImages)
{
 CBitmap		bm;

 // if we use CBitmap::LoadBitmap() to load the bitmap, the colors
 // will be reduced to the bit depth of the main screen and we won't
 // be able to access the pixels directly. To avoid those problems,
 // we'll load the bitmap as a DIBSection instead and attach the
 // DIBSection to the CBitmap.
 VERIFY (bm.Attach (::LoadImage (::AfxFindResourceHandle(
 MAKEINTRESOURCE (inBitmapID), RT_BITMAP),
 MAKEINTRESOURCE (inBitmapID), IMAGE_BITMAP, 0, 0,
 (LR_DEFAULTSIZE | LR_CREATEDIBSECTION))));

 // replace the specified color in the bitmap with the user's
 // button color
 ReplaceBackgroundColor (bm);

 // create a 24 bit image list with the same dimensions and number
 // of buttons as the toolbar
 VERIFY (outImageList.Create (ImageWidth, ImageHeight, kToolBarBitDepth, NumImages, 0));

 // attach the bitmap to the image list
 VERIFY (outImageList.Add (&bm, RGB (0, 0, 0)) != -1);
}


// load the high color toolbar images and attach them to m_wndToolBar
void CMainFrame::AttachToolbarImages (UINT inNormalImageID, UINT inDisabledImageID,
                                      UINT inHotImageID, CToolBar* pToolbar,
																			CImageList* pImageList,
																			CImageList* pImageListDisabled,
																			CImageList* pImageListHot,
																			INT ImageWidth,	INT ImageHeight, INT NumImages)
{
  // make high-color image lists for each of the bitmaps
 MakeToolbarImageList (inNormalImageID, *pImageList,ImageWidth,ImageHeight,NumImages);
 MakeToolbarImageList (inDisabledImageID, *pImageListDisabled,ImageWidth,ImageHeight,NumImages);
 MakeToolbarImageList (inHotImageID, *pImageListHot,ImageWidth,ImageHeight,NumImages);

  // get the toolbar control associated with the CToolbar object
 CToolBarCtrl&	barCtrl = pToolbar->GetToolBarCtrl();

  // attach the image lists to the toolbar control
 barCtrl.SetImageList (pImageList);
 barCtrl.SetDisabledImageList (pImageListDisabled);
 barCtrl.SetHotImageList (pImageListHot);
}
