//////////////////////////////////////////////////////////////////////////////
// Diese Funktion liest aus einem 2-spaltigen File nur die 2-Spalte,				//
// skaliert die Amplituden auf die angegebene Bitrate und schreibt die      //
// Werte in ein Array                                                       //
//////////////////////////////////////////////////////////////////////////////
void CSoundsDoc::OnDatenZeitreiheeinlesen() 
{
			//Wiedergabe stoppen, wenn noch am laufen und alle Objekte und Thread dess letzten Files killen
			DeleteContents();
			if (g_bIsWaveLoaded) 
			{
				if( g_bIsPlayingWave)
				{
					m_pSound->Stop();
					m_pSound->Reset();
					g_bIsPlayingWave=FALSE;
				}
				OnResetwave();
			}

		m_WAVKomplettArray.RemoveAll();
		CFileDialog ZeitreiheDlg(TRUE,NULL,NULL,OFN_OVERWRITEPROMPT|OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST|OFN_ENABLESIZING,\
              "TXT - Textfiles mit 1 Spalte|*.txt|PRN - Mathcadexportfiles mit 1 Spalte|*.prn|DAT - Datenfiles mit 1 Spalte|*.dat|Alle Dateien|*.*|");
	  ZeitreiheDlg.m_ofn.nFilterIndex=3;
		CString Text;
		Text.LoadString(IDS_READ_ZEITREIHE);
		ZeitreiheDlg.m_ofn.lpstrTitle=Text.GetBuffer(Text.GetLength());
	  if (ZeitreiheDlg.DoModal()==IDOK) 
		{
	    m_strPlayFile=ZeitreiheDlg.GetPathName();
			Zeitreiheeinlesen(m_strPlayFile);
			UpdateStatusBar();
			CString AppTitle=ZeitreiheDlg.GetFileName();
			SetTitle(AppTitle);
			UpdateAllViews(NULL,50);
		} //ZeitreiheDlgffnen IDOK
} // OnDatenZeitreiheEinlesen


void CSoundsDoc::Zeitreiheeinlesen(CString DATFile) 
{
	FILE *FileStream;
	DOUBLE Amplitude,MaxAmplitudeDaten=0;
 	CArray<DOUBLE,DOUBLE&> ZeitreiheArray;
	INT i=0;
	BOOL Signed=FALSE;
	// Filedaten einlesen ohne Fehlerabfrage
	FileStream=fopen(DATFile,"r");
	char data[256];
	while ( feof(FileStream)==0 ) 
	{
	  fscanf(FileStream,"%s",data);
		if (data[0]!='#') 
		{
	    Amplitude=atof(data);
		  if (fabs(Amplitude)>MaxAmplitudeDaten)
				MaxAmplitudeDaten=fabs(Amplitude);
			if (Amplitude<0) Signed=TRUE;
				ZeitreiheArray.Add(Amplitude);
		}
	}
  fclose(FileStream);

	//Auf 16 Bit normieren
	DOUBLE Normierungsfaktor;
	if (Signed) 
		Normierungsfaktor=ldexp(1,16)/MaxAmplitudeDaten/2;
	else
		Normierungsfaktor=ldexp(1,16)/MaxAmplitudeDaten;

	int ArraySize=ZeitreiheArray.GetSize();
	for(int j=0; j<ArraySize;j++)
	{
		DOUBLE Wert=ZeitreiheArray[j];
		DOUBLE WertNeu=(UINT)(Wert*Normierungsfaktor);
		if (Signed&&WertNeu<0) 
			WertNeu+=ldexp(1,16);
		if (!Signed)
		{
			if (WertNeu<=ldexp(1,15)) 
				WertNeu+=ldexp(1,15);
			else
				WertNeu-=ldexp(1,15);
		}
		ZeitreiheArray.SetAt(j,WertNeu );
	}
	ConvertZeitreiheToWave(&ZeitreiheArray);
	ZeitreiheArray.RemoveAll();
}

HRESULT CSoundsDoc::ConvertZeitreiheToWave(CArray<DOUBLE,DOUBLE&>* pZeitreihe) 
{
	CWaveFile	waveFile;
	WAVEFORMATEX wfx;
 	CString FileNameStandard;
//	BYTE* pSoundBufferConverted;
   UINT dwDataWrote;

	m_pTempWaveConverted = new CWaveFile;
	//Standardformatfile herstellen
	wfx.cbSize=0;
	wfx.wFormatTag=WAVE_FORMAT_PCM;
	wfx.nChannels=1;
	wfx.wBitsPerSample=16;
	wfx.nSamplesPerSec=44100;
	wfx.nBlockAlign=wfx.wBitsPerSample/8;
	wfx.nAvgBytesPerSec=wfx.nBlockAlign*wfx.nSamplesPerSec;

/*
	//Konvertiertes Wavefile erstellen
	TCHAR TempFolder[MAX_PATH];
	GetTempPath(MAX_PATH,TempFolder);
	CreateDirectory(TempFolder,NULL);

	FileNameStandard=(CString)TempFolder+"~TempWave.wav";
*/

	FileNameStandard=theApp.GetModulPath()+(CString)"~TempWave.wav";
	
  LPTSTR strFileNameStandard = FileNameStandard.GetBuffer(MAX_PATH);
	m_pTempWaveConverted->Open(strFileNameStandard,&wfx,WAVEFILE_WRITE);

	m_SoundBufferConvertedSize=pZeitreihe->GetSize();
	m_AktualPlaySoundBufferSize=m_SoundBufferConvertedSize;
	m_SoundBufferSize=m_SoundBufferConvertedSize;
	
	for(UINT x=0;x<m_SoundBufferSize;x++)	
	{
		UINT Zeitreihenwert=(UINT)pZeitreihe->GetAt(x);
		BYTE Wert1=(BYTE)(Zeitreihenwert%256);
		BYTE Wert2=(BYTE)((Zeitreihenwert-Zeitreihenwert%256)/256);
		m_pTempWaveConverted->Write(1,&Wert1,&dwDataWrote);
		m_pTempWaveConverted->Write(1,&Wert2,&dwDataWrote);
	}

//	m_pTempWaveConverted->ResetFile();
	m_pTempWaveConverted->Close();
	SAFE_DELETE(m_pTempWaveConverted);
	g_bIsConvertedPlay=TRUE;
	m_SampleRateConverted=wfx.nSamplesPerSec;
	m_BitRateConverted=wfx.wBitsPerSample;

/*
  SAFE_DELETE( m_pSound );
		
	    // Load the wave file into a DirectSound buffer
	if( FAILED( hr = theApp.m_pSoundManager->Create( &m_pSound, strFileNameStandard, 0, GUID_NULL ) ) )
	{
    // Not a critical failure, so just update the status
    DXTRACE_ERR_NOMSGBOX( TEXT("Create"), hr );
    return S_FALSE; 
	}
*/
		if (CreateAbbild(strFileNameStandard)==S_OK) 
		{
			if (LoadWaveAndCreateBuffer(strFileNameStandard)==S_OK) 
			{
				g_bIsWaveLoaded=TRUE;
//				m_pStreamingSound->m_pWaveFile->Open(strFileName,NULL,WAVEFILE_READ);
//				CreatePlayThread();
//				m_TimerID=SetTimer(55,100,NULL);
				if (m_pViewFFT!=NULL) 
				{
					m_pViewFFT->m_wndDlgBar.SetDlgItemInt(IDC_TOPCUT_FELD,(INT)(m_intSamples/2/1000),FALSE);
					CSpinButtonCtrl* m_pTopCutCtrl=(CSpinButtonCtrl*)m_pViewFFT->m_wndDlgBar.GetDlgItem(IDC_TOPCUTAMP_SPIN);
					m_pTopCutCtrl->SetPos(-m_BitRate*6);
				}
				if (m_pViewSono!=NULL) 
					m_pViewSono->m_wndDlgBar.SetDlgItemInt(IDC_TOPCUT_FELD,(INT)(m_intSamples/2/1000),FALSE);
				if (m_pViewFFT3D!=NULL) 
					m_pViewFFT3D->m_wndDlgBar.SetDlgItemInt(IDC_TOPCUT_FELD,(INT)(m_intSamples/2/1000),FALSE);
			}
			else
			{
				m_strPlayFile.LoadString(IDS_NO_FILE_CHOOSEN);
				free(m_pSoundBuffer);
				m_SoundBufferSize=0;
				m_WAVKomplettArray.Add(0);
			}
			UpdateStatusBar();
			UpdateAllViews(NULL,50);
		}
		else
			m_strPlayFile.LoadString(IDS_NO_FILE_CHOOSEN);
	
	return S_OK;
}



