#if !defined(AFX_SONOVIEW_H__C301C25F_8FB2_472F_A50F_4EA334B13601__INCLUDED_)
#define AFX_SONOVIEW_H__C301C25F_8FB2_472F_A50F_4EA334B13601__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SonoView.h : Header-Datei
//
//#include "Generator.h"

typedef struct CLRPOINT
{
public:
    LONG x, y;
		COLORREF color;
} CLRPOINT;

/////////////////////////////////////////////////////////////////////////////
// Ansicht CSonoView 

class CSonoView : public CView
{
protected:
	CSonoView();           // Dynamische Erstellung verwendet geschtzten Konstruktor
	DECLARE_DYNCREATE(CSonoView)

// Attribute
protected:
	CArray<CLRPOINT,CLRPOINT> m_ViewPtFreqArray;
	COLORREF						m_clrBkg;
	COLORREF						m_clrText;
	INT									m_BottomCutHz;
	INT									m_FrequenzbereichFFT;
	DOUBLE							m_BildProzentVonBottomCutHz;
	INT									m_FrequenzbreiteFFTAnsicht;
	INT									m_counter;
	INT									m_counterComplete;
	CPalette						m_Pal1;
	CPalette						m_Pal2;
	CDC									m_MemDC;
	BOOL								m_Redraw;
	INT									m_oldwidth;
	INT									m_oldheight;
	INT									m_Liniendicke;
	INT									m_TopCutkHz;
	INT									m_ZoomV;

	CBitmap							m_ScreenBitmap;
	BOOL								m_bLButtonDown;
	BOOL								m_bResize;

	CSpinButtonCtrl*		m_pBottumCutCtrl;
	CSpinButtonCtrl*		m_pTopCutCtrl;
	CSpinButtonCtrl*		m_pLiniendickeCtrl;
	CButton*						m_pRadioAmpLin;
	CButton*						m_pRadioAmpLog;
	CButton*						m_pRadioFreqLin;
	CButton*						m_pRadioFreqLog;
	CButton*						m_pRadioFarbig;
	CButton*						m_pRadioBW;
	CEdit*							m_pFFTPointsFeld;
	CFFTFrame*					m_pParentFFTFrame;

	BOOL								m_bIsAmpLinear;
	BOOL								m_bIsFreqLinear;
	BOOL								m_bIsFarbig1;
	BOOL								m_bEraseClientScreen;
	BOOL								m_bIsSmooth;

//	Generator						m_Gen;
	POINT								m_LButtonDownMousePoint;
	/*
	CMetaFileDC					m_MetaDC;
	HENHMETAFILE				m_pMetaFile;
*/
	CSize								m_ScreenSize;

	CString							m_strHint;
// Operationen
public:
  inline CSoundsDoc* GetDocument() { return (CSoundsDoc*)m_pDocument; }
	CPalette* GetPalette() { return &m_Pal1; }
		void		IniFileWrite();
		void		IniFileRead();

// berschreibungen
	// Vom Klassen-Assistenten generierte virtuelle Funktionsberschreibungen
	//{{AFX_VIRTUAL(CSonoView)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void OnDraw(CDC* pDC);      // berschrieben zum Zeichnen dieser Ansicht
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

protected:
	void ZeichneFrequenzen(CDC* pDC);
	void ZeichneFrequenzWert(CPoint point); 
	void ZeichneTasten(CDC* pDC);
	BOOL CreatePalette();
	void DrawSpektroLine(CDC* pDC,CArray<DOUBLE,DOUBLE>* pFrequenzenArray);
	void DrawCompleteSono();
	BOOL CreatePaletteWhite();
	COLORREF CreatePaletteCOLORREF(int Index);
	CRect DetermineRect(CDC* RefDC);

// Implementierung
protected:
	virtual ~CSonoView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generierte Nachrichtenzuordnungsfunktionen
protected:
	//{{AFX_MSG(CSonoView)
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnChangeBottomcutFeld();
	afx_msg void OnPaletteFarbig();
	afx_msg void OnScaleAmpLin();
	afx_msg void OnScaleAmpLog();
	afx_msg void OnScaleFreqLin();
	afx_msg void OnScaleFreqLog();
	afx_msg void OnReleasedcaptureSliderZoomV(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnChangeTopcutFeld();
	afx_msg void OnChangeLiniendickeFeld();
	afx_msg void OnSave();
	afx_msg void OnEditClearall();
	afx_msg void OnEditCopy();
	afx_msg void OnPaletteFarbig2();
	afx_msg void OnCheckSmooth();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // AFX_SONOVIEW_H__C301C25F_8FB2_472F_A50F_4EA334B13601__INCLUDED_
