// Sounds.h : Haupt-Header-Datei fr die Anwendung SOUNDS
//

#if !defined(AFX_SOUNDS_H__FAE84B8B_B6B7_4080_BF38_0FED7912383D__INCLUDED_)
#define AFX_SOUNDS_H__FAE84B8B_B6B7_4080_BF38_0FED7912383D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       //Hauptsymbole
#include "SoundsDoc.h"       // Dokument
#include "Ini.h"

#define WM_USER_CAPTURE_DONE (WM_USER + 2)
#define WM_USER_CAPTURE_NOW (WM_USER + 3)
#define WM_USER_PLAY_IN_PROGRESS (WM_USER + 4)
#define WM_USER_PLAY_STOP (WM_USER + 5)
#define WM_USER_PLAY_NOW (WM_USER + 6)
#define WM_USER_PLAY_NOTIFY_DONE (WM_USER + 7)
#define WM_USER_SETFFTBAR (WM_USER + 8)
#define WM_USER_SETWAVEFILEBAR (WM_USER + 10)
#define WM_USER_SETWAVEBITBAR (WM_USER + 11)
#define WM_USER_SETWAVEKHZBAR (WM_USER + 12)
#define WM_USER_SETCAPTUREBAR (WM_USER + 13)
#define WM_USER_SETRECORDBAR (WM_USER + 14)
#define WM_USER_SETPROGRESS (WM_USER + 16)

enum Views {MAIN,UEBERSICHT,FFT,ANALYSE,REKO,FFT3D,NOTENBILD,SONO,WAVELET,ZEITREIHE};
enum Profiles {STANDARD, MUSIKER,ANALYTIKER,KOMPLETT,GRUNDSCHULE,OBERSCHULE,RECENT,SELFDEFINED};

/////////////////////////////////////////////////////////////////////////////
// CSoundsApp:
// Siehe Sounds.cpp fr die Implementierung dieser Klasse
//

class CSoundsApp : public CWinApp
{
public:
	CSoundsApp();
	~CSoundsApp();

/*  CMultiDocTemplate* pDocTemplate;
  CMultiDocTemplate* m_pFFTViewTemplate;
  CMultiDocTemplate* m_pFFT3DViewTemplate;
  CMultiDocTemplate* m_pRekoTemplate;
  CMultiDocTemplate* m_pZeitreiheViewTemplate;
  CMultiDocTemplate* m_pInfoTemplate;
	CMultiDocTemplate* m_pOverViewTemplate;
	CMultiDocTemplate* m_pSonoViewTemplate;
	CMultiDocTemplate* m_pAnalyseViewTemplate;
	CMultiDocTemplate* m_pNotenbildViewTemplate;
	CMultiDocTemplate* m_pWaveletViewTemplate;
*/
	
	CSoundsDoc* mp_doc;

  LPDIRECTSOUND8							m_pDS;
	LPDIRECTSOUNDCAPTURE8				m_pDSCapture;
	CSoundManager*							m_pSoundManager;

	CString											m_strSoundAusgang;
	CString											m_strSoundEingang;

// 	LPDIRECTSOUNDBUFFER					m_pTonBuffer;
protected:
  LPDIRECTSOUNDBUFFER					m_pDSBPrimary;
  GUID*												m_pSoundGUID;
  GUID*												m_pCaptureGUID;
	CString											m_strIniFile;
	Profiles										m_Profil;
	CString											m_strSelfDefinedProfileName;
	BOOL												m_bStartWithDatei;
	CString											m_strAppTitle;
//Die INIVariablenkopien zum Export in die Module
protected:
	//ALLGEMEIN
	DWORD								IniAllgemeinLanguage;
	BOOL								IniAllgemeinGrundschulprofil;
	BOOL								IniAllgemeinStatusbar;
	BOOL								IniAllgemeinToolbarNormal;
	BOOL								IniAllgemeinToolbarSchule;
	BOOL								IniAllgemeinMenu;
	
	//DOKUMENT
	INT									IniDokumentNumFFTPoints;
	CString							IniDokumentPlayFile;
	
	//FENSTER
	INT									IniFensterFFT;
	INT									IniFensterFFT3D;
	INT									IniFensterAnalyse;
	INT									IniFensterNotenbild;
	INT									IniFensterReko;
	INT									IniFensterSono;
	INT									IniFensterWavelet;
	INT									IniFensterZeitreihe;
	
	//ZEITREIHE
	INT									IniZeitreiheKorrCount;
	long								IniZeitreihePartitions;
	long								IniZeitreiheCorrlength;
	INT									IniZeitreiheWhatIs;

	//FFT
	INT									IniFFTBottomCutHz;
	INT									IniFFTTopCutkHz;
	INT									IniFFTBottomCutAmp;
	INT									IniFFTTopCutAmp;
	BOOL								IniFFTbIsAmpLinear;
	BOOL								IniFFTbIsFreqLinear;
	INT									IniFFTbDarstellung;
	BOOL								IniFFTbIsSpline;
	BOOL								IniFFTbIsDelay;
	BOOL								IniFFTbIsSumme;
	BOOL								IniFFTbIsCrossVisible;
	BOOL								IniFFTbGrid;
	int									IniFFTDelay;
	INT									IniFFTSplineTyp;
	INT									IniFFTMinAbstandMaxima;
	INT									IniFFTMinAbstandNachbarMin;

	//3DFFT
	FLOAT	Ini3DFFTSchrittweite;
	DWORD	Ini3DFFTclrBackBuffer;
	INT		Ini3DFFTBottomCutHz;
	INT		Ini3DFFTTopCutkHz;
	FLOAT	Ini3DFFTSizePts;
	BOOL	Ini3DFFTbIsWire;
	INT		Ini3DFFTBreite;
	FLOAT	Ini3DFFTEpsilon;
	INT		Ini3DFFTTau;
	BOOL	Ini3DFFTbIsBunt;
	BOOL	Ini3DFFTbIsAmpLinear;
	BOOL	Ini3DFFTbIsFreqLinear;

	//REKONSTRUKTION
	INT		IniRekoTau;
	DWORD	IniRekoclrBackBuffer;
	FLOAT	IniRekoSizePts;
	BOOL	IniRekobIsPunkte;
	INT		IniRekoNumRekoPoints;
	BOOL	IniRekobIsBunt;

	//SONOGRAMM
	INT		IniSonoBottomCutHz;
	INT		IniSonoLiniendicke;
	BOOL	IniSonobIsSmooth;
	INT		IniSonoTopCutkHz;
	BOOL	IniSonobIsAmpLinear;
	BOOL	IniSonobIsFreqLinear;
	BOOL	IniSonobIsFarbig1;

	//NOTENBILD
	BOOL	IniNotenbildIsLinear;
	INT		IniNotenbildWhatIs;
	INT		IniNotenbildObertonanzahl;

	//WAVELET
	CString	IniWaveletWavelet;
	FLOAT			IniWaveletFreqmin;
	FLOAT			IniWaveletFreqmax;
	LONG		IniWaveletFreqn;
	LONG		IniWaveletZeitn;
	INT			IniWaveletadiv; 

	//ANALYSE
	INT																		IniAnalyseDimLya;
	INT																		IniAnalyseTauLya;
	INT																		IniAnalyseNumberOfLya;
	INT																		IniAnalyseIterLya;
	INT																		IniAnalyseNumPointsLya;
	INT																		IniAnalyseMaxDimLya;
	DOUBLE																IniAnalyseRadiusMinLya;

	INT																		IniAnalyseNumPointsLyaMax;
	INT																		IniAnalyseIterLyaMax;
	INT																		IniAnalyseNumberOfLyaMax;
	INT																		IniAnalyseTauLyaMax;
	DOUBLE																IniAnalyseRadiusMinLyaMax;
	DOUBLE																IniAnalyseRadiusMaxLyaMax;
	int																		IniAnalyseMinDimDoneMaxLya;
	int																		IniAnalyseMaxDimDoneMaxLya;
	INT																		IniAnalyseReferenzLyaMax;

	INT																		IniAnalyseDimKorr;
	INT																		IniAnalyseNumPointsKorr;
	INT																		IniAnalyseNumberOfKorr;
	INT																		IniAnalyseTauKorr;
	DOUBLE																IniAnalyseRadiusMinKorr;
	DOUBLE																IniAnalyseRadiusMaxKorr;
	INT																		IniAnalyseMaxDimKorr;
	INT																		IniAnalyseIterKorr;

	INT																		IniAnalyseWhatIs;

protected:
	HRESULT SetPrimaryBufferFormat( DWORD dwPrimaryChannels, DWORD dwPrimaryFreq, DWORD dwPrimaryBitRate );
	HRESULT FreeDirectSound();
	HRESULT InitDirectSoundInterfaces();
	BOOL		CheckForDirectX();

	DWORD		GetDXVersion();

	//Inibergabefunktionen
public:
	inline Profiles* GetProfile() { return &m_Profil; }

	//ALLGEMEIN
	inline DWORD* GetIniAllgemeinLanguage() { return &IniAllgemeinLanguage; }
	inline BOOL* GetIniAllgemeinGrundschulprofil() { return &IniAllgemeinGrundschulprofil; }
	inline BOOL* GetIniAllgemeinStatusbar() { return &IniAllgemeinStatusbar; }
	inline BOOL* GetIniAllgemeinToolbarNormal() { return &IniAllgemeinToolbarNormal; }
	inline BOOL* GetIniAllgemeinToolbarSchule() { return &IniAllgemeinToolbarSchule; }
	inline BOOL* GetIniAllgemeinMenu() { return &IniAllgemeinMenu; }

	//DOKUMENT
	inline INT* GetIniDokumentFFTPoints() { return &IniDokumentNumFFTPoints; }
	inline CString* GetIniDokumentPlayFile() { return &IniDokumentPlayFile; }

	//FENSTER
	inline INT* GetIniFensterFFT() { return &IniFensterFFT; }
	inline INT* GetIniFensterFFT3D() { return &IniFensterFFT3D; }
	inline INT* GetIniFensterAnalyse() { return &IniFensterAnalyse; }
	inline INT* GetIniFensterNotenbild() { return &IniFensterNotenbild; }
	inline INT* GetIniFensterReko() { return &IniFensterReko; }
	inline INT* GetIniFensterSono() { return &IniFensterSono; }
	inline INT* GetIniFensterWavelet() { return &IniFensterWavelet; }
	inline INT* GetIniFensterZeitreihe() { return &IniFensterZeitreihe; }

	//ZEITREIHE
	inline INT* GetIniZeitreiheKorrCount() { return &IniZeitreiheKorrCount; }
	inline long* GetIniZeitreihePartitions() { return &IniZeitreihePartitions; }
	inline long* GetIniZeitreiheCorrlength() { return &IniZeitreiheCorrlength; }
	inline INT* GetIniZeitreiheWhatIs() { return &IniZeitreiheWhatIs; }

	//FFT
	inline INT* GetIniFFTBottomCutHz() { return &IniFFTBottomCutHz; }
	inline INT* GetIniFFTTopCutkHz() { return &IniFFTTopCutkHz; }
	inline INT* GetIniFFTBottomCutAmp() { return &IniFFTBottomCutAmp; }
	inline INT* GetIniFFTTopCutAmp() { return &IniFFTTopCutAmp; }
	inline BOOL* GetIniFFTbIsAmpLinear() { return &IniFFTbIsAmpLinear; }
	inline BOOL* GetIniFFTbIsFreqLinear() { return &IniFFTbIsFreqLinear; }
	inline INT* GetIniFFTbDarstellung() { return &IniFFTbDarstellung; }
	inline BOOL* GetIniFFTbIsSpline() { return &IniFFTbIsSpline; }
	inline BOOL* GetIniFFTbIsDelay() { return &IniFFTbIsDelay; }
	inline BOOL* GetIniFFTbIsSumme() { return &IniFFTbIsSumme; }
	inline BOOL* GetIniFFTbIsCrossVisible() { return &IniFFTbIsCrossVisible; }
	inline INT* GetIniFFTDelay() { return &IniFFTDelay; }
	inline BOOL* GetIniFFTbGrid() { return &IniFFTbGrid; }
	inline INT* GetIniFFTSplineTyp() { return &IniFFTSplineTyp; }
	inline INT* GetIniFFTMinAbstandMaxima() { return &IniFFTMinAbstandMaxima; }
	inline INT* GetIniFFTMinAbstandNachbarMin() { return &IniFFTMinAbstandNachbarMin; }
	//3DFFT
	inline FLOAT* GetIni3DFFTSchrittweite() { return &Ini3DFFTSchrittweite;}
	inline DWORD* GetIni3DFFTclrBackBuffer() { return &Ini3DFFTclrBackBuffer;}
	inline INT* GetIni3DFFTBottomCutHz() { return &Ini3DFFTBottomCutHz;}
	inline INT* GetIni3DFFTTopCutkHz() { return &Ini3DFFTTopCutkHz;}
	inline FLOAT* GetIni3DFFTSizePts() { return &Ini3DFFTSizePts;}
	inline BOOL* GetIni3DFFTbIsWire() { return &Ini3DFFTbIsWire;}
	inline INT* GetIni3DFFTBreite() { return &Ini3DFFTBreite;}
	inline FLOAT* GetIni3DFFTEpsilon() { return &Ini3DFFTEpsilon;}
	inline INT* GetIni3DFFTTau() { return &Ini3DFFTTau;}
	inline BOOL* GetIni3DFFTbIsBunt() { return &Ini3DFFTbIsBunt;}
	inline BOOL* GetIni3DFFTbIsAmpLinear() { return &Ini3DFFTbIsAmpLinear;}
	inline BOOL* GetIni3DFFTbIsFreqLinear() { return &Ini3DFFTbIsFreqLinear;}
	//REKONSTRUKTION
	inline INT* GetIniRekoTau() { return &IniRekoTau;}
	inline DWORD* GetIniRekoclrBackBuffer() { return &IniRekoclrBackBuffer;}
	inline FLOAT* GetIniRekoSizePts() { return &IniRekoSizePts;}
	inline BOOL* GetIniRekobIsPunkte() { return &IniRekobIsPunkte;}
	inline INT* GetIniRekoNumRekoPoints() { return &IniRekoNumRekoPoints;}
	inline BOOL* GetIniRekobIsBunt() { return &IniRekobIsBunt;}
	//SONOGRAMM
	inline INT* GetIniSonoBottomCutHz() { return &IniSonoBottomCutHz;}
	inline INT* GetIniSonoLiniendicke() { return &IniSonoLiniendicke;}
	inline BOOL* GetIniSonobIsSmooth() { return &IniSonobIsSmooth;}
	inline INT* GetIniSonoTopCutkHz() { return &IniSonoTopCutkHz;}
	inline BOOL* GetIniSonobIsAmpLinear() { return &IniSonobIsAmpLinear;}
	inline BOOL* GetIniSonobIsFreqLinear() { return &IniSonobIsFreqLinear;}
	inline BOOL* GetIniSonobIsFarbig1() { return &IniSonobIsFarbig1;}
	//NOTENBILD
	inline BOOL* GetIniNotenbildbisLinear() { return &IniNotenbildIsLinear;}
	inline INT* GetIniNotenbildWhatIs() { return &IniNotenbildWhatIs;}
	inline INT* GetIniNotenbildObertonanzahl() { return &IniNotenbildObertonanzahl;}
	//WAVELET
	inline CString* GetIniWaveletWavelet() { return &IniWaveletWavelet;}
	inline FLOAT* GetIniWaveletFreqmin() { return &IniWaveletFreqmin;}
	inline FLOAT* GetIniWaveletFreqmax() { return &IniWaveletFreqmax;}
	inline LONG* GetIniWaveletFreqn() { return &IniWaveletFreqn;}
	inline LONG* GetIniWaveletZeitn() { return &IniWaveletZeitn;}
	inline INT* GetIniWaveletadiv() { return &IniWaveletadiv;}
	//ANALYSE
	inline INT* GetIniAnalyseDimLya() { return &IniAnalyseDimLya; }
	inline INT* GetIniAnalyseTauLya() { return &IniAnalyseTauLya; }
	inline INT* GetIniAnalyseNumberOfLya() { return &IniAnalyseNumberOfLya; }
	inline INT* GetIniAnalyseIterLya() { return &IniAnalyseIterLya; }
	inline INT* GetIniAnalyseNumPointsLya() { return &IniAnalyseNumPointsLya; }
	inline INT* GetIniAnalyseMaxDimLya() { return &IniAnalyseMaxDimLya; }
	inline DOUBLE* GetIniAnalyseRadiusMinLya() { return &IniAnalyseRadiusMinLya; }

	inline INT* GetIniAnalyseNumPointsLyaMax() { return &IniAnalyseNumPointsLyaMax; }
	inline INT* GetIniAnalyseIterLyaMax() { return &IniAnalyseIterLyaMax; }
	inline INT* GetIniAnalyseNumberOfLyaMax() { return &IniAnalyseNumberOfLyaMax; }
	inline INT* GetIniAnalyseTauLyaMax() { return &IniAnalyseTauLyaMax; }
	inline DOUBLE* GetIniAnalyseRadiusMinLyaMax() { return &IniAnalyseRadiusMinLyaMax; }
	inline DOUBLE* GetIniAnalyseRadiusMaxLyaMax() { return &IniAnalyseRadiusMaxLyaMax; }
	inline INT* GetIniAnalyseMinDimDoneMaxLya() { return &IniAnalyseMinDimDoneMaxLya; }
	inline INT* GetIniAnalyseMaxDimDoneMaxLya() { return &IniAnalyseMaxDimDoneMaxLya; }
	inline INT* GetIniAnalyseReferenzLyaMax() { return &IniAnalyseReferenzLyaMax; }

	inline INT* GetIniAnalyseDimKorr() { return &IniAnalyseDimKorr; }
	inline INT* GetIniAnalyseNumPointsKorr() { return &IniAnalyseNumPointsKorr; }
	inline INT* GetIniAnalyseNumberOfKorr() { return &IniAnalyseNumberOfKorr; }
	inline INT* GetIniAnalyseTauKorr() { return &IniAnalyseTauKorr; }
	inline DOUBLE* GetIniAnalyseRadiusMinKorr() { return &IniAnalyseRadiusMinKorr; }
	inline DOUBLE* GetIniAnalyseRadiusMaxKorr() { return &IniAnalyseRadiusMaxKorr; }
	inline INT* GetIniAnalyseMaxDimKorr() { return &IniAnalyseMaxDimKorr; }
	inline INT* GetIniAnalyseIterKorr() { return &IniAnalyseIterKorr; }

	inline INT* GetIniAnalyseWhatIs() { return &IniAnalyseWhatIs; }

	// BEGIN WINDOW PLACEMENT CODE

private:
	WINDOWPLACEMENT m_WPMain;
	WINDOWPLACEMENT m_WPUebersicht;
	WINDOWPLACEMENT m_WPFFT;
	WINDOWPLACEMENT m_WPFFT3D;
	WINDOWPLACEMENT m_WPAnalyse;
	WINDOWPLACEMENT m_WPNotenbild;
	WINDOWPLACEMENT m_WPReko;
	WINDOWPLACEMENT m_WPSono;
	WINDOWPLACEMENT m_WPWavelet;
	WINDOWPLACEMENT m_WPZeitreihe;
	
public:
	const WINDOWPLACEMENT& GetWP(Views eView) const;
	void PutWP(const WINDOWPLACEMENT& newval, Views eView);
	CString GetModulPath();
	void SwitchWindowplacementAbsolutePercent(BOOL bToPercent,WINDOWPLACEMENT* pwp);
	void SwitchWindowDlgBars(BOOL bDlgOn,BOOL bRedrawFrame);

protected:
//	virtual void ReadWindowConfig(void);
//	virtual void ReadWindowConfig2(WINDOWPLACEMENT wpDefault, WINDOWPLACEMENT* wpRead, LPCTSTR Section);
//	virtual void WriteWindowConfig(WINDOWPLACEMENT wp,LPCTSTR Section);
	virtual void WindowConfigIni(CIni ini,BOOL bFromIni, WINDOWPLACEMENT* wp, WINDOWPLACEMENT wpDefault, LPCTSTR Section);
	void	ScaleMainWindowIfLost(WINDOWPLACEMENT wp);
	BOOL		ReadIniFile();
	BOOL		WriteIniFile();
	void		UpdateIni(BOOL bFromIni =TRUE);
	BOOL		StartStdProfileDlg();
	BOOL		StartGrundschulDlg();
	void		GetWindowPlacementsAndParameters();
	BOOL		StartProfilDlg();
	void		ProfilVerwirklichen();
	void		SetLanguageSettings();

// END WINDOW PLACEMENT CODE


  // berladungen
	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CSoundsApp)
	public:
	virtual BOOL InitInstance();
	virtual BOOL OnIdle(LONG lCount);
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementierung
	//{{AFX_MSG(CSoundsApp)
	afx_msg void OnAppAbout();
	afx_msg HRESULT OnEinstellungenSoundkarte();
	afx_msg void OnSinglestep();
	afx_msg void OnMixer();
	afx_msg void OnBreak();
	afx_msg void OnEinstellungenProfilChoose();
	afx_msg void OnEinstellungenProfilWrite();
	afx_msg void OnHelpShortcuts();
	afx_msg void OnUpdate();
	afx_msg void OnEinstellungenLanguage();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

extern CSoundsApp		theApp;
extern BOOL					g_bIsCapturing; 
extern BOOL	 				g_bIsRecording; 
extern BOOL					g_bIsPlayingWave;	
extern BOOL					g_bIsWaveLoaded;	
extern BOOL					g_bLooped;	
extern BOOL					g_bIsConvertedPlay;
extern BOOL					g_bIsPutPoints;
extern BOOL					g_bIsBreak;
extern BOOL					g_bIsBusy;
extern HANDLE				g_hEventBreak;
extern BOOL					g_bLButtonDown;
extern block_pool		mem_pool;

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_SOUNDS_H__FAE84B8B_B6B7_4080_BF38_0FED7912383D__INCLUDED_)


