// SoundsView.cpp : Implementierung der Klasse CSoundsView
//

#include "stdafx.h"
#include "Sounds.h"
#include "SoundsDoc.h"
#include "SoundsView.h"
#include "SoundsOverView.h"
#include "spline.h"
#include "Splines.h"
#include "HuellkurveDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define RANDLOV 10	//Rand links im Overviewfenster
#define RANDROV 10  //Rand rechts im Overviewfenster siehe SoundsOverView.cpp
#define RANDL 10
#define RANDR 10
#define RANDO 10
#define RANDU 10

/////////////////////////////////////////////////////////////////////////////
// CSoundsView

IMPLEMENT_DYNCREATE(CSoundsView, CScrollView)

BEGIN_MESSAGE_MAP(CSoundsView, CScrollView)
	//{{AFX_MSG_MAP(CSoundsView)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_SIZE()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_WM_LBUTTONDBLCLK()
	ON_BN_CLICKED(IDC_HUELLKURVE, OnHuellkurve)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_SAVE, OnSave)
	ON_WM_HELPINFO()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
	// Standard-Druckbefehle
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSoundsView Konstruktion/Destruktion

CSoundsView::CSoundsView()
{
	m_HuellkurveDlg.Create(IDD_HUELLKURVE);
}

CSoundsView::~CSoundsView()
{
	DeleteObject(Rahmenstift);
	DeleteObject(Kurvenstift);
}

/////////////////////////////////////////////////////////////////////////////
// CSoundsView Zeichnen
void CSoundsView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();
	CRect rect;
	GetClientRect(rect);
	CSize sizeTotal;
	sizeTotal.cx = (rect.right-rect.left);
	sizeTotal.cy = (rect.bottom-rect.top);
	m_WAVKomplettPtArray.RemoveAll();
	m_ControlPointsOben.RemoveAll();
	m_ControlPointsUnten.RemoveAll();
	POINT Nullpunkt;
	Nullpunkt.x=0;
	Nullpunkt.y=0;
	m_AusschnittStart=Nullpunkt;
	m_AusschnittEnde=Nullpunkt;
	m_OldAusschnittStart=Nullpunkt;
	m_OldAusschnittEnde=Nullpunkt;
	m_Marker1=Nullpunkt;
	m_Marker2=Nullpunkt;
	m_WAVKomplettPtArray.Add(Nullpunkt);
	Rahmenstift.CreatePen(PS_SOLID,1,RGB(50,50,50));
  Kurvenstift.CreatePen(PS_SOLID,1,RGB(255,0,0));
	Markerstift.CreatePen(PS_SOLID,2,RGB(0,0,255));

	m_ZoomH_Overview=1;
	m_ZoomV=1;
	SetScrollSizes(MM_TEXT, sizeTotal);
	m_Recalc=FALSE;
	m_MoveMousePoint.x=0;
	m_pParentFrame=(CSplitterFrame*)GetParentFrame();
	m_PtsPerPixel=100;

	CButton* pRadioSample=(CButton*)m_pParentFrame->m_wndDlgBar.GetDlgItem(IDC_RADIO_SAMPLES);
	pRadioSample->SetCheck(1);
	CButton* pRadioHuelle=(CButton*)m_pParentFrame->m_wndDlgBar.GetDlgItem(IDC_RADIO_HUELLE);
	pRadioHuelle->SetCheck(0);
	m_bIsSamples=TRUE;

	m_HuellkurveDlg.SetOwner((CSoundsView*)this);
}

void CSoundsView::OnDraw(CDC* dc)
{
	CMemDC pDC(dc);
	CSoundsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CRect rect;
	GetClientRect(rect);
//	pDC->FillSolidRect(rect,RGB(255,255,255));
  pDC->SelectObject(&Kurvenstift);
	INT* pBitRate=pDoc->GetBitRate();
	BOOL* pSigned=pDoc->GetSigned();
	BYTE* pSoundBuffer=pDoc->GetSoundBuffer();
	DWORD* pSoundBufferSize=pDoc->GetSoundBufferSize();
	DOUBLE* pMaxAmplitude=pDoc->GetMaxAmplitude();
	POINT Nullpunkt;
	Nullpunkt.x=0;
	Nullpunkt.y=0;

	if (*pSoundBufferSize<10) 
	{
		m_WAVKomplettPtArray.RemoveAll();
		m_WAVKomplettPtArray.Add(Nullpunkt);
		m_ControlPointsOben.RemoveAll();
		m_ControlPointsUnten.RemoveAll();
	}
	INT Teiler=0;
	if (*pSigned)
		Teiler=2;
	else
		Teiler=1;
	
	//View Array neu skalieren
	DOUBLE FaktorX=0;
	INT FaktorIX=0;
	DOUBLE FaktorY=0;
	if (*pSoundBufferSize>1)
	{
	  if (((m_AusschnittStart.x!=m_OldAusschnittStart.x)&&(m_AusschnittEnde.x!=m_OldAusschnittEnde.x))||m_Recalc)
		{
			//Samples in m_WAVKomplettArray schreiben
			m_LastMousePoint=Nullpunkt;
			m_MoveMousePoint=Nullpunkt;
			m_FirstMousePoint=Nullpunkt;
			m_Marker1=Nullpunkt;
			m_Marker2=Nullpunkt;
			m_WAVKomplettPtArray.RemoveAll();
			m_ControlPointsOben.RemoveAll();
			m_ControlPointsUnten.RemoveAll();
		}
			POINT Messpunkt;
			INT Start=0,Ende=0;
			DOUBLE FaktorPufferSize=0;
			CSize Size=GetTotalSize();
			DOUBLE BufferSizeInSamples=*pBitRate==16?*pSoundBufferSize/2:*pSoundBufferSize;

			CSoundsOverView* pWnd1=(CSoundsOverView*)m_pParentFrame->m_wndSplitter.GetPane(0,0);
			CSize SizeOverview=pWnd1->GetTotalSize();
			Start=(INT)(m_AusschnittStart.x*(BufferSizeInSamples/(SizeOverview.cx-RANDLOV-RANDROV)));
			Ende=(INT)(m_AusschnittEnde.x*(BufferSizeInSamples/(SizeOverview.cx-RANDLOV-RANDROV)));
			m_StartAusschnitt=Start-Start%2;
			m_EndeAusschnitt=Ende-Ende%2;
			if (m_EndeAusschnitt-m_StartAusschnitt!=0) 
//					m_EndeAusschnitt=m_StartAusschnitt+4;
			{
				DOUBLE AnzahlSamples=m_EndeAusschnitt-m_StartAusschnitt;

			INT m_ZoomH=1;
			FaktorIX=(INT)ceil(AnzahlSamples/((rect.right-RANDL-RANDR)*m_ZoomH)/m_PtsPerPixel); 
			DOUBLE NeueScrollbreiteInPixel=rect.right-RANDL-RANDR;
			int i=0;
			short sample;
			pDC->SelectObject(&Kurvenstift);
			for(int register x=(INT)m_StartAusschnitt;x<(long)(m_StartAusschnitt+AnzahlSamples);x=x+FaktorIX)	
			{
				sample=*pBitRate==8?((*((BYTE*)pSoundBuffer+x)-128)*((rect.bottom-RANDO-RANDU)*m_ZoomV/2))/128:\
														((*((short*)pSoundBuffer+x))*((rect.bottom-RANDO-RANDU)*m_ZoomV/2))/(65536/2);
				Messpunkt.x=RANDL+(LONG)((x-m_StartAusschnitt)*NeueScrollbreiteInPixel/(DOUBLE)AnzahlSamples);
				Messpunkt.y=(rect.bottom-RANDO-RANDU)/2-sample+RANDO;
				if (x==(INT)m_StartAusschnitt) 
					pDC->MoveTo(Messpunkt);
				else
					pDC->LineTo(Messpunkt);
//				m_WAVKomplettPtArray.Add(Messpunkt);
			}
			m_Recalc=FALSE;
			
			//Einhllende berechnen
			if (!m_bIsSamples) 
			{
//				BerechneEinhuellende();
			}


		 if (((m_AusschnittStart.x!=m_OldAusschnittStart.x)&&(m_AusschnittEnde.x!=m_OldAusschnittEnde.x))||m_Recalc)
			{
				//Reskalieren
				m_OldAusschnittStart=m_AusschnittStart;
				m_OldAusschnittEnde=m_AusschnittEnde;
				CSize sizeTotal;
				sizeTotal.cx = rect.right;
				sizeTotal.cy = rect.bottom;
				SetScrollSizes(MM_TEXT, sizeTotal);
			}
		}

		GetClientRect(rect);

/*		//Zeitreihe zeichnen  
		if (m_bIsSamples) 
		{
			POINT Anfangspunkt;
			pDC->SelectObject(&Kurvenstift);
			if (m_WAVKomplettPtArray.GetSize()>1) 
			{	
				Anfangspunkt=m_WAVKomplettPtArray[0];
				pDC->MoveTo(Anfangspunkt);
			  INT i=0;
			  while (i <= (m_WAVKomplettPtArray.GetSize()-1))
				{
					POINT NextPunkt=m_WAVKomplettPtArray[i];
				  pDC->LineTo(NextPunkt);
				  i++;
		    }
			}
		}
		else
		{
			if (m_ControlPointsOben.GetSize()>5) 
			{
				CPen HauchStift;
				HauchStift.CreatePen(PS_SOLID,1,RGB(255,0,0));
				pDC->SelectObject(&HauchStift);
				CBrush RotPinsel;
				RotPinsel.CreateSolidBrush(RGB(254,0,0));
				pDC->SelectObject(&RotPinsel);

				pDC->SetPolyFillMode(WINDING);
				pDC->BeginPath();

				pDC->MoveTo(0,rect.bottom/2);
				pDC->LineTo(0,m_ControlPointsOben.GetAt(0).y);
				pDC->LineTo(m_ControlPointsOben.GetAt(0));
				pDC->PolylineTo(m_ControlPointsOben.GetData(), m_ControlPointsOben.GetSize());
				pDC->LineTo(rect.right,m_ControlPointsOben.GetAt(m_ControlPointsOben.GetSize()-1).y);
				pDC->LineTo(rect.right,rect.bottom/2);
				pDC->LineTo(0,rect.bottom/2);
				pDC->CloseFigure();
				pDC->EndPath();
//				pDC->StrokePath();
				pDC->FillPath();

				pDC->BeginPath();
				pDC->MoveTo(0,rect.bottom/2);
				pDC->LineTo(0,m_ControlPointsUnten.GetAt(0).y);
				pDC->LineTo(m_ControlPointsUnten.GetAt(0));
				pDC->PolylineTo(m_ControlPointsUnten.GetData(), m_ControlPointsUnten.GetSize());
				pDC->LineTo(rect.right,m_ControlPointsUnten.GetAt(m_ControlPointsUnten.GetSize()-1).y);
				pDC->LineTo(rect.right,rect.bottom/2);
				pDC->LineTo(0,rect.bottom/2);
				pDC->CloseFigure();
				//Path schlieen
				pDC->EndPath();
//				pDC->StrokePath();
				pDC->FillPath();

				//Nulllinie zeichnen
				pDC->SelectObject(&Rahmenstift);
				pDC->MoveTo(rect.right,rect.bottom/2);
				pDC->LineTo(0,rect.bottom/2);
			}	
		}
*/
		//Rahmenauswahl zeichnen
		pDC->SelectObject(&Rahmenstift);
		if (m_MoveMousePoint.x!=0) 
		{
			CPen pe(PS_NULL,0,COLORREF(0));
			CPen* oldp =pDC->SelectObject (&pe);
			pDC->SetROP2(R2_NOT);
			pDC->Rectangle (m_FirstMousePoint.x,RANDO,m_LastMousePoint.x,rect.bottom-RANDU);
			pDC->SelectObject (oldp);
		}
	}
	//Markerpunkte zeichnen
	pDC->SetROP2(R2_COPYPEN);
	pDC->SelectObject(&Markerstift);
	if (m_Marker1.x!=0)
	{
		pDC->MoveTo(m_Marker1.x,0);
		pDC->LineTo(m_Marker1.x,rect.bottom);
	}
	else
		m_bIsEinhuellende=FALSE;
	if (m_Marker2.x!=0)
	{
		pDC->MoveTo(m_Marker2.x,0);
		pDC->LineTo(m_Marker2.x,rect.bottom);
	}
	else
		m_bIsEinhuellende=FALSE;

	//Rnder zeichnen
	COLORREF bkg=GetSysColor(COLOR_MENU); 
	pDC->FillSolidRect(0,0,RANDL+1,rect.bottom+1,bkg);											//links
	pDC->FillSolidRect(0,0,rect.right+1,RANDO,bkg);													//oben
	pDC->FillSolidRect(rect.right-RANDR,0,rect.right+1,rect.bottom+1,bkg);	//rechts	
	pDC->FillSolidRect(0,rect.bottom-RANDU+1,rect.right+1,rect.bottom+1,bkg);		//unten
}


/////////////////////////////////////////////////////////////////////////////
// CSoundsView Drucken
/*
BOOL CSoundsView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// Standardvorbereitung
	return DoPreparePrinting(pInfo);
}
*/
/*void CSoundsView::OnBeginPrinting(CDC* /*pDC*//*, CPrintInfo* /*pInfo*//*)
{
	// ZU ERLEDIGEN: Zustzliche Initialisierung vor dem Drucken hier einfgen
}

void CSoundsView::OnEndPrinting(CDC* /*pDC*//*, CPrintInfo* /*pInfo*//*)
{
	// ZU ERLEDIGEN: Hier Bereinigungsarbeiten nach dem Drucken einfgen
}
*/
/////////////////////////////////////////////////////////////////////////////
// CSoundsView Diagnose

#ifdef _DEBUG
void CSoundsView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CSoundsView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CSoundsDoc* CSoundsView::GetDocument() // Die endgltige (nicht zur Fehlersuche kompilierte) Version ist Inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSoundsDoc)));
	return (CSoundsDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSoundsView Nachrichten-Handler


void CSoundsView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	CScrollView::OnRButtonDown(nFlags, point);
}

void CSoundsView::OnRButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Code fr die Behandlungsroutine fr Nachrichten hier einfgen und/oder Standard aufrufen
	
	CScrollView::OnRButtonUp(nFlags, point);
}

void CSoundsView::RaenderKorrigieren(CPoint* point,CRect ClientRect ) 
{
		//In Rand hineinfahren abfangen
		if (point->x<RANDL) 
		{
			point->x=RANDL;
		}
		//Wenn Maus im rechten Rand auf Ende setzen
		if (point->x>ClientRect.right-RANDR) 
		{
			point->x=ClientRect.right-RANDR;
		}
}

void CSoundsView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CRect rect;
	GetClientRect(&rect);

	//alte Markierung entfernen
	CRect Region;
	Region.left=m_FirstMousePoint.x;
	Region.top=RANDO;
	Region.bottom=rect.bottom-RANDU;
	Region.right=m_LastMousePoint.x;
	CDC* pDC=GetDC();
	pDC->InvertRect(&Region);
	ReleaseDC(pDC);

	RaenderKorrigieren(&point,rect);

	m_MoveMousePoint.x=RANDL;
//	m_AusschnittStart.x=point.x;
	POINT Nullpunkt;
	Nullpunkt.x=RANDL;
	Nullpunkt.y=0;
	m_LastMousePoint=Nullpunkt;
	m_FirstMousePoint=point;
	m_MoveMousePoint=point;
	CScrollView::OnLButtonDown(nFlags, point);
}

void CSoundsView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	CScrollView::OnLButtonUp(nFlags, point);
	CRect rect;
	GetClientRect(rect);
	RaenderKorrigieren(&point,rect);

	m_LastMousePoint=point;
//	m_MoveMousePoint.x=0;
	if (m_FirstMousePoint.x>m_LastMousePoint.x) 
		{
			POINT Tausch;
			Tausch=m_FirstMousePoint;
			m_FirstMousePoint=m_LastMousePoint;
			m_LastMousePoint=Tausch;
		}

	if ((m_EndeAusschnitt-m_StartAusschnitt)!=0) 
	{
		INT Start=(INT)(m_StartAusschnitt+(m_FirstMousePoint.x-RANDL)*((m_EndeAusschnitt-m_StartAusschnitt)/(rect.right-RANDL-RANDR)));
		INT Ende=(INT)(m_StartAusschnitt+(m_LastMousePoint.x-RANDL)*((m_EndeAusschnitt-m_StartAusschnitt)/(rect.right-RANDL-RANDR)));
		CSoundsDoc* pDoc=GetDocument();
		if (*pDoc->GetBitRate()==16) 
		{
			Ende=Ende-Ende%2;
			Start=Start-Start%2;
//			Ende=Ende*2;
//			Start=Start*2;
		}
		pDoc->PutNewWaveCutPointsInArrays(Start,Ende);
	}

	//Neuzeichnen des Fensters verhinden
	ValidateRect(rect);
}

void CSoundsView::OnMouseMove(UINT nFlags, CPoint point) 
{

  if (nFlags==MK_LBUTTON)
  {
		CSoundsDoc* pDoc=GetDocument();
		CRect rect;
		GetClientRect(rect);
		RaenderKorrigieren(&point,rect);

//		CPen pe(PS_NULL,0,RGB(255,255,255));
//		CPen* oldp =pDC->SelectObject (&pe);
		CRect Region;
		Region.left=m_MoveMousePoint.x;
		Region.top=RANDO;
		Region.bottom=rect.bottom-RANDU;
		Region.right=point.x;
		CDC* pDC = GetDC();
 		pDC->InvertRect (&Region);
//		pDC->SelectObject (oldp);
		ReleaseDC (pDC);	
		m_MoveMousePoint=point;
		INT Start=(INT)(m_StartAusschnitt+m_FirstMousePoint.x*((m_EndeAusschnitt-m_StartAusschnitt)/(rect.right-RANDL-RANDR)));
		INT Ende=(INT)(m_StartAusschnitt+m_MoveMousePoint.x*((m_EndeAusschnitt-m_StartAusschnitt)/(rect.right-RANDL-RANDR)));
		INT AnzahlPunkte=Ende-Start<0?Start-Ende:Ende-Start;
// 		AnzahlPunkte=*pDoc->GetBitRate()==8?AnzahlPunkte:AnzahlPunkte/2;
		m_pParentFrame->m_wndDlgBar.SetDlgItemInt(IDC_ANZAHLPUNKTE,AnzahlPunkte,FALSE);
	}
//	CScrollView::OnMouseMove(nFlags, point);
}

void CSoundsView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	if (lHint==50||lHint==2)
		Invalidate(TRUE);
}

void CSoundsView::OnSize(UINT nType, int cx, int cy) 
{
	CScrollView::OnSize(nType, cx, cy);
	CSize sizeTotal;
	sizeTotal.cx = cx;
	sizeTotal.cy = cy;
	SetScrollSizes(MM_TEXT, sizeTotal);
	m_Recalc=TRUE;
	Invalidate(TRUE);
}


void CSoundsView::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	POINT Nullpunkt;
	Nullpunkt.x=0;
	Nullpunkt.y=0;
	switch(IsAtMarkerLine(&point)) 
	{
	case 0:
			if (m_Marker1.x==0) 
				m_Marker1=point;
			else  if (m_Marker2.x==0)
							m_Marker2=point;
						else
						{
							if (abs(m_Marker1.x-point.x)<abs(m_Marker2.x-point.x)) 
								m_Marker1=point;
							else
								m_Marker2=point;
						}
			break;

			
/*			if (m_Marker1.x==-1) 
		{
			m_Marker1=point;
		}
		else
		{
			m_Marker2=point;
		}
//		pDC->SelectObject(&Markerstift);
//		pDC->MoveTo(point.x,0);
//		pDC->LineTo(point.x,rect.bottom);
		break;
		*/
	case 1:
		m_Marker1=Nullpunkt;
		break;
	case 2:
		m_Marker2=Nullpunkt;
		break;
	}
/*	if (m_Marker1.x>m_Marker2.x&&m_Marker1.x!=-1&&m_Marker2.x!=-1) 
	{
		POINT TempPoint;
		TempPoint=m_Marker1;
		m_Marker1=m_Marker2;
		m_Marker2=TempPoint;
	}
	*/
		if (m_Marker1.x>m_Marker2.x&&m_Marker1.x!=0&&m_Marker2.x!=0) 
		{
			POINT TempPoint;
			TempPoint=m_Marker1;
			m_Marker1=m_Marker2;
			m_Marker2=TempPoint;
		}

	Invalidate(TRUE);
	CScrollView::OnLButtonDblClk(nFlags, point);
}

int CSoundsView::IsAtMarkerLine(POINT* ppoint)
{
	if (Distance(&m_Marker1,ppoint)<5)
		return 1;
	if (Distance(&m_Marker2,ppoint)<5)
		return 2;

	return 0;
}

double CSoundsView::Distance(POINT* p1, POINT* p2)
{
	int dx = abs(p1->x - p2->x);
//	int dy = abs(p1->y - p2->y);
	return dx;
//	return sqrt(dx*dx + dy*dy);
}

HENHMETAFILE CSoundsView::DrawPointsToMetaFile(CArray<POINT,POINT>* pPunkte,LPCTSTR FileName,BOOL IsDrawSpline)
{
	CMetaFileDC * pMetaDC = new CMetaFileDC();
	// Obtain a handle to a reference device context. 
	CDC* RefDC = GetDC(); 
	INT iWidthMM = GetDeviceCaps(RefDC->GetSafeHdc(), HORZSIZE); 
	INT iHeightMM = GetDeviceCaps(RefDC->GetSafeHdc(), VERTSIZE); 
	INT iWidthPels = GetDeviceCaps(RefDC->GetSafeHdc(), HORZRES); 
	INT iHeightPels = GetDeviceCaps(RefDC->GetSafeHdc(), VERTRES); 
	// Retrieve the coordinates of the client rectangle, in pixels. 
	CRect Specialrect;
	GetClientRect(Specialrect); 
 
	Specialrect.left = (Specialrect.left * iWidthMM * 100)/iWidthPels; 
	Specialrect.top = (Specialrect.top * iHeightMM * 100)/iHeightPels; 
	Specialrect.right = (Specialrect.right * iWidthMM * 100)/iWidthPels; 
	Specialrect.bottom = (Specialrect.bottom * iHeightMM * 100)/iHeightPels; 

	pMetaDC->CreateEnhanced(RefDC,FileName,Specialrect,"SOUNDS Soundanalyse\0Hllkurve\0\0");

	CRect rect;
	GetClientRect(rect); 
	
	//optimierte Hllkurve zeichnen
	CPen HauchStift;
	HauchStift.CreatePen(PS_SOLID,1,RGB(255,0,0));
	pMetaDC->SelectObject(&HauchStift);
	CBrush RotPinsel;
	RotPinsel.CreateSolidBrush(RGB(254,0,0));
	pMetaDC->SelectObject(&RotPinsel);
	pMetaDC->FillSolidRect(rect,RGB(255,255,255));
	pMetaDC->SetPolyFillMode(WINDING);

			//			pMetaDC->BeginPath();

//			pMetaDC->MoveTo(0,DialogRect.bottom/2);
//			pMetaDC->LineTo(0,m_HuellkurveObenArray.GetAt(0).y);
//			pMetaDC->LineTo(m_HuellkurveObenArray.GetAt(0));
//			pMetaDC->Polyline(m_HuellkurveObenArray.GetData(), m_HuellkurveObenArray.GetSize());
			//draw the control points
			ControlArray.RemoveAll();
			if (IsDrawSpline) 
			{
//				for	(int i=0; i<pPunkte->GetSize(); i++)
//				{
				INT i=0;
				BOOL Stop=FALSE;
					while (pPunkte->GetAt(i).x<rect.right/8)
					{
						ControlArray.Add(pPunkte->GetAt(i));
						i+=3;
						if (i>=pPunkte->GetSize())
						{
							Stop=TRUE;
							break;
						}
					}
					if (!Stop)
					while (pPunkte->GetAt(i).x<rect.right*1/4)
					{
						ControlArray.Add(pPunkte->GetAt(i));
						i+=10;
						if (i>=pPunkte->GetSize())
						{
							Stop=TRUE;
							break;
						}
					}
					if (!Stop)
					while (pPunkte->GetAt(i).x<rect.right*3/4)
					{
						ControlArray.Add(pPunkte->GetAt(i));
						i+=30;
						if (i>=pPunkte->GetSize())
						{
							Stop=TRUE;
							break;
						}
					}
					if (!Stop)
					while (pPunkte->GetAt(i).x>rect.right*3/4)
					{
						ControlArray.Add(pPunkte->GetAt(i));
						i+=10;
						if (i>=pPunkte->GetSize())
						{
							Stop=TRUE;
							break;
						}
					}
					if (!Stop)
					while (pPunkte->GetAt(i).x>rect.right/4)
					{
						ControlArray.Add(pPunkte->GetAt(i));
						i+=30;
						if (i>=pPunkte->GetSize())
						{
							Stop=TRUE;
							break;
						}
					}
					if (!Stop)
					while (pPunkte->GetAt(i).x>rect.right/8)
					{
						ControlArray.Add(pPunkte->GetAt(i));
						i+=10;
						if (i>=pPunkte->GetSize())
						{
							Stop=TRUE;
							break;
						}
					}
					if (!Stop)
					while (i<pPunkte->GetSize())
					{
						ControlArray.Add(pPunkte->GetAt(i));
						i+=3;
						if (i>=pPunkte->GetSize())
						{
							Stop=TRUE;
							break;
						}
					}
/*
					INT Count=0;
					ControlArray.Add(pPunkte->GetAt(i));
					while (abs(pPunkte->GetAt(i-1).y-pPunkte->GetAt(i).y)<5) 
					{
						Count++;
						i++;
						if (i==pPunkte->GetSize()) break;
						if (Count==10) break;
					}
*/
// 				}

					int Laenge=m_CtrlOptimierePoints.GetSize();
					if (Laenge>0) 
					{
						//Mit Maus vorgenomme nderungen bercksichtigen
						for(i=0; i<Laenge;i++)
						{
							int Stelle=m_CtrlOptimierePoints.GetAt(i).x;
							if (m_CtrlOptimierePoints.GetAt(i).y==0&&Stelle-2>0&&ControlArray.GetSize()>Stelle) 
							{
								ControlArray.RemoveAt(m_CtrlOptimierePoints.GetAt(i).x-2);
							}
							else
							{
								int j=0;
								if (m_CtrlOptimierePoints.GetAt(i).y<=rect.bottom/2) 
								{
									while (ControlArray.GetAt(j).x<Stelle)
									{
										j++;
										if (j==ControlArray.GetSize()) break;
									}
									ControlArray.InsertAt(j,m_CtrlOptimierePoints.GetAt(i));
								}
								else
								{
									while (ControlArray.GetAt(j).y<=rect.bottom/2)
									{
										j++;
									}
									while (ControlArray.GetAt(j).x>Stelle)
									{
										j++;
										if (j==ControlArray.GetSize()) break;
									}
									ControlArray.InsertAt(j,m_CtrlOptimierePoints.GetAt(i));

								}
							}
						}
					}

					
				ControlArray.InsertAt(0,ControlArray.GetAt(0));
				ControlArray.InsertAt(0,ControlArray.GetAt(0));
				ControlArray.Add(ControlArray.GetAt(ControlArray.GetSize()-1));
				ControlArray.Add(ControlArray.GetAt(ControlArray.GetSize()-1));
				Spline HuellSpline(ControlArray.GetData(), ControlArray.GetSize());
				HuellSpline.Generate();
				CSplines SplineHelper;
				SplineHelper.ZeichneBSpline(pMetaDC,ControlArray.GetData(),ControlArray.GetSize(),RGB(0,0,255));
				for(i=0; i<ControlArray.GetSize(); i++)
					DrawCross(ControlArray.GetAt(i), RGB(255,0,0), 3,pMetaDC);
			}
			else
			{
				for(int i=0; i<pPunkte->GetSize(); i++)
					DrawCross(pPunkte->GetAt(i), RGB(0,255,0), 3,pMetaDC);
			}

			//Nulllinie zeichnen
			pMetaDC->SelectObject(&Rahmenstift);
			pMetaDC->MoveTo(rect.right,rect.bottom/2);
			pMetaDC->LineTo(0,rect.bottom/2);

			//close meta file
			HENHMETAFILE hMF = pMetaDC->CloseEnhanced();

			delete pMetaDC;

			return hMF;
}

void CSoundsView::OnHuellkurve() 
{
	CRect rect;
	GetClientRect(rect);
	INT Start=0;
	INT Ende=0;
	DOUBLE AusschnittsLaengeOverviewinSamples=m_EndeAusschnitt-m_StartAusschnitt;
	if (AusschnittsLaengeOverviewinSamples!=0) 
	{
		if (m_Marker1.x==0||m_Marker2.x==0) 
		{
			AfxMessageBox(IDS_ONHUELLKURVE);
		}
		else 
		{
			CSplines SplineHelper;
			Start=(INT)(m_StartAusschnitt+m_Marker1.x*(AusschnittsLaengeOverviewinSamples/rect.right));
			Ende=(INT)(m_StartAusschnitt+m_Marker2.x*(AusschnittsLaengeOverviewinSamples/rect.right));

			BerechneHuellkurve(Start,Ende);
			Invalidate(TRUE);
			m_bIsEinhuellende=TRUE;

			CRect DialogRect,Position;
			Position.left=200;
			Position.right=500;
			Position.top=0;
			Position.bottom=250;
			m_HuellkurveDlg.GetClientRect(DialogRect);

			DialogRect.top=0;
			DialogRect.bottom=200;
			DialogRect.left=0;
			DialogRect.right=300;

			CRect rect;
			GetClientRect(rect); 
	
			CArray<POINT,POINT> TempKurveOben;
			CArray<POINT,POINT> TempKurveUnten;


				INT i=0;
				INT MaxX=0;
				INT MaxY=0;
				INT MaxYOben=rect.bottom/2;
				INT MaxYUnten=0;
				//Neu Skalieren;
				while(i<m_ControlPointsObenSpline.GetSize())
				{
					if (m_ControlPointsObenSpline.GetAt(i).y<MaxYOben) MaxYOben=m_ControlPointsObenSpline.GetAt(i).y;
					i++;
				}
				i=0;
				while(i<m_ControlPointsUntenSpline.GetSize())
				{
					if (m_ControlPointsUntenSpline.GetAt(i).y>MaxYUnten) MaxYUnten=m_ControlPointsUntenSpline.GetAt(i).y;
					i++;
				}
				MaxX=m_ControlPointsObenSpline.GetAt(m_ControlPointsObenSpline.GetSize()-1).x>m_ControlPointsUntenSpline.GetAt(m_ControlPointsUntenSpline.GetSize()-1).x?
		 				 m_ControlPointsObenSpline.GetAt(m_ControlPointsObenSpline.GetSize()-1).x:m_ControlPointsUntenSpline.GetAt(m_ControlPointsUntenSpline.GetSize()-1).x;
				MaxX-=m_Marker1.x;
				INT Differenz=0;
				if (MaxYOben<rect.bottom-MaxYUnten)
				{
					Differenz=MaxYOben;
				}
				else
				{
					Differenz=rect.bottom-MaxYUnten;
				}
				MaxY=rect.bottom-2*Differenz;
				double FaktorX;
				double FaktorY;
				FaktorX=rect.right/(double)MaxX;
				FaktorY=rect.bottom/(double)MaxY;

				POINT Skaliert,Letzter;
				Letzter.x=0;
				Letzter.y=0;
				for(i=0;i<m_ControlPointsObenSpline.GetSize();i++)
				{
					Skaliert.x=(LONG)((m_ControlPointsObenSpline.GetAt(i).x-m_Marker1.x)*FaktorX);
					Skaliert.y=(LONG)((m_ControlPointsObenSpline.GetAt(i).y-Differenz)*FaktorY);
					if (Skaliert.x>Letzter.x&&i>0) 
						TempKurveOben.Add(Skaliert);
					Letzter=Skaliert;
				}
				for(i=0;i<m_ControlPointsUntenSpline.GetSize();i++)
				{
					Skaliert.x=(LONG)((m_ControlPointsUntenSpline.GetAt(i).x-m_Marker1.x)*FaktorX);
					Skaliert.y=(LONG)((m_ControlPointsUntenSpline.GetAt(i).y-Differenz)*FaktorY);
					if (Skaliert.x>Letzter.x&&i>0) 
						TempKurveUnten.Add(Skaliert);
					Letzter=Skaliert;
				}

			if(m_HuellkurveObenArray.GetSize()>1)
			{
				for (i=0;i<TempKurveOben.GetSize();i++)
				{
					INT j=0;
					while(TempKurveOben.GetAt(i).x!=m_HuellkurveObenArray.GetAt(j).x&&j<m_HuellkurveObenArray.GetSize())
					{
						if (TempKurveOben.GetAt(i).x<m_HuellkurveObenArray.GetAt(j).x) break;
						j++;
						if (j==m_HuellkurveObenArray.GetSize())
						{
							j--;
							break;
						}
					}
					if (TempKurveOben.GetAt(i).x==m_HuellkurveObenArray.GetAt(j).x)
					{
						POINT Mittelwert;
						Mittelwert.x=m_HuellkurveObenArray.GetAt(j).x;
						Mittelwert.y=(TempKurveOben.GetAt(i).y+m_HuellkurveObenArray.GetAt(j).y)/2;
						m_HuellkurveObenArray.SetAt(j,Mittelwert);
					}
					else
						m_HuellkurveObenArray.InsertAt(j,TempKurveOben.GetAt(i));
				}

				for (i=0;i<TempKurveUnten.GetSize();i++)
				{
					INT j=0;
					while(TempKurveUnten.GetAt(i).x!=m_HuellkurveUntenArray.GetAt(j).x&&j<m_HuellkurveUntenArray.GetSize())
					{
						if (TempKurveUnten.GetAt(i).x<m_HuellkurveUntenArray.GetAt(j).x) break;
						j++;
						if (j==m_HuellkurveUntenArray.GetSize())
						{
							j--;
							break;
						}
					}
					if (TempKurveUnten.GetAt(i).x==m_HuellkurveUntenArray.GetAt(j).x)
					{
						POINT Mittelwert;
						Mittelwert.x=m_HuellkurveUntenArray.GetAt(j).x;
						Mittelwert.y=(TempKurveUnten.GetAt(i).y+m_HuellkurveUntenArray.GetAt(j).y)/2;
						m_HuellkurveUntenArray.SetAt(j,Mittelwert);
					}
					else
						m_HuellkurveUntenArray.InsertAt(j,TempKurveUnten.GetAt(i));
				}

			}
			else
			{
				m_HuellkurveObenArray.Copy(TempKurveOben);
				m_HuellkurveUntenArray.Copy(TempKurveUnten);
			}
			
			m_OptimiereArray.RemoveAll();
			m_OptimiereArray.Copy(m_HuellkurveObenArray);
			for (int j=0;j<m_HuellkurveUntenArray.GetSize();j++)
				m_OptimiereArray.Add(m_HuellkurveUntenArray.GetAt(m_HuellkurveUntenArray.GetSize()-j-1));

			HENHMETAFILE hMF=DrawPointsToMetaFile(&m_OptimiereArray,NULL,FALSE);
			//Zeichne in Dialogfeld
			m_HuellkurveDlg.m_MetaBild.SetEnhMetaFile(hMF);

			m_HuellkurveDlg.ShowWindow(SW_SHOW);
		}
	}
}

void CSoundsView::DrawCross(POINT point, COLORREF rgbColor, int extent,CDC* pDC)
{
//	CDC* pDC=GetDC();
	CPen Pen;
	Pen.CreatePen(PS_SOLID,1,rgbColor);
	pDC->SelectObject(&Pen);
	
	pDC->MoveTo(point.x - extent, point.y);
	pDC->LineTo(point.x + extent, point.y);
    
	pDC->MoveTo(point.x, point.y - extent);
  pDC->LineTo(point.x, point.y + extent);
}


void CSoundsView::OnRadioHuelle() 
{
	CButton* pRadioHuelle=(CButton*)m_pParentFrame->m_wndDlgBar.GetDlgItem(IDC_RADIO_HUELLE);
	CButton* pRadioSamples=(CButton*)m_pParentFrame->m_wndDlgBar.GetDlgItem(IDC_RADIO_SAMPLES);
	if (pRadioHuelle->GetCheck())
	{
		pRadioSamples->SetCheck(0);
		m_bIsSamples=FALSE;
	}
	else
	{
		pRadioSamples->SetCheck(1);
		m_bIsSamples=TRUE;
	}
	m_Recalc=TRUE;
	Invalidate(TRUE);
}

void CSoundsView::OnRadioSamples() 
{
	CButton* pRadioHuelle=(CButton*)m_pParentFrame->m_wndDlgBar.GetDlgItem(IDC_RADIO_HUELLE);
	CButton* pRadioSamples=(CButton*)m_pParentFrame->m_wndDlgBar.GetDlgItem(IDC_RADIO_SAMPLES);
	if (pRadioSamples->GetCheck())
	{
		pRadioHuelle->SetCheck(0);
		m_bIsSamples=TRUE;
	}
	else
	{
		pRadioHuelle->SetCheck(1);
		m_bIsSamples=FALSE;
	}
	m_Recalc=TRUE;
	Invalidate(TRUE);
}


short CSoundsView::GetSample(BYTE* pBuffer,int register Stelle,CRect rect,INT BitRate) 
{
	short sample=BitRate==8?((*((BYTE*)pBuffer+Stelle)-128)*((rect.bottom-RANDU-RANDO)*m_ZoomV/2))/128:\
											((*((short*)pBuffer+Stelle))*((rect.bottom-RANDU-RANDO)*m_ZoomV/2))/(65536/2);
	return sample;
}

void CSoundsView::BerechneEinhuellende() 
{
/*	CRect rect;
	GetClientRect(rect);
	CSoundsDoc* pDoc=GetDocument();
	m_ControlPointsOben.RemoveAll();
	m_ControlPointsUnten.RemoveAll();
	DOUBLE AusschnittsLaengeOverviewinSamples=m_EndeAusschnitt-m_StartAusschnitt;
	BYTE* pSoundBuffer=pDoc->GetSoundBuffer();
	DWORD* pSoundBufferLength=pDoc->GetSoundBufferSize();
	if (*pSoundBufferLength>1) 
	{
		if (*pDoc->GetBitRate()==16) 
		{
			m_EndeAusschnitt=m_EndeAusschnitt-(INT)(m_EndeAusschnitt)%2;
			m_StartAusschnitt=m_StartAusschnitt-(INT)(m_StartAusschnitt)%2;
		}
		INT* pBitRate=pDoc->GetBitRate();
		INT MaxiOben=0;
		INT MaxiUnten=0;
		int register x=(INT)m_StartAusschnitt;
		INT Nullkappe=(INT)(rect.bottom*0.02);//(INT)(pow(2,*pBitRate)*0.02);
		INT Standardcount=(INT)((m_EndeAusschnitt-m_StartAusschnitt)/rect.right*(41-m_PtsPerPixel));
		INT Peakszaehler=7;//44-m_PtsPerPixel;
		while(x<(INT)m_EndeAusschnitt)	
		{
			short sample;
			POINT CtrlPunkt;
			INT StartX=x;
			for(int i=0;i<Peakszaehler;i++)
			{
				while((sample=GetSample(pSoundBuffer,x,rect,*pBitRate))>=0)
				{
					if (sample>MaxiOben) MaxiOben=sample;
					x++;
					if (x-StartX>Standardcount) break;
					if (x==m_EndeAusschnitt)
					{
						i=Peakszaehler-2;
						break;
					}
				}
				while((sample=GetSample(pSoundBuffer,x,rect,*pBitRate))<=0)
				{
					if (sample<MaxiUnten) MaxiUnten=sample;
					if (x-StartX>Standardcount) break;
					x++;
					if (x==m_EndeAusschnitt)
					{
						i=Peakszaehler-2;
						break;
					}
				}	

				if (x-StartX>Standardcount)
				{
					i=Peakszaehler;
					if ((MaxiOben<=Nullkappe)&&(abs(MaxiUnten)<=Nullkappe))
						{
							MaxiOben=1;
							MaxiUnten=-1;
						}
				}
			}
			CtrlPunkt.x=(LONG)((x-(x-StartX)/2-m_StartAusschnitt)*rect.right/AusschnittsLaengeOverviewinSamples);
			CtrlPunkt.y=(LONG)(rect.bottom/2-MaxiOben+HEIGHT_RULER_VIEW/2);
			m_ControlPointsOben.Add(CtrlPunkt);
			CtrlPunkt.y=(LONG)(rect.bottom/2-MaxiUnten+HEIGHT_RULER_VIEW/2);
			m_ControlPointsUnten.Add(CtrlPunkt);
			MaxiOben=0;
			MaxiUnten=0;
		}
	}
*/
}


void CSoundsView::BerechneHuellkurve(INT Start, INT Ende) 
{
	CRect rect;
	GetClientRect(rect);
	CSoundsDoc* pDoc=GetDocument();
	m_ControlPointsObenSpline.RemoveAll();
	m_ControlPointsUntenSpline.RemoveAll();
	DOUBLE AusschnittsLaengeOverviewinSamples=m_EndeAusschnitt-m_StartAusschnitt;
	BYTE* pSoundBuffer=pDoc->GetSoundBuffer();
	DWORD* pSoundBufferLength=pDoc->GetSoundBufferSize();
	if (*pSoundBufferLength>1) 
	{
		if (*pDoc->GetBitRate()==16) 
		{
			Start=Start-Start%2;
			Ende=Ende-Ende%2;
		}
		INT* pBitRate=pDoc->GetBitRate();
		INT MaxiOben=0;
		INT MaxiUnten=0;
		int register x=Start;
		while(x<Ende)	
		{
			short sample;
			POINT CtrlPunkt;
			INT StartX=x;
			for(int i=0;i<7;i++)
			{
				while((sample=GetSample(pSoundBuffer,x,rect,*pBitRate))>0)
				{
					if (sample>MaxiOben) MaxiOben=sample;
					x++;
					if (x==Ende)
					{
						i=5;
						break;
					}
				}
				while(GetSample(pSoundBuffer,x,rect,*pBitRate)==0)
				{
					x++;
					if (x==m_EndeAusschnitt)
					{
						i=5;
						break;
					}
				}
				while((sample=GetSample(pSoundBuffer,x,rect,*pBitRate))<0)
				{
					if (sample<MaxiUnten) MaxiUnten=sample;
					x++;
					if (x==m_EndeAusschnitt)
					{
						i=5;
						break;
					}
				}	
				while(GetSample(pSoundBuffer,x,rect,*pBitRate)==0)
				{
					x++;
					if (x==m_EndeAusschnitt)
					{
						i=5;
						break;
					}
				}
			}
			CtrlPunkt.x=(LONG)((x-(x-StartX)/2-m_StartAusschnitt)*rect.right/AusschnittsLaengeOverviewinSamples);
			CtrlPunkt.y=(LONG)((rect.bottom-RANDO-RANDU)/2-MaxiOben+RANDO);
			m_ControlPointsObenSpline.Add(CtrlPunkt);
			CtrlPunkt.y=(LONG)((rect.bottom-RANDO-RANDU)/2-MaxiUnten+RANDO);
			m_ControlPointsUntenSpline.Add(CtrlPunkt);
			MaxiOben=0;
			MaxiUnten=0;
		}
	}
}


void CSoundsView::OptimiereHuellkurve()
{
	CRect rect;
	GetClientRect(rect); 
	for(int i=0; i<m_OptimiereArray.GetSize();i++)
	{
		INT Links=0;
		INT Rechts=0;
		INT Oben=0;
		INT Unten=0;
		POINT AktuellerPunkt=m_OptimiereArray.GetAt(i);
		INT Radius=40;
		ZaehleNachbarn(&m_OptimiereArray,AktuellerPunkt,&Links,&Rechts,&Oben,&Unten,Radius);
		if (Links!=Rechts) 
		{
			if (Links>Rechts+4&&Links>4) 
				AktuellerPunkt.x>1?AktuellerPunkt.x-=1:1;
			if (Rechts>Links+4&&Rechts>4) 
				AktuellerPunkt.x<rect.right?AktuellerPunkt.x+=1:rect.right;
		}
		if (Oben!=Unten) 
		{
			if (Oben>Unten+4&&Oben>4) 
				AktuellerPunkt.y>1?AktuellerPunkt.y-=1:1;
			if (Unten>Oben+4&&Unten>4)
				AktuellerPunkt.y<rect.bottom?AktuellerPunkt.y+=1:rect.bottom;
		}
		m_OptimiereArray.SetAt(i,AktuellerPunkt);
	}
	//entfernte Punkte lschen
	for(i=0; i<m_OptimiereArray.GetSize();i++)
	{
		if (m_OptimiereArray.GetAt(i).x==2000) 
		{
			m_OptimiereArray.RemoveAt(i);
			i--;
		}
	}
	HENHMETAFILE hMF=DrawPointsToMetaFile(&m_OptimiereArray,NULL,FALSE);
	m_HuellkurveDlg.m_MetaBild.SetEnhMetaFile(hMF);

	m_HuellkurveDlg.ShowWindow(SW_SHOW);
}

void CSoundsView::ZaehleNachbarn(CArray<POINT,POINT>* Punkte,POINT AktuellerPunkt,INT* Links,INT* Rechts,
										INT* Oben,INT* Unten,INT Radius)
{
	INT L=0;
	INT R=0;
	INT	O=0;
	INT U=0;
	for(int i=0; i<Punkte->GetSize();i++)
	{
		INT dx=Punkte->GetAt(i).x-AktuellerPunkt.x;
		INT dy=Punkte->GetAt(i).y-AktuellerPunkt.y;
		double Abstand=sqrt(pow(dx,2)+pow(dy,2));
		if (Abstand<2&&Abstand!=0) 
		{
			POINT Abwegig;
			Abwegig.x=2000;
			Abwegig.y=2000;
			Punkte->SetAt(i,Abwegig);
		}
		else
		{
		///
		if (abs(dx)<Radius&&abs(dy)<Radius)
		{
			if (dx<0)
			{
				if (abs(dy)<=abs(dx)) 
				{
					L++;
				}
			}	
			else
			{
				if (abs(dy)<=abs(dx)) 
				{
					R++;
				}
			}	
			if (dy>0) 
			{
				if (abs(dx)<=abs(dy)) 
				{
					U++;
				}
			}	
			else
			{
				if (abs(dx)<=abs(dy)) 
				{
					O++;
				}
			}
		}
		///
		}
	}
	*Links=L;
	*Rechts=R;
	*Oben=O;
	*Unten=U;
}



void CSoundsView::DrawHuellSpline()
{
	HENHMETAFILE hMF=DrawPointsToMetaFile(&m_OptimiereArray,NULL,TRUE);
	//Zeichne in Dialogfeld
	m_HuellkurveDlg.m_MetaBild.SetEnhMetaFile(hMF);
	m_HuellkurveDlg.ShowWindow(SW_SHOW);
	m_CtrlOptimierePoints.RemoveAll();
}

int CSoundsView::IsInsideControlPoint(POINT& point)
{
	int count = ControlArray.GetSize();

	if(count>0)	
	{
		for(int i=0; i<count; i++)
		{
			if(Distance(ControlArray[i], point)<=10)
				return i;
		}
	}

	return -1;

}

double CSoundsView::Distance(const POINT& p1, const POINT& p2)
{
	int dx = abs(p1.x - p2.x);
	int dy = abs(p1.y - p2.y);

	return sqrt(dx*dx + dy*dy);
}

void CSoundsView::LButtonDown(UINT nFlags,POINT point)
{
	CRect rect;
	GetClientRect(rect);


	
	POINT Punktskaliert;
	Punktskaliert.x=point.x*rect.right/490-14;
	Punktskaliert.y=point.y*rect.bottom/390-9;

	int index = IsInsideControlPoint(Punktskaliert);
	
	if(index == -1)
		m_CtrlOptimierePoints.Add(Punktskaliert); //bedeutet: ADD diesen Punkt weil Punkt.y!=0

	HENHMETAFILE hMF=DrawPointsToMetaFile(&m_OptimiereArray,NULL,TRUE);
	//Zeichne in Dialogfeld
	m_HuellkurveDlg.m_MetaBild.SetEnhMetaFile(hMF);
	m_HuellkurveDlg.ShowWindow(SW_SHOW);
}

void CSoundsView::RButtonDown(UINT nFlags,POINT point)
{
	CRect rect;
	GetClientRect(rect);

	POINT Punktskaliert;
	Punktskaliert.x=point.x*rect.right/490-14;
	Punktskaliert.y=point.y*rect.bottom/390-9;

	int index = IsInsideControlPoint(Punktskaliert);
	
	if(index >= 0)
	{
		POINT Punkt;
		Punkt.x=index;								//bedeutet: welcher Punkt
		Punkt.y=0;										//bedeutet: REMOVE
		m_CtrlOptimierePoints.Add(Punkt);
	}
	HENHMETAFILE hMF=DrawPointsToMetaFile(&m_OptimiereArray,NULL,TRUE);
	//Zeichne in Dialogfeld
	m_HuellkurveDlg.m_MetaBild.SetEnhMetaFile(hMF);
	m_HuellkurveDlg.ShowWindow(SW_SHOW);
}

void CSoundsView::Save()
{
	HENHMETAFILE hMF;

	// Load the filename Dialog
	CFileDialog FileDlg(FALSE,NULL,NULL,OFN_OVERWRITEPROMPT|OFN_NOREADONLYRETURN|OFN_ENABLESIZING,\
              "WMF - Enhanced Metafile|*.wmf|");
  FileDlg.m_ofn.nFilterIndex=1;
	FileDlg.m_ofn.lpstrDefExt=".wmf";
	CString Text;
	Text.LoadString(IDS_SAVE_HUELLKURVE);
	FileDlg.m_ofn.lpstrTitle=Text.GetBuffer(Text.GetLength());
  if (FileDlg.DoModal()==IDOK) 
	{
		// Create the metafile device context. 
		CString Pfad=FileDlg.GetPathName();
		LPTSTR strFileName=Pfad.GetBuffer(MAX_PATH);
		if (ControlArray.GetSize()>0)
			hMF=DrawPointsToMetaFile(&m_OptimiereArray,strFileName,TRUE);
		else 
			hMF=DrawPointsToMetaFile(&m_OptimiereArray,strFileName,FALSE);
		DeleteEnhMetaFile(hMF);
	}
}

void CSoundsView::ToClipboard()
{
	HENHMETAFILE hMF;
	if (ControlArray.GetSize()>0)
		hMF=DrawPointsToMetaFile(&m_OptimiereArray,NULL,TRUE);
	else 
		hMF=DrawPointsToMetaFile(&m_OptimiereArray,NULL,FALSE);

	//copy to clipboard
	// Open the clipboard...
	if(!OpenClipboard()) 
	{
    AfxMessageBox(IDS_OPEN_CLIPBOARD_FAIL);
    return;
	}
	EmptyClipboard();
	::SetClipboardData(CF_ENHMETAFILE,hMF);
	CloseClipboard();
	DeleteEnhMetaFile(hMF);
}

void CSoundsView::OnEditCopy() 
{
	// Obtain a handle to a reference device context. 
	CDC* RefDC = GetDC(); 
 
	CRect rect=DetermineRect(RefDC);

	CMetaFileDC MetaFileDC;
	MetaFileDC.CreateEnhanced(RefDC,NULL,rect,"SOUNDS Soundanalyse\0Wave Abbild\0\0");
	OnDraw(&MetaFileDC);
	HENHMETAFILE pMetaFile=MetaFileDC.CloseEnhanced();
	
	//copy to clipboard
	// Open the clipboard...
	if(!OpenClipboard()) 
	{
    AfxMessageBox(IDS_OPEN_CLIPBOARD_FAIL);
    return;
	}
	EmptyClipboard();
	::SetClipboardData(CF_ENHMETAFILE,pMetaFile);
	CloseClipboard();

	DeleteEnhMetaFile(pMetaFile);
}

CRect CSoundsView::DetermineRect(CDC* RefDC)
{
	// Determine the picture frame dimensions. 
	// iWidthMM is the display width in millimeters. 
	// iHeightMM is the display height in millimeters. 
	// iWidthPels is the display width in pixels. 
	// iHeightPels is the display height in pixels 
 
	INT iWidthMM = GetDeviceCaps(RefDC->GetSafeHdc(), HORZSIZE); 
	INT iHeightMM = GetDeviceCaps(RefDC->GetSafeHdc(), VERTSIZE); 
	INT iWidthPels = GetDeviceCaps(RefDC->GetSafeHdc(), HORZRES); 
	INT iHeightPels = GetDeviceCaps(RefDC->GetSafeHdc(), VERTRES); 
 
	// Retrieve the coordinates of the client rectangle, in pixels. 
	CRect rect;
	GetClientRect(rect); 
 
	// Convert client coordinates to .01-mm units. 
	// Use iWidthMM, iWidthPels, iHeightMM, and 
	// iHeightPels to determine the number of 
	// .01-millimeter units per pixel in the x- 
	//  and y-directions. 
 
	rect.left = (rect.left * iWidthMM * 100)/iWidthPels; 
	rect.top = (rect.top * iHeightMM * 100)/iHeightPels; 
	rect.right = (rect.right * iWidthMM * 100)/iWidthPels; 
	rect.bottom = (rect.bottom * iHeightMM * 100)/iHeightPels; 

	return rect;
}

void CSoundsView::OnSave() 
{
	// Obtain a handle to a reference device context. 
	CDC* RefDC = GetDC(); 
 
	CRect rect=DetermineRect(RefDC);
	// Load the filename Dialog
	CFileDialog ViewFileDlg(FALSE,NULL,NULL,OFN_OVERWRITEPROMPT|OFN_NOREADONLYRETURN|OFN_ENABLESIZING,\
              "WMF - Enhanced Metafile|*.wmf|");
  ViewFileDlg.m_ofn.nFilterIndex=1;
	ViewFileDlg.m_ofn.lpstrDefExt=".wmf";
	ViewFileDlg.m_ofn.lpstrTitle="Speichert diese Waveansicht...";
  if (ViewFileDlg.DoModal()==IDOK) 
	{
		// Create the metafile device context. 
		CString Pfad=ViewFileDlg.GetPathName();
		LPTSTR strFileName=Pfad.GetBuffer(MAX_PATH);
		CMetaFileDC MetaFileDC;
		MetaFileDC.CreateEnhanced(RefDC,strFileName,rect,"SOUNDS Soundanalyse\0Wave Abbild\0\0");
		OnDraw(&MetaFileDC);
		HENHMETAFILE pMetaFile=MetaFileDC.CloseEnhanced();
		DeleteEnhMetaFile(pMetaFile);
	}
	// Release the reference device context. 
	ReleaseDC(RefDC); 
}

BOOL CSoundsView::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	CSoundsDoc* pDoc=GetDocument();
	pDoc->m_help.SetHelpFile(pDoc->m_strHelpFile);
	pDoc->m_help.DisplayTopic("html/Hauptfenster.html");
	
	return CScrollView::OnHelpInfo(pHelpInfo);
}


BOOL CSoundsView::OnEraseBkgnd(CDC* pDC) 
{
	return FALSE;
//	return CScrollView::OnEraseBkgnd(pDC);
}
	
