// SoundsView.h : Schnittstelle der Klasse CSoundsView
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_SOUNDSVIEW_H__2A7A04D2_7BD6_4E21_B0C4_5352D6FC8F99__INCLUDED_)
#define AFX_SOUNDSVIEW_H__2A7A04D2_7BD6_4E21_B0C4_5352D6FC8F99__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "HuellkurveDlg.h"

class CSoundsView : public CScrollView
{
protected: // Nur aus Serialisierung erzeugen
	CSoundsView();
	DECLARE_DYNCREATE(CSoundsView)

// Attribute
public:
	CSoundsDoc* GetDocument();
// Operationen
public:
	POINT								m_AusschnittStart;
	POINT								m_AusschnittEnde;
	POINT								m_FirstMousePoint;
	POINT								m_LastMousePoint;
	POINT								m_MoveMousePoint;
	INT									m_ZoomH_Overview;
	INT									m_ZoomV;
	BOOL								m_Recalc;
	INT									m_PtsPerPixel;

protected:
	POINT								m_OldAusschnittStart;
	POINT								m_OldAusschnittEnde;
	POINT								m_AusschnittAnalyse;
	CPen								Rahmenstift;
	CPen								Kurvenstift;
	CPen								Markerstift;
	DOUBLE							m_StartAusschnitt;
	DOUBLE							m_EndeAusschnitt;
	CSplitterFrame*			m_pParentFrame;

	POINT								m_Marker1;
	POINT								m_Marker2;

	BOOL								m_bIsSamples;
	BOOL								m_bIsEinhuellende;

	
protected:
	CArray<POINT,POINT> m_WAVKomplettPtArray;
	CArray<POINT,POINT>	m_ControlPointsOben;
	CArray<POINT,POINT>	m_ControlPointsUnten;
	CArray<POINT,POINT>	m_CurvePointsOben;
	CArray<POINT,POINT>	m_CurvePointsUnten;
	CArray<POINT,POINT>	m_ControlPointsObenSpline;
	CArray<POINT,POINT>	m_ControlPointsUntenSpline;
	CArray<POINT,POINT>	m_CurvePointsObenSpline;
	CArray<POINT,POINT>	m_CurvePointsUntenSpline;
	CArray<POINT,POINT>	m_ControlPointsObenSumme;
	CArray<POINT,POINT>	m_ControlPointsUntenSumme;
	CArray<POINT,POINT>	m_CurvePointsObenSumme;
	CArray<POINT,POINT>	m_CurvePointsUntenSumme;
	CHuellkurveDlg			m_HuellkurveDlg;
	CArray<POINT,POINT> m_HuellkurveObenArray;
	CArray<POINT,POINT> m_HuellkurveUntenArray;
	CArray<POINT,POINT>	m_OptimiereArray;
	CArray<POINT,POINT>	m_CtrlOptimierePoints;
	CArray<POINT,POINT> ControlArray;

protected:
	int IsAtMarkerLine(POINT* ppoint);
	double Distance(POINT* p1, POINT* p2);
	void BerechneEinhuellende();
	void BerechneHuellkurve(INT Start, INT Ende); 
	void DrawCross(POINT point, COLORREF rgbColor, int extent,CDC* pDC);
	short GetSample(BYTE* pBuffer,int register Stelle,CRect rect,INT BitRate) ;
	void ZaehleNachbarn(CArray<POINT,POINT>* Punkte,POINT AktuellerPunkt,INT* Links,INT* Rechts,
										INT* Oben,INT* Unten,INT Radius);
	HENHMETAFILE DrawPointsToMetaFile(CArray<POINT,POINT>* pPunkte,LPCTSTR FileName,BOOL IsDrawSpline);
	int IsInsideControlPoint(POINT& point);
	double Distance(const POINT& p1, const POINT& p2);
	void RaenderKorrigieren(CPoint* point,CRect ClientRect );
	CRect DetermineRect(CDC* RefDC);
// berladungen
	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CSoundsView)
	public:
	virtual void OnDraw(CDC* pDC);  // berladen zum Zeichnen dieser Ansicht
	protected:
	virtual void OnInitialUpdate(); // das erste mal nach der Konstruktion aufgerufen
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementierung
public:
	virtual ~CSoundsView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

public:
	void OnRadioHuelle();
	void OnRadioSamples();
	inline DeleteHuellkurven() { m_HuellkurveUntenArray.RemoveAll();m_HuellkurveObenArray.RemoveAll();}
	void OptimiereHuellkurve();
	void DrawHuellSpline();
	void LButtonDown(UINT nFlags,POINT point);
	void RButtonDown(UINT nFlags,POINT point);
	void Save();
	void ToClipboard();

// Generierte Message-Map-Funktionen
protected:
	//{{AFX_MSG(CSoundsView)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnHuellkurve();
	afx_msg void OnEditCopy();
	afx_msg void OnSave();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // Testversion in SoundsView.cpp
inline CSoundsDoc* CSoundsView::GetDocument()
   { return (CSoundsDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_SOUNDSVIEW_H__2A7A04D2_7BD6_4E21_B0C4_5352D6FC8F99__INCLUDED_)
