// WaveformatDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Sounds.h"
#include "WaveformatDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CWaveformatDlg 


CWaveformatDlg::CWaveformatDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWaveformatDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWaveformatDlg)
	m_WaveFormat_Eingang = _T("");
	//}}AFX_DATA_INIT
}


void CWaveformatDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWaveformatDlg)
	DDX_Control(pDX, IDC_WAVEFORMAT_EINGANG, m_WaveFormat_Eingang_Control);
	DDX_LBString(pDX, IDC_WAVEFORMAT_EINGANG, m_WaveFormat_Eingang);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CWaveformatDlg, CDialog)
	//{{AFX_MSG_MAP(CWaveformatDlg)
	ON_LBN_SELCHANGE(IDC_WAVEFORMAT, OnSelchangeWaveformat)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CWaveformatDlg 

BOOL CWaveformatDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	if( FAILED( ScanAvailableInputFormats() ) )
        AfxMessageBox(E_WAVEFORMATDLG_SCANAVAILABLEINPUTFORMATS);
		FillFormatListBox( m_InputFormatSupported );
	
	return TRUE;  // return TRUE unless you set the focus to a control
}


//-----------------------------------------------------------------------------
// Name: ScanAvailableInputFormats()
// Desc: Tests to see if 16 different standard wave formats are supported by
//       the capture device 
//-----------------------------------------------------------------------------
HRESULT CWaveformatDlg::ScanAvailableInputFormats()
{
    HRESULT       hr;
    WAVEFORMATEX  wfx;
    DSCBUFFERDESC dscbd;
    LPDIRECTSOUNDCAPTUREBUFFER pDSCaptureBuffer = NULL;

    // This might take a second or two, so throw up the hourglass
		BeginWaitCursor();
    
    ZeroMemory( &wfx, sizeof(wfx));
    wfx.wFormatTag = WAVE_FORMAT_PCM;

    ZeroMemory( &dscbd, sizeof(dscbd) );
    dscbd.dwSize = sizeof(dscbd);
		
    // Try 20 different formats to see if they are supported
    for( INT iIndex = 0; iIndex < 20; iIndex++ )
    {
        theApp.mp_doc->GetWaveFormatFromIndex( iIndex, &wfx );

        // To test if a capture format is supported, try to create a 
        // new capture buffer using a specific format.  If it works
        // then the format is supported, otherwise not.

        dscbd.dwBufferBytes = wfx.nAvgBytesPerSec;
        dscbd.lpwfxFormat = &wfx;
        
        if( FAILED( hr = (theApp.m_pDSCapture->CreateCaptureBuffer( &dscbd, &pDSCaptureBuffer, NULL ) ) ) )
            m_InputFormatSupported[ iIndex ] = FALSE;
        else
            m_InputFormatSupported[ iIndex ] = TRUE;
				if (hr==DSERR_GENERIC)
					int Stop=0;


				SAFE_RELEASE( pDSCaptureBuffer );
    }

		EndWaitCursor();

    return S_OK;
}

//-----------------------------------------------------------------------------
// Name: FillFormatListBox()
// Desc: Fills the format list box based on the availible formats
//-----------------------------------------------------------------------------
HRESULT CWaveformatDlg::FillFormatListBox( BOOL* aFormatSupported )
{
    TCHAR        strFormatName[255];
    WAVEFORMATEX wfx;

		m_WaveFormat_Eingang_Control.ResetContent();
		INT j=0;
    for( INT iIndex = 0; iIndex < 20; iIndex++ )
    {
    		if( aFormatSupported[ iIndex ] )
        {
            // Turn the index into a WAVEFORMATEX then turn that into a
            // string and put the string in the listbox
            theApp.mp_doc->GetWaveFormatFromIndex( iIndex, &wfx );
            ConvertWaveFormatToString( &wfx, strFormatName );
						m_WaveFormat_Eingang_Control.AddString((LPCTSTR) strFormatName );
						m_WaveFormat_Eingang_Control.SetItemData(j,iIndex);
						j++;
				}
    }
    return S_OK;
}

//-----------------------------------------------------------------------------
// Name: ConvertWaveFormatToString()
// Desc: Converts a wave format to a text string
//-----------------------------------------------------------------------------
VOID CWaveformatDlg::ConvertWaveFormatToString( WAVEFORMATEX* pwfx, TCHAR* strFormatName )
{
    wsprintf( strFormatName, 
              TEXT("%u Hz, %u-bit %s"), 
              pwfx->nSamplesPerSec, 
              pwfx->wBitsPerSample, 
              ( pwfx->nChannels == 1 ) ? TEXT("Mono") : TEXT("Stereo") );
}

//-----------------------------------------------------------------------------
// Name: OnInputFormatBoxSelected()
// Desc: Enables the OK button when there is a selection
//-----------------------------------------------------------------------------

void CWaveformatDlg::OnSelchangeWaveformat() 
{
    CWnd* pOK         = GetDlgItem( IDOK );
    if (m_WaveFormat_Eingang_Control.GetCurSel()!=LB_ERR)
			pOK->EnableWindow(TRUE);	
    else
			pOK->EnableWindow(FALSE);	
}



void CWaveformatDlg::OnOK() 
{
  UpdateData(TRUE);
	InputWavIndex=m_WaveFormat_Eingang_Control.GetItemData(m_WaveFormat_Eingang_Control.GetCurSel());

	CDialog::OnOK();
}
