// ZeitreiheView1.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Sounds.h"
#include "ZeitreiheView1.h"
#include "LyapunovKantz.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CZeitreiheView

IMPLEMENT_DYNCREATE(CZeitreiheView, CScrollView)

CZeitreiheView::CZeitreiheView()
{
	INT Items=AfxGetMainWnd()->GetMenu()->GetMenuItemCount();
	AfxGetMainWnd()->GetMenu()->GetSubMenu(Items>5?5:3)->AppendMenu(MF_STRING|MF_ENABLED,ID_FENSTER_ZEITREIHE,"Zeitreihe");
	AfxGetMainWnd()->DrawMenuBar();
}

void CZeitreiheView::IniFileRead()
{
	//INIFile Werte einlesen
	m_KorrCount=*theApp.GetIniZeitreiheKorrCount();
	m_partitions=*theApp.GetIniZeitreihePartitions();
 	m_corrlength=*theApp.GetIniZeitreiheCorrlength();
	m_WhatIs=*theApp.GetIniZeitreiheWhatIs();
}

void	CZeitreiheView::IniFileWrite()
{
	//INIFile Werte schreiben
	*theApp.GetIniZeitreiheKorrCount()=m_KorrCount;
	*theApp.GetIniZeitreihePartitions()=m_partitions;
 	*theApp.GetIniZeitreiheCorrlength()=m_corrlength;
	*theApp.GetIniZeitreiheWhatIs()=m_WhatIs;
}

CZeitreiheView::~CZeitreiheView()
{
	IniFileWrite();
	m_ViewPtArray.RemoveAll();
	m_ViewPtMutualArray.RemoveAll();
	INT Items=AfxGetMainWnd()->GetMenu()->GetMenuItemCount();
	AfxGetMainWnd()->GetMenu()->GetSubMenu(Items>5?5:3)->RemoveMenu(ID_FENSTER_ZEITREIHE,MF_BYCOMMAND);
	AfxGetMainWnd()->DrawMenuBar();
	CSoundsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->m_pViewZeitreihe=NULL;
}


BEGIN_MESSAGE_MAP(CZeitreiheView, CScrollView)
	//{{AFX_MSG_MAP(CZeitreiheView)
	ON_COMMAND(ID_EDIT_CLEARALL, OnEditClearall)
	ON_WM_ERASEBKGND()
	ON_BN_CLICKED(IDC_CHECK_AUTOKORR, OnCheckAutokorr)
	ON_BN_CLICKED(IDC_CHECK_ZEITREIHE, OnCheckZeitreihe)
	ON_EN_CHANGE(IDC_PARTITION_FELD, OnChangePartitionFeld)
	ON_EN_CHANGE(IDC_MAXTAU_FELD, OnChangeMaxtauFeld)
	ON_BN_CLICKED(IDC_CHECK_MUTUAL, OnCheckMutual)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_SAVE, OnSave)
	ON_WM_HELPINFO()
	ON_COMMAND(ID_EXPORTDATA, OnExportdata)
	ON_EN_CHANGE(IDC_EDIT_KORR, OnChangeEditKorr)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SLIDER_ZOOMH, OnReleasedcaptureSliderZoomh)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Zeichnung CZeitreiheView 

void CZeitreiheView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();
	m_XPixel=1;
	m_clrKurve= RGB(0,255,0);
	m_clrBkg=RGB(0, 0, 0);
	m_clrText=RGB(255,255,255);
	m_clrKoords=RGB(255,255,255);

	IniFileRead();

	CPoint Nullpunkt;
	Nullpunkt.x=0;
	Nullpunkt.y=0;
	m_ViewPtArray.Add(Nullpunkt);
	m_ViewPtAutoKorrArray.Add(Nullpunkt);
	m_ViewPtMutualArray.Add(Nullpunkt);
	CSize sizeTotal;
	CRect rect;
	GetClientRect(rect);
	sizeTotal.cx=(rect.right-rect.left);
	sizeTotal.cy=(rect.bottom-rect.top);
	SetScrollSizes(MM_TEXT,sizeTotal);


	m_pParentZeitreiheFrame=(CZeitreiheFrame*)GetParentFrame();

	CSliderCtrl* SliderHOverviewCtrl=(CSliderCtrl*)m_pParentZeitreiheFrame->m_wndDlgBar.GetDlgItem(IDC_SLIDER_ZOOMH);
	SliderHOverviewCtrl->SetTicFreq( 1 );    // Send TBM_SETTICFREQ
	SliderHOverviewCtrl->SetLineSize( 1 );       // Send TBM_SETLINESIZE
	SliderHOverviewCtrl->SetPageSize( 1 );       // Send TBM_SETPAGESIZE
	SliderHOverviewCtrl->SetRange( -1000, 1000, TRUE );
	SliderHOverviewCtrl->SetPos((INT)m_XPixel);

	CSpinButtonCtrl* pSpinCtrl=(CSpinButtonCtrl*)m_pParentZeitreiheFrame->m_wndDlgBar.GetDlgItem(IDC_PARTITION_SPIN);
	pSpinCtrl->SetBuddy(m_pParentZeitreiheFrame->m_wndDlgBar.GetDlgItem(IDC_PARTITION_FELD));
	pSpinCtrl->SetRange(2,100);
	pSpinCtrl->SetPos((INT)m_partitions);

	pSpinCtrl=(CSpinButtonCtrl*)m_pParentZeitreiheFrame->m_wndDlgBar.GetDlgItem(IDC_MAXTAU_SPIN);
	pSpinCtrl->SetBuddy(m_pParentZeitreiheFrame->m_wndDlgBar.GetDlgItem(IDC_MAXTAU_FELD));
	pSpinCtrl->SetRange(1,100);
	pSpinCtrl->SetPos((INT)m_corrlength);

	pSpinCtrl=(CSpinButtonCtrl*)m_pParentZeitreiheFrame->m_wndDlgBar.GetDlgItem(IDC_SPIN_KORR);
 	pSpinCtrl->SetRange(1,9);
	pSpinCtrl->SetBuddy(m_pParentZeitreiheFrame->m_wndDlgBar.GetDlgItem(IDC_EDIT_KORR));
	pSpinCtrl->SetPos(m_KorrCount);

	SwitchDlgWindows();

	m_Choose=IDNO;
}


//Dialog Bar Tool - Switches the right elements on/of depending on modul
void CZeitreiheView::SwitchDlgWindows()
{
	CButton* pButton1=(CButton*)m_pParentZeitreiheFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_ZEITREIHE);
	CButton* pButton2=(CButton*)m_pParentZeitreiheFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_AUTOKORR);
	CButton* pButton3=(CButton*)m_pParentZeitreiheFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_MUTUAL);

	CEdit* pEdit1a=(CEdit*)m_pParentZeitreiheFrame->m_wndDlgBar.GetDlgItem(IDC_PARTITION_STATIC);
	CEdit* pEdit2a=(CEdit*)m_pParentZeitreiheFrame->m_wndDlgBar.GetDlgItem(IDC_MAXTAU_STATIC);
	CEdit* pEdit3a=(CEdit*)m_pParentZeitreiheFrame->m_wndDlgBar.GetDlgItem(IDC_STATIC_KORR);

	CEdit* pEdit1b=(CEdit*)m_pParentZeitreiheFrame->m_wndDlgBar.GetDlgItem(IDC_PARTITION_FELD);
	CEdit* pEdit2b=(CEdit*)m_pParentZeitreiheFrame->m_wndDlgBar.GetDlgItem(IDC_MAXTAU_FELD);
	CEdit* pEdit3b=(CEdit*)m_pParentZeitreiheFrame->m_wndDlgBar.GetDlgItem(IDC_EDIT_KORR);

	CSpinButtonCtrl* pSpinCtrl1=(CSpinButtonCtrl*)m_pParentZeitreiheFrame->m_wndDlgBar.GetDlgItem(IDC_PARTITION_SPIN);
	CSpinButtonCtrl* pSpinCtrl2=(CSpinButtonCtrl*)m_pParentZeitreiheFrame->m_wndDlgBar.GetDlgItem(IDC_MAXTAU_SPIN);
	CSpinButtonCtrl* pSpinCtrl3=(CSpinButtonCtrl*)m_pParentZeitreiheFrame->m_wndDlgBar.GetDlgItem(IDC_SPIN_KORR);

	switch(m_WhatIs) {
	case 0:
		pEdit1a->ShowWindow(SW_HIDE);
		pEdit2a->ShowWindow(SW_HIDE);
		pEdit3a->ShowWindow(SW_HIDE);
		pEdit1b->ShowWindow(SW_HIDE);
		pEdit2b->ShowWindow(SW_HIDE);
		pEdit3b->ShowWindow(SW_HIDE);
		pSpinCtrl1->ShowWindow(SW_HIDE);
		pSpinCtrl2->ShowWindow(SW_HIDE);
		pSpinCtrl3->ShowWindow(SW_HIDE);
		pButton1->SetCheck(1);
		pButton2->SetCheck(0);
		pButton3->SetCheck(0);
		break;
	case 1:
		pEdit1a->ShowWindow(SW_HIDE);
		pEdit2a->ShowWindow(SW_HIDE);
		pEdit3a->ShowWindow(SW_SHOW);
		pEdit1b->ShowWindow(SW_HIDE);
		pEdit2b->ShowWindow(SW_HIDE);
		pEdit3b->ShowWindow(SW_SHOW);
		pSpinCtrl1->ShowWindow(SW_HIDE);
		pSpinCtrl2->ShowWindow(SW_HIDE);
		pSpinCtrl3->ShowWindow(SW_SHOW);
		pButton1->SetCheck(0);
		pButton2->SetCheck(1);
		pButton3->SetCheck(0);
		break;
	case 2:
		pEdit1a->ShowWindow(SW_SHOW);
		pEdit2a->ShowWindow(SW_SHOW);
		pEdit3a->ShowWindow(SW_HIDE);
		pEdit1b->ShowWindow(SW_SHOW);
		pEdit2b->ShowWindow(SW_SHOW);
		pEdit3b->ShowWindow(SW_HIDE);
		pSpinCtrl1->ShowWindow(SW_SHOW);
		pSpinCtrl2->ShowWindow(SW_SHOW);
		pSpinCtrl3->ShowWindow(SW_HIDE);
		pButton1->SetCheck(0);
		pButton2->SetCheck(0);
		pButton3->SetCheck(1);
		break;
	}  

}

/////////////////////////////////////////////////////////////////////////////
// Diagnose CZeitreiheView

#ifdef _DEBUG
void CZeitreiheView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CZeitreiheView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CZeitreiheView 

void CZeitreiheView::OnDraw(CDC* dc) 
{
	CMemDC pDC(dc);

	switch(m_WhatIs) 
	{
	case 0:
		ZeichneZeitreihe(pDC);
		break;
	case 1:
		ZeichneAutokorrelationsfunktion(pDC);
		break;
	case 2:
		ZeichneMutualInformation(pDC,FALSE,NULL);
		break;
	}
}  // On Draw


void CZeitreiheView::ControlPixel(INT Length) 
{
	if (Length>20000/m_XPixel&&m_Choose==IDNO) 
	{
		char buffer[20];
		CString strDaten=itoa( Length, buffer, 10 );
		CString strPixel=gcvt( m_XPixel, 5, buffer);
		CString Text;
		AfxFormatString2(Text,IDS_STRINGREDUCE,strDaten,strPixel);
		if (g_bIsPutPoints) m_Choose=AfxMessageBox(Text,MB_YESNO);
		else m_Choose=IDYES;
		if (m_Choose==IDYES) 
		{
			m_XPixel=5000/(float)(Length);
			CSliderCtrl* SliderHOverviewCtrl=(CSliderCtrl*)m_pParentZeitreiheFrame->m_wndDlgBar.GetDlgItem(IDC_SLIDER_ZOOMH);
			INT Pixel=0;
			if (m_XPixel>1) 
				Pixel=(INT)m_XPixel;
			else
				Pixel=-(INT)(1/m_XPixel);
			SliderHOverviewCtrl->SetPos((INT)Pixel);
		}
	}
}

void CZeitreiheView::ZeichneZeitreihe(CDC* pDC) 
{
	CSoundsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	INT* pBitRate=pDoc->GetBitRate();
	BOOL* pSigned=pDoc->GetSigned();
	CArray<DOUBLE,DOUBLE>* pZeitreiheArray=pDoc->GetZeitreiheArray();
	INT MaxZeit1=pZeitreiheArray->GetSize();
	ControlPixel(MaxZeit1);
	DOUBLE MaxZeit=MaxZeit1-1;

	if (pZeitreiheArray->GetSize()==1) 
	{
		m_ViewPtArray.RemoveAll();
		POINT Nullpunkt;
		Nullpunkt.x=0;
		Nullpunkt.y=0;
		m_ViewPtArray.Add(Nullpunkt);
	}
	DOUBLE* pMaxAmplitude=pDoc->GetMaxAmplitude();
	INT Teiler=0;
	if (*pSigned)
		Teiler=2;
	else
		Teiler=1;

	CRect rect;
	GetClientRect(rect);
	CPen KurvenStift;
  KurvenStift.CreatePen(PS_SOLID,1,m_clrKurve);
	CPen KoordinatensystemStift;
  KoordinatensystemStift.CreatePen(PS_SOLID,1,m_clrKoords);

	pDC->SetTextColor(m_clrText);
	pDC->FillSolidRect(rect,m_clrBkg);

	//View Array neu skalieren
	DOUBLE FaktorX=0,FaktorY=0;
	{
	  if (pZeitreiheArray->GetSize()>1)
		{
			m_ViewPtArray.RemoveAll();
			POINT Messpunkt;
			
			//Faktor X gibt die Anzahl der Pixel pro Messpunkt an
			if (m_XPixel==0) 
				m_XPixel=1;

			FaktorX=m_XPixel;//((rect.right-rect.left)/150);
		  FaktorY=((rect.bottom-rect.top)/(*pMaxAmplitude)/Teiler);
	    int i=0;
			INT Sprung=0;
			if (FaktorX<1) Sprung=(INT)(1/FaktorX);
			else Sprung=1;
			m_ViewPtArray.SetSize((INT)(MaxZeit/Sprung)+1);

			while (i<MaxZeit)
	    {
		    Messpunkt.x=(LONG)(i*FaktorX);
	      Messpunkt.y=(LONG)((*pMaxAmplitude-pZeitreiheArray->GetAt(i))*FaktorY);
//				m_ViewPtArray.Add(Messpunkt);
				m_ViewPtArray[i/Sprung]=Messpunkt;
				i+=Sprung;
			}
		}
	}

	//Scrollschienen neu skalieren
	CSize sizeTotal;
	sizeTotal.cx=(LONG)(pZeitreiheArray->GetSize()*FaktorX); //rect.Width();
	sizeTotal.cy=(rect.bottom-rect.top);
	SetScrollSizes(MM_TEXT,sizeTotal);

	POINT Anfangspunkt;

	//Zeitreihe zeichnen  
  pDC->SelectObject(&KurvenStift);
	if (m_ViewPtArray.GetSize()>1) 
	{
		Anfangspunkt=m_ViewPtArray[0];
    pDC->MoveTo(Anfangspunkt);
    INT i=1;
    while (i < (m_ViewPtArray.GetSize()-2))
    {
      POINT NextPunkt=m_ViewPtArray[i];
      pDC->LineTo(NextPunkt.x,m_ViewPtArray[i-1].y);
      pDC->LineTo(NextPunkt);
      i++;
    }
	}

	// Koordinatensystem zeichnen
  pDC->SelectObject(&KoordinatensystemStift);
	pDC->MoveTo(0,rect.bottom/2);
	pDC->LineTo(sizeTotal.cx,rect.bottom/2);
}

void CZeitreiheView::ResetArray(CArray<POINT,POINT>* pArray)
{ 
	pArray->RemoveAll();
	POINT Nullpunkt;
	Nullpunkt.x=0;
	Nullpunkt.y=0;
	pArray->Add(Nullpunkt);
}

void CZeitreiheView::ZeichneAutokorrelationsfunktion(CDC* pDC) 
{
	CSoundsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	INT* pBitRate=pDoc->GetBitRate();
	BOOL* pSigned=pDoc->GetSigned();
	CArray<DBLArray*,DBLArray*>* pAutokorrArray=pDoc->GetAutoKorrArray();
	
	//Check length of First Autokorrelationfunction 
	INT AutoKorrArrayLength=pAutokorrArray->GetAt(0)->GetSize();

	ControlPixel(AutoKorrArrayLength);

	//If there are enough points to display, then draw list of autokorrelationfunctions,
	// else calculate again
	if (AutoKorrArrayLength<=10&&(g_bIsCapturing||g_bIsPlayingWave||g_bIsPutPoints)) 
		pDoc->CalcAllAutoKorrelationFunctions(m_KorrCount);

	if (AutoKorrArrayLength>10) 
	{
	
		DOUBLE MaxZeit=AutoKorrArrayLength-1;
		INT Teiler=0;
		if (*pSigned)
			Teiler=2;
		else
			Teiler=1;
	
		//Set Drawing Functions and Erase ClientScreen
		CRect rect;
		GetClientRect(rect);
		CPen KurvenStift;
	  KurvenStift.CreatePen(PS_SOLID,1,m_clrKurve);
		CPen KoordinatensystemStift;
	  KoordinatensystemStift.CreatePen(PS_SOLID,1,m_clrKoords);
	
		pDC->SetTextColor(m_clrText);
		pDC->FillSolidRect(rect,m_clrBkg);

		INT HeightofEachFunction=(INT)(rect.bottom/(FLOAT)m_KorrCount);

		
		DOUBLE FaktorX=0,FaktorY=0;
		INT Sprung=0;
	  if (AutoKorrArrayLength>1)
		{
			m_ViewPtAutoKorrArray.RemoveAll();
		  //View Array fr Autokorrelationsfunktion neu skalieren
			POINT Messpunkt;
				
			//Faktor X gibt die Anzahl der Pixel pro Messpunkt an, 
			if (m_XPixel==0) 
				m_XPixel=1;
			FaktorX=m_XPixel;


			if (FaktorX<1) Sprung=(INT)(1/FaktorX);
			else Sprung=1;

			m_ViewPtAutoKorrArray.SetSize((INT)((MaxZeit/Sprung)*m_KorrCount)+1);

/*			//determine max amplitude from autokorrelation array
			double MaxAutoKorrAmplitude=0;
			for (int w=0;w<m_KorrCount; w++)
			{
				for (int z=0;z<AutoKorrArrayLength; z++)
				{
					if (fabs(pAutokorrArray->GetAt(w)->GetAt(z))>MaxAutoKorrAmplitude) 
						MaxAutoKorrAmplitude=fabs(pAutokorrArray->GetAt(w)->GetAt(z));
				}
			}
			FaktorY=((HeightofEachFunction)/(MaxAutoKorrAmplitude)/Teiler);
*/
			for (int j=0;j<m_KorrCount; j++)
			{

			  INT i=0;
				//determine max amplitude from autokorrelation array
				double MaxAutoKorrAmplitude=0;
 				for (int z=0;z<AutoKorrArrayLength; z++)
				{
					if (fabs(pAutokorrArray->GetAt(j)->GetAt(z))>MaxAutoKorrAmplitude) 
						MaxAutoKorrAmplitude=fabs(pAutokorrArray->GetAt(j)->GetAt(z));
				}
				FaktorY=((HeightofEachFunction)/(MaxAutoKorrAmplitude)/Teiler);

				while (i<MaxZeit)
		    {
			    Messpunkt.x=(LONG)(i*FaktorX);
					DOUBLE yWert=pAutokorrArray->GetAt(j)->GetAt(i);
		      Messpunkt.y=HeightofEachFunction*j+(LONG)((MaxAutoKorrAmplitude-yWert)*FaktorY);
					m_ViewPtAutoKorrArray.SetAt(i/Sprung+j*MaxZeit/Sprung,Messpunkt);

					//					m_ViewPtAutoKorrArray.GetAt(i/Sprung*j)=Messpunkt;
					i+=Sprung;
			  }
//				i=0;
			}
		}
	
		//Scrollschienen neu skalieren	
		CSize sizeTotal;
		sizeTotal.cx=(LONG)(AutoKorrArrayLength*FaktorX);
		sizeTotal.cy=rect.bottom;
		SetScrollSizes(MM_TEXT,sizeTotal);

		POINT Anfangspunkt;
	
		//Autokorrelationsfunktionen zeichnen  
		if (m_ViewPtAutoKorrArray.GetSize()>1) 
		{
			for (int j=0;j<m_KorrCount; j++)
			{
				pDC->SelectObject(&KurvenStift);
				Anfangspunkt=m_ViewPtAutoKorrArray.GetAt(j*MaxZeit/Sprung);
		    pDC->MoveTo(Anfangspunkt);
			  INT i=j*MaxZeit/Sprung+1;
				while (i < (m_ViewPtAutoKorrArray.GetSize()-(m_KorrCount-j-1)*MaxZeit/Sprung)-2)
		    {
		      POINT NextPunkt=m_ViewPtAutoKorrArray.GetAt(i);
			    pDC->LineTo(NextPunkt.x,m_ViewPtAutoKorrArray.GetAt(i-1).y);
				  pDC->LineTo(NextPunkt);
					i++;
		    }
				// Koordinatensystem zeichnen
			  pDC->SelectObject(&KoordinatensystemStift);
				LONG MiddleLineHeight=HeightofEachFunction*j+HeightofEachFunction/2;
				pDC->MoveTo(0,MiddleLineHeight);
				pDC->LineTo(sizeTotal.cx,MiddleLineHeight);
			}
		}
	}
}
	
	
void CZeitreiheView::OnEditClearall() 
{
	CPoint Nullpunkt;
	Nullpunkt.x=0;
	Nullpunkt.y=0;
  m_ViewPtArray.RemoveAll();
	m_ViewPtArray.Add(Nullpunkt);
	CSoundsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->DeleteContents();
	Invalidate(TRUE);
}


BOOL CZeitreiheView::OnEraseBkgnd(CDC* pDC) 
{
//	CRect rect;
//	GetClientRect(rect);
//	pDC->FillSolidRect(rect,m_clrBkg);
	return FALSE;
}

void CZeitreiheView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	if (g_bIsCapturing||g_bIsPlayingWave||g_bIsPutPoints) //lHint==50||
	{
		if (m_WhatIs==1) 
		{
			CSoundsDoc* pDoc = GetDocument();
			ASSERT_VALID(pDoc);
			pDoc->CalcAllAutoKorrelationFunctions(m_KorrCount);
		}
		Invalidate(TRUE);
	}
	if (lHint==11) 
	{
		m_ViewPtArray.RemoveAll();
		m_ViewPtAutoKorrArray.RemoveAll();
		m_ViewPtMutualArray.RemoveAll();
		Invalidate(TRUE);
	}							
}

void CZeitreiheView::OnCheckZeitreihe() 
{
	m_WhatIs=0;
	SwitchDlgWindows();
	Invalidate(TRUE);
}

void CZeitreiheView::OnCheckAutokorr() 
{
	m_WhatIs=1;
	SwitchDlgWindows();
	Invalidate(TRUE);
}

void CZeitreiheView::OnCheckMutual() 
{
	m_WhatIs=2;
	SwitchDlgWindows();
	Invalidate(TRUE);
}


void CZeitreiheView::OnReleasedcaptureSliderZoomh(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CSliderCtrl* SliderVOverviewCtrl=(CSliderCtrl*)m_pParentZeitreiheFrame->m_wndDlgBar.GetDlgItem(IDC_SLIDER_ZOOMH);
	INT Stelle=SliderVOverviewCtrl->GetPos();
	if (Stelle>0) 
		m_XPixel=Stelle;
	else
		if (Stelle==0) 
			m_XPixel=1;
		else
			m_XPixel=1/fabs(Stelle);
	Invalidate(TRUE);
	*pResult = 0;
}

void CZeitreiheView::OnChangePartitionFeld() 
{
	m_partitions=m_pParentZeitreiheFrame->m_wndDlgBar.GetDlgItemInt(IDC_PARTITION_FELD);
	Invalidate(TRUE);
}

void CZeitreiheView::OnChangeMaxtauFeld() 
{
	m_corrlength=m_pParentZeitreiheFrame->m_wndDlgBar.GetDlgItemInt(IDC_MAXTAU_FELD);
	Invalidate(TRUE);
}

void CZeitreiheView::OnChangeEditKorr() 
{
	CSoundsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	m_KorrCount=m_pParentZeitreiheFrame->m_wndDlgBar.GetDlgItemInt(IDC_EDIT_KORR);
	if (pDoc->GetZeitreiheArray()->GetSize()>10)
		pDoc->CalcAllAutoKorrelationFunctions(m_KorrCount);
	IniFileWrite();	
	Invalidate(TRUE);
}


double CZeitreiheView::make_cond_entropy(long t,unsigned long	length,long* h1, long* h11, long** h2,long* array)
{
	long i;
  long j,hi,hii,count=0;
  double hpi,hpj,pij,cond_ent=0.0,norm;

  for (i=0;i<m_partitions;i++) 
	{
    h1[i]=h11[i]=0;
    for (j=0;j<m_partitions;j++)
      h2[i][j]=0;
  }
  for (i=0;i<(LONG)length;i++)
    if (i >= t) 
		{
      hii=array[i];
      hi=array[i-t];
      h1[hi]++;
      h11[hii]++;
      h2[hi][hii]++;
      count++;
    }

  norm=1.0/(double)count;
  cond_ent=0.0;

  for (i=0;i<m_partitions;i++) 
	{
    hpi=(double)(h1[i])*norm;
    if (hpi > 0.0) {
      for (j=0;j<m_partitions;j++) 
			{
				hpj=(double)(h11[j])*norm;
				if (hpj > 0.0) 
				{
				  pij=(double)h2[i][j]*norm;
				  if (pij > 0.0)
						cond_ent += pij*log(pij/hpj/hpi);
				}
      }
    }
  }

  return cond_ent;
}


void CZeitreiheView::ZeichneMutualInformation(CDC* pDC,BOOL bWriteToClipboard,CString* pAusgabe)
{
	long *array,*h1,*h11,**h2;
	unsigned long	length=0;

  char stdi=0;
  long tau,i;
  double min,interval;
//  FILE *file;
  
	CLyapunovKantz LyaKantz;
	CSoundsDoc* pDoc=GetDocument();
	CArray<DOUBLE,DOUBLE>* pZeitreiheArray=pDoc->GetZeitreiheArray();
	CArray<DOUBLE,DOUBLE> ZeitreiheArray;
	ZeitreiheArray.Copy(*pZeitreiheArray);
	int numberPts=ZeitreiheArray.GetSize();
	if (numberPts>100) 
	{
		double* DATA;
		DATA=ZeitreiheArray.GetData();
		length=ZeitreiheArray.GetSize();
	  LyaKantz.rescale_data(DATA,length,&min,&interval);	

	
	  LyaKantz.check_alloc(h1=(long *)malloc(sizeof(long)*m_partitions));
	  LyaKantz.check_alloc(h11=(long *)malloc(sizeof(long)*m_partitions));
	  LyaKantz.check_alloc(h2=(long **)malloc(sizeof(long *)*m_partitions));
	  for (i=0;i<m_partitions;i++) 
	    LyaKantz.check_alloc(h2[i]=(long *)malloc(sizeof(long)*m_partitions));
		LyaKantz.check_alloc(array=(long *)malloc(sizeof(long)*length));
	  for (i=0;i<(LONG)length;i++)
	    if (DATA[i] < 1.0)
	      array[i]=(long)(DATA[i]*(double)m_partitions);
	    else
	      array[i]=m_partitions-1;
	
	//	free(DATA);
		ZeitreiheArray.RemoveAll();
	
		double* Mutuals;
		Mutuals=(double*)malloc(sizeof(double)*(m_corrlength+1));
	
	  Mutuals[0]=make_cond_entropy(0,length,h1,h11,h2,array);
	  if (m_corrlength >= (LONG)length)
	    m_corrlength=length-1;
	
	
//		file=fopen("d:\\AdrianBauernhaus\\Testfiles\\Mutual.txt","w");
//		fprintf(file,"#shannon= %e\n",Mutuals[0]);
//	  fprintf(file,"%d %e\n",0,Mutuals[0]);

		CString strX,strY;
		char buffer[30];
	
		double MaxData=0;
	  for (tau=1;tau<=m_corrlength;tau++) 
		{
			Mutuals[tau]=make_cond_entropy(tau,length,h1,h11,h2,array);
//	    fprintf(file,"%ld %e\n",tau,Mutuals[tau]);
//	    fflush(file);
			if (Mutuals[tau]>MaxData) MaxData=Mutuals[tau];
	  }
//	  fclose(file);
	
		free(h1);
		free(h11);
	  for (i=0;i<m_partitions;i++) 
	    free(h2[i]);
		free(h2);
		free(array);

		//Zeichnen
		CRect rect;
		GetClientRect(rect);
		CPen KurvenStift;	
	  KurvenStift.CreatePen(PS_SOLID,1,m_clrKurve);
		CPen KoordinatensystemStift;
	  KoordinatensystemStift.CreatePen(PS_SOLID,1,m_clrKoords);
		pDC->FillSolidRect(rect,m_clrBkg);
		pDC->SetTextColor(m_clrText);

		//View Array neu skalieren
		DOUBLE FaktorX=0,FaktorY=0;
		{
		  if (m_corrlength>1)
			{
				m_ViewPtMutualArray.RemoveAll();
				POINT Messpunkt;
			
				//Faktor X gibt die Anzahl der Pixel pro Messpunkt an, 
				FaktorX=4;//m_XPixel;
			  FaktorY=rect.bottom/MaxData;
		    int i=0;
			  while (i<=m_corrlength)
		    {
					if (bWriteToClipboard)
					{
						strX=IntToStr(i);

						strY=gcvt( Mutuals[i], 10, buffer);
//						strY=strY.Left(strY.Find(".")+5); 
						strY.Replace(".",",");
						*pAusgabe+=strX+_T("\t")+strY+_T("\r\n");
					}
					Messpunkt.x=(LONG)(i*FaktorX);
		      Messpunkt.y=(LONG)((MaxData-Mutuals[i])*FaktorY);
					m_ViewPtMutualArray.Add(Messpunkt);
					i++;
			  }
			}
		
		}
		i=0;
		INT FirstMinimum;
		while (Mutuals[i]>Mutuals[i+1]) 
		{
			FirstMinimum=i;
			if (i==m_corrlength)
			{
				FirstMinimum=0;
				break;
			}
			i++;
		}

		//Scrollschienen neu skalieren
		CSize sizeTotal;
		sizeTotal.cx=(LONG)(m_corrlength*FaktorX);
		sizeTotal.cy=rect.bottom;
		SetScrollSizes(MM_TEXT,sizeTotal);

		POINT Anfangspunkt;

		//Zeitreihe zeichnen  
	  pDC->SelectObject(&KurvenStift);
		if (m_ViewPtMutualArray.GetSize()>1) 
		{
			Anfangspunkt=m_ViewPtMutualArray[0];
	    pDC->MoveTo(Anfangspunkt);
			INT i=1;
	    while (i <= (m_ViewPtMutualArray.GetSize()-1))
			{
		    POINT NextPunkt=m_ViewPtMutualArray[i];
	      pDC->LineTo(NextPunkt.x,m_ViewPtMutualArray[i-1].y);
				pDC->LineTo(NextPunkt);
			  i++;
		  }
		}

		// Koordinatensystem zeichnen
	  pDC->SelectObject(&KoordinatensystemStift);
		pDC->MoveTo(0,rect.bottom/2);
		pDC->LineTo(sizeTotal.cx,rect.bottom/2);

		CAutoFont font("Arial");
		font.SetDC(pDC->GetSafeHdc());
		font.SetHeight(16);
		font.SetFontColor(m_clrText);
		font.SetEscapement(0);
		font.SetOrientation(0);
		pDC->SelectObject(&font);

		int dec;
		int sign;
		CString strShannon=ecvt(Mutuals[0],10, &dec,&sign );
		if (dec<=0) 
			for(int z=0;z<=abs(dec);z++) strShannon.Insert(0,'0');
		if (dec<=0) 
			strShannon.Insert(1,'.');
		else 
			strShannon.Insert(dec,'.');
		if (sign!=0) strShannon.Insert(0,'-');
		
		CString Wert=strShannon.Left(6);
		Wert.Replace(".",",");
		if (bWriteToClipboard) *pAusgabe+=_T("Shannon Entropie:\t")+Wert+_T("\r\n");

		strShannon="Shannon Entropie: "+ strShannon.Left(6);


		pDC->DrawText(strShannon,rect,DT_TOP|DT_CENTER);

		CString strFirstMinimum;
		strFirstMinimum=itoa( FirstMinimum, buffer, 10 );
		if (FirstMinimum==0) strFirstMinimum.LoadString(IDS_NOTFOUND);
		strFirstMinimum="1.Minimum: "+strFirstMinimum+" ";
		pDC->DrawText(strFirstMinimum,rect,DT_BOTTOM|DT_RIGHT);
		free(Mutuals);
	}
}

CRect CZeitreiheView::DetermineRect(CDC* RefDC)
{
	// Determine the picture frame dimensions. 
	// iWidthMM is the display width in millimeters. 
	// iHeightMM is the display height in millimeters. 
	// iWidthPels is the display width in pixels. 
	// iHeightPels is the display height in pixels 
 
	INT iWidthMM = GetDeviceCaps(RefDC->GetSafeHdc(), HORZSIZE); 
	INT iHeightMM = GetDeviceCaps(RefDC->GetSafeHdc(), VERTSIZE); 
	INT iWidthPels = GetDeviceCaps(RefDC->GetSafeHdc(), HORZRES); 
	INT iHeightPels = GetDeviceCaps(RefDC->GetSafeHdc(), VERTRES); 
 
	// Retrieve the coordinates of the client rectangle, in pixels. 
	CRect rect;
	GetClientRect(rect); 

	CSize size=GetTotalSize();
	rect.right=MAX(size.cx,rect.right);
	rect.bottom=MAX(size.cy,rect.bottom);
 
	// Convert client coordinates to .01-mm units. 
	// Use iWidthMM, iWidthPels, iHeightMM, and 
	// iHeightPels to determine the number of 
	// .01-millimeter units per pixel in the x- 
	//  and y-directions. 
 
	rect.left = (rect.left * iWidthMM * 100)/iWidthPels; 
	rect.top = (rect.top * iHeightMM * 100)/iHeightPels; 
	rect.right = (rect.right * iWidthMM * 100)/iWidthPels; 
	rect.bottom = (rect.bottom * iHeightMM * 100)/iHeightPels; 

	return rect;
}

void CZeitreiheView::OnSave() 
{
	// Obtain a handle to a reference device context. 
	CDC* RefDC = GetDC(); 
 
	CRect rect=DetermineRect(RefDC);

	// Load the filename Dialog
	CFileDialog SaveZeitreiheFileDlg(FALSE,NULL,NULL,OFN_OVERWRITEPROMPT|OFN_NOREADONLYRETURN|OFN_ENABLESIZING,\
              "WMF - Enhanced Metafile|*.wmf|");
  SaveZeitreiheFileDlg.m_ofn.nFilterIndex=1;
	SaveZeitreiheFileDlg.m_ofn.lpstrDefExt=".wmf";
	CString Text;
	Text.LoadString(IDS_SAVE_ZEITREIHE);
	SaveZeitreiheFileDlg.m_ofn.lpstrTitle=Text.GetBuffer(Text.GetLength());
  if (SaveZeitreiheFileDlg.DoModal()==IDOK) 
	{
		BeginWaitCursor();

		// Create the metafile device context. 
		CString Pfad=SaveZeitreiheFileDlg.GetPathName();
		LPTSTR strFileName=Pfad.GetBuffer(MAX_PATH);
		CMetaFileDC MetaFileDC;
		MetaFileDC.CreateEnhanced(RefDC,strFileName,rect,"SOUNDS Soundanalyse\0Zeitreihe Abbild\0\0");

		m_clrText=RGB(0,0,0);
		m_clrBkg=RGB(255,255,255);
		m_clrKoords=RGB(0,0,0);
		OnDraw(&MetaFileDC);
		HENHMETAFILE pMetaFile=MetaFileDC.CloseEnhanced();
		DeleteEnhMetaFile(pMetaFile);
		m_clrText=RGB(255,255,255);
		m_clrBkg=RGB(0,0,0);
		m_clrKoords=RGB(255,255,255);

		//Alten Cursor zurcksetzen
		EndWaitCursor();

	}
	// Release the reference device context. 
	ReleaseDC(RefDC); 	
}

void CZeitreiheView::OnEditCopy() 
{
	BeginWaitCursor();

	CDC* RefDC = GetDC(); 
	CRect rect=DetermineRect(RefDC);

	CMetaFileDC * pMetaDC = new CMetaFileDC();
	pMetaDC->CreateEnhanced(GetDC(),NULL,NULL,"SOUNDS Soundanalyse\0Analyse Abbild\0\0");
	//draw meta file
	m_clrText=RGB(0,0,0);
	m_clrBkg=RGB(255,255,255);
	m_clrKoords=RGB(0,0,0);

	OnDraw(pMetaDC);

	//close meta file dc and prepare for clipboard;
	HENHMETAFILE hMF = pMetaDC->CloseEnhanced();

	//copy to clipboard
	// Open the clipboard...
	if(!OpenClipboard()) 
	{
    AfxMessageBox(IDS_OPEN_CLIPBOARD_FAIL);
    return;
	}
	EmptyClipboard();
	::SetClipboardData(CF_ENHMETAFILE,hMF);
	CloseClipboard();
	//DeleteMetaFile(hMF);
	delete pMetaDC;

	m_clrText=RGB(255,255,255);
	m_clrBkg=RGB(0,0,0);
	m_clrKoords=RGB(255,255,255);

	//Alten Cursor zurcksetzen
	EndWaitCursor();
}



BOOL CZeitreiheView::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	CSoundsDoc* pDoc=GetDocument();
	pDoc->m_help.SetHelpFile(pDoc->m_strHelpFile);
	pDoc->m_help.DisplayTopic("html/Zeitreihendarstellung.html");
	
	return CScrollView::OnHelpInfo(pHelpInfo);
}

void CZeitreiheView::OnExportdata() 
{
	if (!g_bIsPlayingWave||g_bIsCapturing) 
	{
	BeginWaitCursor();

	//Daten berechnen aus Arrays und als Tabulator getrennte Werte in CString schreiben
	CString Ausgabe;
	char buffer[30];
	CString strX;
	CString strY;
	CSoundsDoc* pDoc=GetDocument();
	CArray<DOUBLE,DOUBLE>* pZeitreiheArray=pDoc->GetZeitreiheArray();
	INT MaxZeit=pZeitreiheArray->GetSize();
	CArray<DOUBLE,DOUBLE>* pAutokorrArray=pDoc->GetAutoKorrArray()->GetAt(0);
	INT MaxZeitAuto=pZeitreiheArray->GetSize();

	INT SamplingRate=*pDoc->GetSampleRate();
	INT MaxAmplitude=*pDoc->GetMaxAmplitude();
	INT i=0;
	switch(m_WhatIs) 
	{
	case 0:
		//1.Zeile schreiben
		
		Ausgabe.LoadString(IDS_EXPORT_ZEITREIHE1);
		for	(i=0; i<MaxZeit;i++)
		{
			DOUBLE Peak=pZeitreiheArray->GetAt(i);
			DOUBLE xWert=i/(FLOAT)SamplingRate*1000;
			DOUBLE Pegel=Peak/MaxAmplitude*100; //in Prozent
			strX=gcvt( xWert, 10, buffer);
//			strX=strX.Left(strX.Find(".")+5); 
	    strX.Replace(".",",");
			strY=gcvt( Pegel, 10, buffer);
//			strY=strY.Left(strY.Find(".")+5); 
	    strY.Replace(".",",");
			Ausgabe+=strX+_T("\t")+strY+_T("\r\n");
		}
		break;
	case 1:
		//1.Zeile schreiben
		Ausgabe.LoadString(IDS_EXPORT_ZEITREIHE1);
		for	(i=0; i<MaxZeitAuto;i++)
		{
			DOUBLE Peak=pAutokorrArray->GetAt(i);
			DOUBLE xWert=i/(FLOAT)SamplingRate*1000;
			DOUBLE Pegel=Peak/MaxAmplitude*100; //in Prozent
			strX=gcvt( xWert, 10, buffer);
//			strX=strX.Left(strX.Find(".")+5); 
	    strX.Replace(".",",");
			strY=gcvt( Pegel, 10, buffer);
//			strY=strY.Left(strY.Find(".")+5); 
	    strY.Replace(".",",");
			Ausgabe+=strX+_T("\t")+strY+_T("\r\n");
		}
		break;
	case 2:
		//1.Zeile schreiben
		Ausgabe.LoadString(IDS_EXPORT_ZEITREIHE2);
		Ausgabe+=IntToStr(m_partitions);
		Ausgabe+=_T("\r\n");
		Ausgabe+=_T("Delay-Parameter Tau\tMutual Information\r\n");
		ZeichneMutualInformation(GetDC(),TRUE,&Ausgabe);
	}
	
	// Open the clipboard...
	if(!OpenClipboard()) 
	{
    AfxMessageBox(IDS_OPEN_CLIPBOARD_FAIL);
    return;
	}

	// Empty anything already there...
	EmptyClipboard();


	// Allocate global memory for transfer...
	HGLOBAL hText = GlobalAlloc(GMEM_MOVEABLE |GMEM_DDESHARE, strlen(Ausgabe)+4);

	// Put our string in the global memory...
	char* ptr = (char *)GlobalLock(hText);
	strcpy(ptr, Ausgabe);
	GlobalUnlock(hText);

	// Put data on the clipboard as CF_TEXT
	::SetClipboardData(CF_TEXT, hText);

	// Free memory...
	GlobalFree(hText);

	// Close clipboard...
	CloseClipboard();

	AfxMessageBox(IDS_ZEITREIHEVIEW_ONEXPORTDATA,MB_ICONINFORMATION);
	EndWaitCursor();
	}

}


