/////////////////////////////////////////////////////////////////////////////
// $Header: /cvsroot/mmconvert/mmconvert/MMConvert/Src/Common/helper.cpp,v 1.10 2005/09/08 09:43:18 ping235 Exp $
//
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2005 ping235.  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//  This file is subject to the terms of the GNU General Public License as
//  published by the Free Software Foundation.  A copy of this license is
//  included with this software distribution in the file COPYING.  If you
//  do not have a copy, you may obtain a copy by writing to the Free
//  Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  This software is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
// Change Log
//
// Date          Developer             Changes
// $Date: 2005/09/08 09:43:18 $        $Author: ping235 $              $Name:  $
//
/////////////////////////////////////////////////////////////////////////////
// CVS Log
// $Log: helper.cpp,v $
// Revision 1.10  2005/09/08 09:43:18  ping235
// translate MMConvert into english
//
// Revision 1.9  2005/09/07 10:56:27  ping235
// fixed controls blink when resizing main dialog
//
// Revision 1.8  2005/09/07 03:58:47  ping235
// impoved UI:avoid XPTaskPane's blink when resizing
//
// Revision 1.7  2005/09/05 01:24:57  ping235
// improvement in interactant of UI
// fixed error:lost call OnConvertEnd when exception
// changed status info to the last pane of the status bar
// added overall progress(current count/entired count) functional
// translate unknown exception message to localize language
//
// Revision 1.6  2005/08/09 09:52:58  ping235
// modify to obtain about version info dynamiclly from resource
//
// Revision 1.5  2005/08/09 06:45:42  ping235
// modified about dialog
//
// Revision 1.4  2005/08/08 09:01:15  ping235
// add file dialog filter and default output path
//
// Revision 1.3  2005/08/06 10:25:11  ping235
// add CConvertGUI and convert progress
//
// Revision 1.2  2005/08/05 08:33:54  ping235
// added tasklistctrl to bind CListCtrl and CTaskList
// add common task property management
//
// Revision 1.1.1.1  2005/08/02 05:17:19  ping235
// initial,GUI 1.0.0.0,CMD 1.3.0.1
//
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include ".\helper.h"
#include <shlwapi.h>


CString IntToStr(int n)
{
	CString str;
	str.Format(_T("%d"),n);
	return str;
}

CString UIntToStr(UINT u)
{
	CString str;
	str.Format(_T("%u"),u);
	return str;
}

CString IntToHex(DWORD dw)
{
	CString str;
	str.Format(_T("%08X"),dw);
	return str;
}

CString WordToHex(WORD w)
{
	CString str;
	str.Format(_T("%04X"),w);
	return str;
}

CString ByteToHex(BYTE by)
{
	CString str;
	str.Format(_T("%02X"),by);
	return str;
}

CString Int64ToStr(LONGLONG i64)
{
	TCHAR buf[256]={0};
	_i64tot(i64,buf,10);
	return buf;
}

CString FloatToStr(double f)
{
	CString str;
	str.Format(_T("%f"),f);
	return str;
}

void ShutdownComputer()
{
/*	//Adjust System Right
	OSVERSIONINFO osv; 
	osv.dwOSVersionInfoSize=sizeof(OSVERSIONINFO); 
	GetVersionEx(&osv); 
	if(osv.dwPlatformId==VER_PLATFORM_WIN32_NT) 
	{ 
		HANDLE hProcess,hToken; 
		TOKEN_PRIVILEGES Privileges; 
		LUID luid; 
		hProcess=GetCurrentProcess(); 
		OpenProcessToken(hProcess,TOKEN_ADJUST_PRIVILEGES,&hToken); 
		Privileges.PrivilegeCount=1; 
		LookupPrivilegeValue(NULL,SE_SHUTDOWN_NAME,&luid); 
		Privileges.Privileges[0].Luid=luid; 
		Privileges.Privileges[0].Attributes=SE_PRIVILEGE_ENABLED; 
		AdjustTokenPrivileges(hToken,FALSE,&Privileges,NULL,NULL,NULL); 
		
		//NT 3.51 ,NT 4.0
		if(osv.dwMajorVersion <= 4)
			ExitWindowsEx(EWX_SHUTDOWN,0);
		//Win2000,WinXP,Win2003
		else
			ExitWindowsEx(EWX_SHUTDOWN|EWX_POWEROFF|EWX_FORCEIFHUNG,0);
	}
	//Win9x,ME
	else
	{
		ExitWindowsEx(EWX_SHUTDOWN,0);
	}
*/
}

DWORD GetIntervalTime(DWORD dw1)
{
	DWORD dw2 = GetTickCount();
	if(dw2>=dw1)
	{
		return dw2-dw1;
	}
	else
	{
		return 0xFFFFFFFF-dw1+dw2;
	}
}

//
CString ParseString(CString strInput,char chDiv,UINT uIndex)
{
	CString strLeft,strRight=strInput;

	for(UINT i=0;i<=uIndex;i++)
	{
		UINT uPosOfDiv=strRight.Find(chDiv);	//position of div
		if(uPosOfDiv!=-1)
		{
			strLeft=strRight.Left(uPosOfDiv);
			strRight=strRight.Mid(uPosOfDiv+1);
		}
		else
		{
			strLeft=strRight;
			strRight="";
		}
	}

	return strLeft;
}

//parse string,return part after specified index,such as input "134\54\6",'\',1,return '6'
CString ParseStringRight(CString strInput,TCHAR chDiv,UINT uIndex)
{
	CString strLeft,strRight=strInput;

	for(UINT i=0;i<=uIndex;i++)
	{
		UINT uPosOfDiv=strRight.Find(chDiv);	//position of div
		if(uPosOfDiv!=-1)
		{
			strLeft=strRight.Left(uPosOfDiv);
			strRight=strRight.Mid(uPosOfDiv+1);
		}
		else
		{
			strLeft=strRight;
			strRight=_T("");
		}
	}

	return strRight;
}

//find substr with case insensitively
int FindSubStr(CString str,CString strSubStr)
{
	str.MakeLower();
	return str.Find(strSubStr);
}

//return Application's path with backsplash end
CString GetAppPath()
{
	static CString strRes = _T("");
	
	if(strRes.IsEmpty())
	{
		//get module file name
		TCHAR* psz = strRes.GetBufferSetLength(_MAX_PATH);
		if(::GetModuleFileName(NULL,psz,_MAX_PATH) != 0)
		{
			::PathRemoveFileSpec(psz);
			::PathAddBackslash(psz);
			strRes.ReleaseBuffer();
		}
	}

	return strRes;
}

//get application path name
CString GetAppPathName()
{
	TCHAR szPath[_MAX_PATH];
	::GetModuleFileName(::GetModuleHandle(NULL),szPath,_MAX_PATH);
	return szPath;
}

//get application name
CString GetAppName()
{
	TCHAR szPath[_MAX_PATH];
	::GetModuleFileName(::GetModuleHandle(NULL),szPath,_MAX_PATH);
	int nPos=CString(szPath).ReverseFind('\\');
	if(nPos<0||nPos==int(_tcslen(szPath)-1))
		return _T("");
	else
	{
		szPath[_tcslen(szPath)-4]=0;
		return ((TCHAR*)&szPath[nPos+1]);
	}
}

//resolve relative path to absolute path
CString PathResolve(CString strPath)
{
	if(::PathIsRelative(strPath))
	{
		TCHAR tsDir[_MAX_PATH+1];
		::GetCurrentDirectory(_MAX_PATH+1,tsDir);
		::PathAddBackslash(tsDir);
		
		TCHAR tsRes[_MAX_PATH+1] = {0};
		::PathCanonicalize(tsRes,tsDir+strPath);
		
		return tsRes;
	}
	else
		return strPath;
}

CString FormatTimeSpan(DWORD dwTickCount)
{
	COleDateTimeSpan span(dwTickCount/3600000.0/24.0);
	if(span.GetDays()!=0)
        return span.Format(_T("%D days %H h %M min %S sec"));
	else if(span.GetHours()!=0)
		return span.Format(_T("%H h %M min %S sec"));
	else if(span.GetMinutes()!=0)
		return span.Format(_T("%M min %S sec"));
	else if(span.GetSeconds()!=0)
		return span.Format(_T("%S sec"));
	else if(dwTickCount!=0)
	{
		CString str;
		str.Format(_T("%d msec"),dwTickCount);
		return str;
	}
	else
		return _T("0 sec");
}

//load string by resid from resource
CString IDToStr(int nID)
{
	CString str;
	str.LoadString(nID);
	return str;
}

//load string by resid from resource
CString IDToStrV(int nID,...)
{
	CString str;
	va_list pArg;

	va_start(pArg, nID);
	str.FormatV(IDToStr(nID),pArg);
	va_end(pArg);

	return str;
}

//draw gradient
void DrawGradient(CDC* pDC,COLORREF clrBegin,COLORREF clrEnd,CRect rc,bool bVert)
{
	TRIVERTEX vertex[2];
	vertex[0].Red = UINT(GetRValue(clrBegin))<<8;
	vertex[0].Green = UINT(GetGValue(clrBegin))<<8;
	vertex[0].Blue = UINT(GetBValue(clrBegin))<<8;
	vertex[0].Alpha = 0;
	vertex[0].x = rc.left;
	vertex[0].y = rc.top;
	vertex[1].Red = UINT(GetRValue(clrEnd))<<8;
	vertex[1].Green = UINT(GetGValue(clrEnd))<<8;
	vertex[1].Blue = UINT(GetBValue(clrEnd))<<8;
	vertex[1].Alpha = 0;
	vertex[1].x = rc.right;
	vertex[1].y = rc.bottom;

	GRADIENT_RECT gr;
	gr.UpperLeft = 0;
	gr.LowerRight = 1;
//	pDC->GradientFill(vertex,2,&gr,1,bVert?GRADIENT_FILL_RECT_V:GRADIENT_FILL_RECT_H);
}

void DrawGradient(CDC* pDC,COLORREF clr1,COLORREF clr2,COLORREF clr3,const CPoint& pt1,const CPoint& pt2,const CPoint& pt3)
{
	TRIVERTEX vertex[3];
	vertex[0].Red = UINT(GetRValue(clr1))<<8;
	vertex[0].Green = UINT(GetGValue(clr1))<<8;
	vertex[0].Blue = UINT(GetBValue(clr1))<<8;
	vertex[0].Alpha = 0;
	vertex[0].x = pt1.x;
	vertex[0].y = pt1.y;

	vertex[1].Red = UINT(GetRValue(clr2))<<8;
	vertex[1].Green = UINT(GetGValue(clr2))<<8;
	vertex[1].Blue = UINT(GetBValue(clr2))<<8;
	vertex[1].Alpha = 0;
	vertex[1].x = pt2.x;
	vertex[1].y = pt2.y;

	vertex[2].Red = UINT(GetRValue(clr3))<<8;
	vertex[2].Green = UINT(GetGValue(clr3))<<8;
	vertex[2].Blue = UINT(GetBValue(clr3))<<8;
	vertex[2].Alpha = 0;
	vertex[2].x = pt3.x;
	vertex[2].y = pt3.y;

	GRADIENT_TRIANGLE gt;
	gt.Vertex1 = 0;
	gt.Vertex2 = 1;
	gt.Vertex3 = 2;
//	pDC->GradientFill(vertex,3,&gt,1,GRADIENT_FILL_TRIANGLE);
	DWORD dw = ::GetLastError();
}

//create directory recursely
BOOL RecurseCreateDir(LPCTSTR lpszName)
{
	BOOL bRes = TRUE;
	//Create directory
	bRes = ::CreateDirectory(lpszName,NULL);
	if(!bRes)
	{
		if(::GetLastError()!=ERROR_ALREADY_EXISTS)
		{
			//copy and del lowest level dir
			TCHAR szParent[MAX_PATH];
			::_tcscpy(szParent,lpszName);
			::PathRemoveBackslash(szParent);
			::PathRemoveFileSpec(szParent);

			//create parent
			bRes = RecurseCreateDir(szParent);
			if(bRes)
			{
				//now create sub dir
				bRes = ::CreateDirectory(lpszName,NULL);
			}

		}
	}

	return bRes;
}	

//load icon from default resource as specified size
HICON LoadIconEx(int nID,CSize sz)
{
	return (HICON)LoadImage(AfxGetResourceHandle(),MAKEINTRESOURCE(nID),IMAGE_ICON,sz.cx,sz.cy,LR_DEFAULTCOLOR|LR_SHARED);
}

//pump messages, return FALSE if gotten WM_QUIT
BOOL ProcessMessage()
{
	BOOL bRes = TRUE;
	MSG msg;
	while(PeekMessage(&msg,NULL,0,0,FALSE))
	{
		if(msg.message != WM_QUIT)
		{
			PeekMessage(&msg,NULL,0,0,TRUE);
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		else
		{
			bRes = FALSE;
			break;
		}
	}

	return bRes;
}

//map coordinate from one window to another
void ClientToClient(CWnd* pwndTo,CWnd* pwndFrom,CRect& rc)
{
	ASSERT(pwndTo);
	ASSERT(pwndFrom);
	pwndFrom->ClientToScreen(rc);
	pwndTo->ScreenToClient(rc);
}

//map coordinate from one window to another
void ClientToClient(HWND hwndTo,HWND hwndFrom,CRect& rc)
{
	ASSERT(hwndTo);
	ASSERT(hwndFrom);
	CPoint pt1 = rc.TopLeft();
	CPoint pt2 = rc.BottomRight();
	ClientToScreen(hwndFrom,&pt1);
	ClientToScreen(hwndFrom,&pt2);
	ScreenToClient(hwndTo,&pt1);
	ScreenToClient(hwndTo,&pt2);
	rc.SetRect(pt1,pt2);
}
